VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls9858EVBD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "AD9858 Evaluation Board Class - Models the AD9858 Evaluation board."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'*******************************************************
'* Enums                                               *
'*******************************************************
Public Enum adiBinValues
    abvLow = 0
    abvHigh = 1
End Enum
 
Public Enum evbdComMode
    Parallel = 0
    Serial = 1
End Enum

Public Enum evbdSerMode
    TwoWire = 0
    ThreeWire = 1
End Enum

Public Enum evbBuffs
    evbDataBuffer = 0    'U5
    evbAddressBuffer = 1 'U7
    evbControlBuffer = 2 'U8
End Enum

Public Enum evbBits
    evbBit0 = 0
    evbBit1 = 1
    evbBit2 = 2
    evbBit3 = 3
    evbBit4 = 4
    evbBit5 = 5
    evbBit6 = 6
    evbBit7 = 7
End Enum

'*******************************************************
'* Constants                                           *
'*******************************************************
'Bit Number Constants for the signals on the
'parallel port's data port
Const bnD0 = 0
Const bnD1 = 1
Const bnD2 = 2
Const bnD3 = 3
Const bnD4 = 4
Const bnD5 = 5
Const bnD6 = 6
Const bnD7 = 7

Const bnA0_SDIO = 0
Const bnA1 = 1
Const bnA2_IOReset = 2
Const bnA3 = 3
Const bnA4 = 4
Const bnA5 = 5

Const bnPS0 = 0
Const bnPS1 = 1
Const bnSPMode = 2
Const bnReset = 3
Const bnFUD = 4
Const bnWRB_SCLK = 5
Const bnRDB_CSB = 6

'Bit Number Constants for the signals on the
'parallel port's status port
Const bnSDO = 3

'Bit Number Constants for the signals on the
'parallel port's Control port
Const bnClockD = 0
Const bnClockA = 1
Const bnRB_Enable = 2
Const bnClockF = 3

'Define the serial mode register names which index the
'lookup table above
Const smCFR = &H0
Const smDFTW = &H1
Const smDFRRW = &H2
Const smFTW0 = &H3
Const smPOW0 = &H4
Const smFTW1 = &H5
Const smPOW1 = &H6
Const smFTW2 = &H7
Const smPOW2 = &H8
Const smFTW3 = &H9
Const smPOW3 = &HA
Const smDAC_CTRL = &HB
Const smTR0 = &HC
Const smTR1 = &HD
Const smTR2 = &HE

'*******************************************************
'local variable(s) to hold property value(s)           *
'*******************************************************
Private mvarD0 As adiBinValues 'local copy
Private mvarD1 As adiBinValues 'local copy
Private mvarD2 As adiBinValues 'local copy
Private mvarD3 As adiBinValues 'local copy
Private mvarD4 As adiBinValues 'local copy
Private mvarD5 As adiBinValues 'local copy
Private mvarD7 As adiBinValues 'local copy
Private mvarA0_SDIO As adiBinValues 'local copy
Private mvarA1 As adiBinValues 'local copy
Private mvarA2_IOReset As adiBinValues 'local copy
Private mvarA3 As adiBinValues 'local copy
Private mvarA4 As adiBinValues 'local copy
Private mvarA5 As adiBinValues 'local copy
Private mvarSDI As adiBinValues 'local copy
Private mvarPS0 As adiBinValues 'local copy
Private mvarPS1 As adiBinValues 'local copy
Private mvarSPMode As adiBinValues 'local copy
Private mvarReset As adiBinValues 'local copy
Private mvarFUD As adiBinValues 'local copy
Private mvarWRB_SCLK As adiBinValues 'local copy
Private mvarRDB_CSB As adiBinValues 'local copy
Private mvarSDO As adiBinValues 'local copy
Private mvarClock_D As adiBinValues 'local copy
Private mvarClock_A As adiBinValues 'local copy
Private mvarRB_Enable As adiBinValues 'local copy
Private mvarClock_F As adiBinValues 'local copy
Private mvarD6 As adiBinValues 'local copy
Private mvarEnabled As Boolean 'local copy
Private mvarLSBFirst As Boolean 'local copy

'Delcare the LPTIO class
Private PPIO As clsLPTIO

'These variables store the values last latched into the latches
'U5,U7,U8 on the Evaluation Board
Private evbBuffers(0 To 2) As Integer
Private evbBitVals(0 To 7) As Integer

'Allocate memory for a lookup table for the serial mode
'register sizes
Private sRegSize(0 To 14) As Integer
Private sPRegAddr(0 To 14, 0 To 3) As Integer
'local variable(s) to hold property value(s)
Private mvarSerialIOMode As evbdSerMode 'local copy
'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent ResetOccured[(arg1, arg2, ... , argn)]
Public Event ResetOccured()
Attribute ResetOccured.VB_Description = "Is triggered after a reset has occured."
'local variable(s) to hold property value(s)
Private mvarAutoFUD As Boolean 'local copy
Public Property Let AutoFUD(ByVal vData As Boolean)
Attribute AutoFUD.VB_Description = "When set to true after a load the software will automatically strobe the FUD pin on the AD9858, loading the data sent and making it active.  When set to false the user must manually strobe the FUD pin, to make the data sent active."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.AutoFUD = 5
    mvarAutoFUD = vData
End Property


Public Property Get AutoFUD() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.AutoFUD
    AutoFUD = mvarAutoFUD
End Property

'Gets the active profile
'Returns 1 to 4
Public Function GetActiveProfile() As Integer
Attribute GetActiveProfile.VB_Description = "Gets the currently active profile."
    Dim sProfileNum As String
    'Set the profile number
    sProfileNum = CStr(PS1) & CStr(PS0)
    GetActiveProfile = CInt(cbaseBinS2Dec(sProfileNum)) + 1
End Function

'Sets the active profile
'Inputs: Profile = A value from 0 to 3
Public Sub SetActiveProfile(ByVal Profile As Integer)
Attribute SetActiveProfile.VB_Description = "Sets the currently active profile."
    Dim sProfileNum As String
    'Use the profile selection bits to select the profile
    Select Case Profile
        Case 0:
            PS0 = abvLow
            PS1 = abvLow
        Case 1:
            PS0 = abvHigh
            PS1 = abvLow
        Case 2:
            PS0 = abvLow
            PS1 = abvHigh
        Case 3:
            PS0 = abvHigh
            PS1 = abvHigh
    End Select
End Sub


Public Property Let SerialIOMode(ByVal vData As evbdSerMode)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SerialIOMode = 5
    'mvarSerialIOMode = vData
    MsgBox "SerialIOMode is currently a read only property." & vbCrLf & "SerialIOMOde can only be set by setting Bit 1 in the Control Register.", vbCritical, "Funciton: Not Yet Supported!!"
End Property


Public Property Get SerialIOMode() As evbdSerMode
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SerialIOMode
    SerialIOMode = mvarSerialIOMode
End Property






Public Property Let LSBFirst(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LSBFirst = 5
    'mvarLSBFirst = vData
End Property


Public Property Get LSBFirst() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LSBFirst
    LSBFirst = mvarLSBFirst
End Property
'Loads the data speicified by data into the AD9858 at the register address
'specified by Address
Public Sub LoadData(ByVal Address As Integer, ByVal Data As String)
    If mvarEnabled Then
        If SPMode = abvHigh Then
            ParallelLoad Address, Data
        Else
            SerialLoad Address, Data
        End If
    End If
    
    If mvarAutoFUD = True Then
        'Strobe the FUD line
        FUD = abvLow
        FUD = abvHigh
        FUD = abvLow
    End If
End Sub


'This Sub is designed to work just like SerialLoad data and address
'values are identical in format.
'Address is the serial address of the register to be modified
'Data Format - MSB 10101010 10101010 LSB
'                 LBO             FBO
Public Sub ParallelLoad(ByVal Address As Integer, ByVal Data As String)
    Dim sByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim iData As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
    
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)
        
        'If the number of bytes to send is different than the number of bytes
        'present in the data passed then exit the sub
        If (NumBytes = (Len(Data) / 8)) And (Address >= 0 And Address <= &HD) Then
            'Get a copy of the data, this data should contain the right amount for
            'the register
            sData = Data
            
            'Loop through the data and send each byte
            For cntr = 0 To NumBytes - 1
                'Get the byte to send
                sByte = Right(sData, 8)
                
                'Trim off that byte
                If Len(sData) > 8 Then
                    sData = Left(sData, Len(sData) - 8)
                End If
                
                'Convert the data to an integer form
                iData = CInt(cbaseBinS2Dec(sByte))
                
                'Load the data into the AD9858
                ParallelLoadByte sPRegAddr(Address, cntr), iData
            Next cntr
        Else
            'The data isn't valid or the address isn't valid
            If Address < 0 Or Address > &HD Then
                MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub ParallelLoad"
            End If
            
            If NumBytes = (Len(Data) / 8) Then
                MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub ParallelLoad"
            End If
        End If
    End If
End Sub

Public Sub SerialLoad(ByVal Address As Integer, ByVal Data As String)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)
        
        'If the number of bytes to send is different than the number of bytes
        'present in the data passed then exit the sub
        If (NumBytes = (Len(Data) / 8)) And (Address >= 0 And Address <= &HD) Then
            'Build the instruction byte
            sInstructByte = "0000" & cbaseDec2Bin(Address, 4)
            sData = Data
            
            'Check to see if the part is currently in LSB First Mode
            If LSBFirst Then
                'Rearrange the instruction byte into LSB First format
                sInstructByte = FlipString(sInstructByte)
                'Rearrange the data into LSB First format
                sData = FlipString(sData)
            End If
            
            'Build the final data string to be sent to the AD9858
            sData = sInstructByte & sData
            
            'Set SCLK Low before csb goes low so that we will know its
            'state
            WRB_SCLK = abvLow
            
            'First take the CSB line low
            RDB_CSB = abvLow
            
            'Send the Instruction Byte first
'            For cntr = 1 To Len(sInstructByte)
'                'Set SDI to the proper value
'                A0_SDIO = CInt(Mid(sInstructByte, cntr, 1))
'                'Latch the data into the AD9858
'                WRB_SCLK = abvHigh
'                WRB_SCLK = abvLow
'            Next cntr
            
            'Loop through the data
            For cntr = 1 To Len(sData)
                'Set SDI to the proper value
                A0_SDIO = CInt(Mid(sData, cntr, 1))
                'Latch the data into the AD9858
                WRB_SCLK = abvHigh
                WRB_SCLK = abvLow
            Next cntr
                    
            'Now return the CSB line high
            RDB_CSB = abvHigh
            'Always return SCLK to a High when done just incase the user
            'switches to Parallel Mode
            WRB_SCLK = abvHigh
            
            'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
            If Address = 0 Then
                If Right(Data, 1) = "1" Then
                    'They sent the LSBFirst Bit
                    mvarLSBFirst = True
                Else
                    'They Sent MSB First Mode
                    mvarLSBFirst = False
                End If
                If Left(Right(Data, 2), 1) = "1" Then
                    'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                    mvarSerialIOMode = ThreeWire
                    'Make sure RB_Enable is a low
                    RB_Enable = abvLow
                Else
                    'They want 2 wire mode
                    mvarSerialIOMode = TwoWire
                End If
            End If
        Else
            'The data isn't valid or the address isn't valid
            If Address < 0 Or Address > &HD Then
                MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub SerialLoad"
            End If
            
            If NumBytes = (Len(Data) / 8) Then
                MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub SerialLoad"
            End If
        End If
    End If
End Sub
'Reads back a string serialy
Public Function SerialRead(ByVal Address As Integer) As String
    Dim sInstructByte As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    Dim sRetStr As String
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)
        
        'If the number of bytes to send is different than the number of bytes
        'present in the data passed then exit the sub
        If Address >= 0 And Address <= &HE Then
            'Build the instruction byte
            sInstructByte = "1000" & cbaseDec2Bin(Address, 4)
            
            'Check to see if the part is currently in LSB First Mode
            If LSBFirst Then
                'Rearrange the instruction byte into LSB First format
                sInstructByte = FlipString(sInstructByte)
            End If
            
            'Set SCLK Low before csb goes low so that we will know its
            'state
            WRB_SCLK = abvLow
            
            'First take the CSB line low
            RDB_CSB = abvLow
            
            'Take readback enable low
            RDB_CSB = abvLow
            
            'Send the Instruction Byte first
            For cntr = 1 To Len(sInstructByte)
                'Set SDI to the proper value
                A0_SDIO = CInt(Mid(sInstructByte, cntr, 1))
                'Latch the data into the AD9858
                WRB_SCLK = abvHigh
                If cntr <> Len(sInstructByte) Then
                    WRB_SCLK = abvLow
                End If
                
            Next cntr
            
            If SerialIOMode = TwoWire Then
                'Set read back enable high
                RB_Enable = abvHigh
            Else
                'Make sure its low or
                RB_Enable = abvLow
            End If
                        
            'Loop through, reading the data back
            For cntr = 0 To ((NumBytes * 8) - 1)
                'Latch the data into the AD9858
                WRB_SCLK = abvLow
                'Get a bit from the eval board
                sRetStr = sRetStr & CStr(SDO)
                'Set sclk high only if it isn't the last bit shifted in
                WRB_SCLK = abvHigh
            Next cntr
            
            'Take the sclk line low again
            WRB_SCLK = abvLow
                                
            'If in 2 Wire mode set RB_Enable Low again
            If SerialIOMode = TwoWire Then
                'Set read back enable low
                RB_Enable = abvLow
            End If
                                
            'Now return the CSB line high
            RDB_CSB = abvHigh
            'Always return SCLK to a High when done just incase the user
            'switches to Parallel Mode
            WRB_SCLK = abvHigh
            
            'Check to see if the AD9858 is in LSB First mode
            If LSBFirst = True Then
                'Rearrange the data read back into MSB First format
                sRetStr = FlipString(sRetStr)
            End If
            
            'Return the data string received
            SerialRead = sRetStr
        Else
            'The data isn't valid or the address isn't valid
            If Address < 0 Or Address > &HD Then
                MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub SerialLoad"
            End If
            
            If NumBytes = (Len(Data) / 8) Then
                MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub SerialLoad"
            End If
        End If
    End If
End Function

Public Sub ParallelLoadByte(ByVal addr As Integer, ByVal Data As Integer)
    Dim InstructByte As Integer
    Dim sData As String
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Make sure that RBE is set low
        RB_Enable = abvLow
        
        'Setup the instruction byte
        InstructByte = addr 'And 63 - Don't need this unless in serial mode
        
        'Put the data in the register and send it to the parallel port
        WriteEvbBuffVal evbAddressBuffer, InstructByte
        
        'Send the data to the eval board
        WriteEvbBuffVal evbDataBuffer, Data
        
        'Latch the data into the AD9858
        WRB_SCLK = abvLow
        WRB_SCLK = abvHigh
    
        'Convert the data to a binary string
        sData = cbaseDec2Bin(Data, 8)
            
        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
        If addr = 0 Then
            If Right(sData, 1) = "1" Then
                'They sent the LSBFirst Bit
                mvarLSBFirst = True
            Else
                'They Sent MSB First Mode
                mvarLSBFirst = False
            End If
            If Left(Right(sData, 2), 1) = "1" Then
                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                mvarSerialIOMode = ThreeWire
                'Make sure RB_Enable is a low
                RB_Enable = abvLow
            Else
                'They want 2 wire mode
                mvarSerialIOMode = TwoWire
            End If
        End If
    End If
End Sub

Public Sub ResetDUT()
    'Strobe the reset line
    Reset = abvHigh
    Reset = abvLow
End Sub



Public Property Let Enabled(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Enabled = 5
    mvarEnabled = vData
End Property


Public Property Get Enabled() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Enabled
    Enabled = mvarEnabled
End Property



Public Property Let Clock_F(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_F = Form1
    If mvarEnabled Then
        'Store the value latched into the Data buffer
        If mvarClock_F = abvLow And vData = abvLow Then
            'Just store the value that is currently on the
            'data port because that is what will be latched in
            CtrlBuff = PPIO.GetRegVal(ppaDataRegister)
        End If
        
        mvarClock_F = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnClockF, mvarClock_F
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_F() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_F
    Clock_F = mvarClock_F
End Property



Public Property Let RB_Enable(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.RB_Enable = Form1
    If mvarEnabled Then
        mvarRB_Enable = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnRB_Enable, mvarRB_Enable
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get RB_Enable() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RB_Enable
    RB_Enable = mvarRB_Enable
End Property



Public Property Let Clock_A(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_A = Form1
    If mvarEnabled Then
        'Store the value latched into the Data buffer
        If mvarClock_A = abvLow And vData = abvLow Then
            'Just store the value that is currently on the
            'data port because that is what will be latched in
            AddrBuff = PPIO.GetRegVal(ppaDataRegister)
        End If
        
        mvarClock_A = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnClockA, mvarClock_A
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_A() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_A
    Clock_A = mvarClock_A
End Property



Public Property Let Clock_D(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_D = Form1
    If mvarEnabled Then
        'Store the value latched into the Data buffer
        If mvarClock_D = abvLow And vData = abvLow Then
            'Just store the value that is currently on the
            'data port because that is what will be latched in
            DataBuff = PPIO.GetRegVal(ppaDataRegister)
        End If
        
        mvarClock_D = vData
        'Set the bit value for the Clock_D bit
        PPIO.SetBitVal ppControlRegister, bnClockD, mvarClock_D
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_D() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_D
    Clock_D = mvarClock_D
End Property



Public Property Let SDO(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.SDO = Form1
    'mvarSDO = vData
    MsgBox "SDO is a readonly property.", vbCritical, "Critical Error!"
End Property


Public Property Get SDO() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SDO
    'Read the register value
    Call PPIO.ReadPort(ppStatusRegister)
    mvarSDO = PPIO.GetBitVal(ppaStatusRegister, bnSDO)
    'Return the current value
    SDO = mvarSDO
End Property



Public Property Let RDB_CSB(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.RDB = Form1
    If mvarEnabled Then
        mvarRDB_CSB = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnRDB_CSB, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property

Public Property Get RDB_CSB() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RDB
    RDB_CSB = GetBitVal(evbControlBuffer, bnRDB_CSB)
End Property



Public Property Let WRB_SCLK(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.WRB_SCLK = Form1
    If mvarEnabled Then
        'mvarWRB_SCLK = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnWRB_SCLK, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get WRB_SCLK() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WRB_SCLK
    WRB_SCLK = GetBitVal(evbControlBuffer, bnWRB_SCLK)
End Property



Public Property Let FUD(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.FUD = Form1
    If mvarEnabled Then
        'mvarFUD = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnFUD, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get FUD() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FUD
    FUD = GetBitVal(evbControlBuffer, bnFUD)
End Property



Public Property Let Reset(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Reset = Form1
    If mvarEnabled Then
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnReset, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'If the reset line is going from 0 to a 1
        If mvarReset = abvHigh And vData = abvLow Then
            RaiseEvent ResetOccured
        End If
        mvarReset = vData
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get Reset() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Reset
    Reset = GetBitVal(evbControlBuffer, bnReset)
End Property



Public Property Let SPMode(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.SPMode = Form1
    If mvarEnabled Then
        mvarSPMode = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnSPMode, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get SPMode() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SPMode
    SPMode = GetBitVal(evbControlBuffer, bnSPMode)
End Property



Public Property Let PS1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS1 = Form1
    If mvarEnabled Then
        mvarPS1 = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnPS1, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get PS1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS1
    PS1 = GetBitVal(evbControlBuffer, bnPS1)
End Property



Public Property Let PS0(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS0 = Form1
    If mvarEnabled Then
        'mvarPS0 = vData
        
        'Set the bit value
        SetBitVal evbControlBuffer, bnPS0, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbControlBuffer
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get PS0() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS0
    PS0 = GetBitVal(evbControlBuffer, bnPS0)
End Property






Public Property Let A5(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A5 = Form1
    If mvarEnabled Then
        'mvarA5 = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA5, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A5() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A5
    A5 = GetBitVal(evbAddressBuffer, bnA5)
End Property



Public Property Let A4(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A4 = Form1
    If mvarEnabled Then
        'mvarA4 = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA4, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A4() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A4
    A4 = GetBitVal(evbAddressBuffer, bnA4)
End Property



Public Property Let A3(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A3 = Form1
    If mvarEnabled Then
        'mvarA3 = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA3, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A3() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A3
    A3 = GetBitVal(evbAddressBuffer, bnA3)
End Property



Public Property Let A2_IOReset(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A2_IOReset = Form1
    If mvarEnabled Then
        'mvarA2_IOReset = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA2_IOReset, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A2_IOReset() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A2_IOReset
    A2_IOReset = GetBitVal(evbAddressBuffer, bnA2_IOReset)
End Property



Public Property Let A1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A1 = Form1
    If mvarEnabled Then
        'mvarA1 = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA1, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A1
    A1 = GetBitVal(evbAddressBuffer, bnA1)
End Property



Public Property Let A0_SDIO(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A0_SDIO = Form1
    If mvarEnabled Then
        'mvarA0_SDIO = vData
        
        'Set the bit value
        SetBitVal evbAddressBuffer, bnA0_SDIO, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbAddressBuffer
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get A0_SDIO() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A0_SDIO
    A0_SDIO = GetBitVal(evbAddressBuffer, bnA0_SDIO)
End Property



Public Property Let D7(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D7 = Form1
    If mvarEnabled Then
        'mvarD7 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD7, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D7() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D7
    D7 = GetBitVal(evbDataBuffer, bnD7)
End Property



Public Property Let D6(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D6 = Form1
    If mvarEnabled Then
        'mvarD6 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD6, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D6() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D6
    D6 = GetBitVal(evbDataBuffer, bnD6)
End Property



Public Property Let D5(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D5 = Form1
    If mvarEnabled Then
        'mvarD5 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD5, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D5() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D5
    D5 = GetBitVal(evbDataBuffer, bnD5)
End Property



Public Property Let D4(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D4 = Form1
    If mvarEnabled Then
        'mvarD4 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD4, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D4() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D4
    D4 = GetBitVal(evbDataBuffer, bnD4)
End Property



Public Property Let D3(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D3 = Form1
    If mvarEnabled Then
        'mvarD3 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD3, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D3() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D3
    D3 = GetBitVal(evbDataBuffer, bnD3)
End Property



Public Property Let D2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D2 = Form1
    If mvarEnabled Then
        'mvarD2 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD2, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D2
    D2 = GetBitVal(evbDataBuffer, bnD2)
End Property



Public Property Let D1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D1 = Form1
    If mvarEnabled Then
        'mvarD1 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD1, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D1
    D1 = GetBitVal(evbDataBuffer, bnD1)
End Property

Public Property Let D0(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D0 = Form1
    If mvarEnabled Then
        'mvarD0 = vData
        
        'Set the bit value
        SetBitVal evbDataBuffer, bnD0, vData
        'Write the value to the buffer
        WriteEvbBuffVal evbDataBuffer
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get D0() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D0
    D0 = GetBitVal(evbDataBuffer, bnD0) 'mvarD0
End Property

Private Sub Class_Initialize()
    Dim cntr As Integer
        
    'Setup the lptio class
    Set PPIO = New clsLPTIO
    
    mvarEnabled = True
    mvarLSBFirst = False
    'Default value for AutoFUD mode is on.
    mvarAutoFUD = True
    
    'Initialize the bitvals array
    For cntr = 0 To 7
        evbBitVals(cntr) = 2 ^ cntr
    Next cntr
    
    'Initialize the serial mode register size lookup table,
    'sizes are in number of bytes
    sRegSize(smCFR) = 4
    sRegSize(smDFTW) = 4
    sRegSize(smDFRRW) = 2
    sRegSize(smFTW0) = 4
    sRegSize(smPOW0) = 2
    sRegSize(smFTW1) = 4
    sRegSize(smPOW1) = 2
    sRegSize(smFTW2) = 4
    sRegSize(smPOW2) = 2
    sRegSize(smFTW3) = 4
    sRegSize(smPOW3) = 2
    sRegSize(smDAC_CTRL) = 2
    sRegSize(smTR0) = 2
    sRegSize(smTR1) = 3
    sRegSize(smTR2) = 3
    
    'Setup the serial to parallel port register
    'address lookup table for the
    sPRegAddr(smCFR, 0) = &H0
    sPRegAddr(smCFR, 1) = &H1
    sPRegAddr(smCFR, 2) = &H2
    sPRegAddr(smCFR, 3) = &H3
    
    sPRegAddr(smDFTW, 0) = &H4
    sPRegAddr(smDFTW, 1) = &H5
    sPRegAddr(smDFTW, 2) = &H6
    sPRegAddr(smDFTW, 3) = &H7

    sPRegAddr(smDFRRW, 0) = &H8
    sPRegAddr(smDFRRW, 1) = &H9

    sPRegAddr(smFTW0, 0) = &HA
    sPRegAddr(smFTW0, 1) = &HB
    sPRegAddr(smFTW0, 2) = &HC
    sPRegAddr(smFTW0, 3) = &HD
    
    sPRegAddr(smPOW0, 0) = &HE
    sPRegAddr(smPOW0, 1) = &HF

    sPRegAddr(smFTW1, 0) = &H10
    sPRegAddr(smFTW1, 1) = &H11
    sPRegAddr(smFTW1, 2) = &H12
    sPRegAddr(smFTW1, 3) = &H13
    
    sPRegAddr(smPOW1, 0) = &H14
    sPRegAddr(smPOW1, 1) = &H15

    sPRegAddr(smFTW2, 0) = &H16
    sPRegAddr(smFTW2, 1) = &H17
    sPRegAddr(smFTW2, 2) = &H18
    sPRegAddr(smFTW2, 3) = &H19
    
    sPRegAddr(smPOW2, 0) = &H1A
    sPRegAddr(smPOW2, 1) = &H1B

    sPRegAddr(smFTW3, 0) = &H1C
    sPRegAddr(smFTW3, 1) = &H1D
    sPRegAddr(smFTW3, 2) = &H1E
    sPRegAddr(smFTW3, 3) = &H1F
    
    sPRegAddr(smPOW3, 0) = &H20
    sPRegAddr(smPOW3, 1) = &H21
    
    sPRegAddr(smDAC_CTRL, 0) = &H22
    sPRegAddr(smDAC_CTRL, 1) = &H23
    
    sPRegAddr(smTR0, 0) = &H24
    sPRegAddr(smTR0, 1) = &H25
    
    sPRegAddr(smTR1, 0) = &H26
    sPRegAddr(smTR1, 1) = &H27
    sPRegAddr(smTR1, 2) = &H28

    sPRegAddr(smTR2, 0) = &H29
    sPRegAddr(smTR2, 1) = &H2A
    sPRegAddr(smTR2, 2) = &H2B

End Sub

Private Sub Class_Terminate()
    'Release the lptio class
    Set PPIO = Nothing
End Sub
'Flips a string - used to flip the data in lsb mode
Public Function FlipString(ByVal MyStr As String) As String
    Dim cntr As Integer
    For cntr = Len(MyStr) To 1 Step -1
        FlipString = FlipString & Mid(MyStr, cntr, 1)
    Next cntr
End Function
'Sets the specified bit value to the specified buffer
Public Sub SetBitVal(ByVal Buff As evbBuffs, ByVal Bit As evbBits, ByVal value As adiBinValues)
    If value <> 0 Then
        'Set the bit
        evbBuffers(Buff) = evbBuffers(Buff) Or evbBitVals(Bit)
    Else
        'Clear the bit
        evbBuffers(Buff) = evbBuffers(Buff) And Not evbBitVals(Bit)
    End If
End Sub
'Returns the current bit value from the specified buffer
Public Function GetBitVal(ByVal Buff As evbBuffs, ByVal Bit As evbBits) As Integer
    'Test the bit
    If evbBuffers(Buff) And evbBitVals(Bit) Then
        'If a one the return 1
        GetBitVal = 1
    Else
        'If a zero then return 0
        GetBitVal = 0
    End If
End Function
'Returns the current value of the specified software buffer which should be the
'current hardware buffer value if SetBitVal,SetEvbBuffVal,and WriteEvbBuffVal
'are used exclusively
Public Function GetEvbBuffVal(ByVal Buff As evbBuffs) As Integer
    'Return the requested information
    GetEvbBuffVal = evbBuffers(Buff)
End Function

'Sets the software buffer value specifed by RegVal
'To write the value from the software buffer to the hardware buffer call
'WriteEvbBuffVal()
Public Sub SetEvbBuffVal(ByVal Buff As evbBuffs, ByVal BuffVal As Integer)
    
    'Set the register value
    evbBuffers(Buff) = BuffVal
    
End Sub

'Writes the value specified by buff to the software buffer and the hardware buffer
'specifed by evbBuffs.  If BuffVal is not passed then it writes the value currently
'in the software buffer.
'The write sequence is as follows
'1. Write the value to the dataport of the parallel port
'2. Latch the data into the proper hardware buffer on the eval board.
Public Sub WriteEvbBuffVal(ByVal Buff As evbBuffs, Optional BuffVal As Variant)
    
    If IsMissing(BuffVal) Then
        'Write it to the parallel port
        PPIO.WritePort ppDataRegister, evbBuffers(Buff)
    Else
        'Set the register value
        evbBuffers(Buff) = BuffVal
        
        'Write it to the parallel port
        PPIO.WritePort ppDataRegister, BuffVal
    End If
    
    Select Case Buff
        Case evbDataBuffer:
            Clock_D = abvHigh
            Clock_D = abvLow
        Case evbAddressBuffer:
            Clock_A = abvHigh
            Clock_A = abvLow
        Case evbControlBuffer:
            Clock_F = abvHigh
            Clock_F = abvLow
    End Select
End Sub

