VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls9859EVBD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "AD9858 Evaluation Board Class - Models the AD9858 Evaluation board."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'*******************************************************
'* Enums                                               *
'*******************************************************
Public Enum adiBinValues
    abvLow = 0
    abvHigh = 1
End Enum
 
Public Enum evbdComMode
    Parallel = 0
    Serial = 1
End Enum

Public Enum evbdSerMode
    TwoWire = 0
    ThreeWire = 1
End Enum

Public Enum evb59Buffs
    evb59Buff1 = 0 'U5
    evb59Buff2 = 1 'U7
    evb59Buff3 = 2 'U8
End Enum

Public Enum evbBits
    evbBit0 = 0
    evbBit1 = 1
    evbBit2 = 2
    evbBit3 = 3
    evbBit4 = 4
    evbBit5 = 5
    evbBit6 = 6
    evbBit7 = 7
End Enum
'Buffer to store new and current register map values
'Syntax: Buffer(Dutnum: 0 or 1, RegAddr: 0 - 12) = Value
Private sRegMapValsNew(0 To 1, 0 To 12) As String
Private sRegMapVals(0 To 1, 0 To 12) As String

'*******************************************************
'* Constants                                           *
'*******************************************************
'Bit Number Constants for the signals on the
'parallel port's data port
'Buff1's Bit Designations
Const bnPS0_DUT1 = 0
Const bnPS1_DUT1 = 1
Const bnPS0_DUT2 = 2
Const bnPS1_DUT2 = 3
Const bnOSK_DUT1 = 4
Const bnOSK_DUT2 = 5
Const bnFUD_DUT1 = 6
Const bnFUD_DUT2 = 7

'Buff2's Bit Designations
Const bnIOSync_DUT1 = 0
Const bnIOSync_DUT2 = 1
Const bnPwrDwnCtl_DUT1 = 2
Const bnPwrDwnCtl_DUT2 = 3
Const bnClkMdSel_DUT1 = 4
Const bnClkMdSel_DUT2 = 5
Const bnReset_DUT1 = 6
Const bnReset_DUT2 = 7

'Buff3's Bit Designations
Const bnSDIO = 0
Const bnSCLK = 1
Const bnCSB_DUT1 = 2
Const bnCSB_DUT2 = 3
Const bnREF_CLK = 4

'Bit Number Constants for the signals on the
'parallel port's status port
Const bnSDO = 3
Const bnSCLK1 = 6

'Bit Number Constants for the signals on the
'parallel port's Control port
Const bnClock_D = 0
Const bnClock_A = 1
Const bnRB_Enable = 2
Const bnClock_F = 3

'Define the serial mode register names which index the
'lookup table above
Const smCFR1 = &H0
Const smCFR2 = &H1
Const smASF = &H2
Const smARR = &H3
Const smFTW0 = &H4
Const smPOW0 = &H5
Const smFTW1 = &H6
Const smRSCW0 = &H7
Const smRSCW1 = &H8
Const smRSCW2 = &H9
Const smRSCW3 = &HA
Const smRAM = &HB
Const smTR = &HC

'*******************************************************
'local variable(s) to hold property value(s)           *
'*******************************************************
Private mvarPS0_DUT1 As adiBinValues 'local copy
Private mvarPS1_DUT1 As adiBinValues 'local copy
Private mvarPS0_DUT2 As adiBinValues 'local copy
Private mvarPS1_DUT2 As adiBinValues 'local copy
Private mvarOSK_DUT1 As adiBinValues 'local copy
Private mvarOSK_DUT2 As adiBinValues 'local copy
Private mvarFUD_DUT1 As adiBinValues 'local copy
Private mvarFUD_DUT2 As adiBinValues 'local copy
Private mvarIOSync_DUT1 As adiBinValues 'local copy
Private mvarIOSync_DUT2 As adiBinValues 'local copy
Private mvarPwrDwnCtl_DUT1 As adiBinValues 'local copy
Private mvarPwrDwnCtl_DUT2 As adiBinValues 'local copy
Private mvarClkMdSel_DUT1 As adiBinValues 'local copy
Private mvarClkMdSel_DUT2 As adiBinValues 'local copy
Private mvarReset_DUT1 As adiBinValues 'local copy
Private mvarReset_DUT2 As adiBinValues 'local copy
Private mvarCSB_DUT1 As adiBinValues 'local copy
Private mvarCSB_DUT2 As adiBinValues 'local copy
Private mvarFUD As adiBinValues 'local copy
Private mvarWRB_SCLK As adiBinValues 'local copy
Private mvarRDB_CSB As adiBinValues 'local copy
Private mvarREF_CLK As adiBinValues 'local copy
Private mvarClock_D As adiBinValues 'local copy
Private mvarClock_A As adiBinValues 'local copy
Private mvarRB_Enable As adiBinValues 'local copy
Private mvarClock_F As adiBinValues 'local copy
Private mvarEnabled As Boolean 'local copy
Private mvarLSBFirstDUT1 As Boolean 'local copy
Private mvarLSBFirstDUT2 As Boolean 'local copy
Private mvarSDO As adiBinValues
Private mvarSCLK1 As adiBinValues

'Delcare the LPTIO class
Public PPIO As clsLPTIO

'These variables store the values last latched into the latches
'U5,U7,U8 on the Evaluation Board
Private evbBuffers(0 To 2) As Integer
Private evbBitVals(0 To 7) As Integer

'Allocate memory for a lookup table for the serial mode
'register sizes
Private sRegSize(0 To 12) As Integer
'Private sPRegAddr(0 To 14, 0 To 3) As Integer
'local variable(s) to hold property value(s)
Private mvarSerialIOModeDUT1 As evbdSerMode 'local copy
Private mvarSerialIOModeDUT2 As evbdSerMode 'local copy
'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent ResetOccured[(arg1, arg2, ... , argn)]
Public Event ResetOccured(DUTNum As Integer, WasPwdwn As Boolean)
Public Event PoweringDown(DUTNum As Integer)
Public Event PoweringUp(DUTNum As Integer)
'RaiseEvent RegMapChanged[(DUTNum=1-2),(RegMap=0-1),(RegAddr=0-12)]
'RegMap = 0 = New Reg Map Values
'RegMap = 1 = Loaded Reg Map Values
Public Event RegMapChanged(DUTNum As Integer, RegMap As Integer, RegAddr As Integer)
'local variable(s) to hold property value(s)
Private mvarAutoFUD_DUT1 As Boolean 'local copy
Private mvarAutoFUD_DUT2 As Boolean 'local copy

Private OldResetDUT1Val As adiBinValues
Private OldResetDUT2Val As adiBinValues

'Local variable(s) to hold property values
Private mvar_DUTsDetected As Integer

'Ramsegment control word structure
Private Type RSCWInfo
    BeginAddr As Integer
    FinalAddr As Integer
    NoDwell As Long
    AddressRampRate As Long
    ModeControl As Integer
End Type


Public Property Let AutoFUD_DUT1(ByVal vData As Boolean)
Attribute AutoFUD_DUT1.VB_Description = "When set to true after a load the software will automatically strobe the FUD pin on the AD9858, loading the data sent and making it active.  When set to false the user must manually strobe the FUD pin, to make the data sent active."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.AutoFUD = 5
    mvarAutoFUD_DUT1 = vData
End Property

Public Property Get AutoFUD_DUT1() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.AutoFUD
    AutoFUD_DUT1 = mvarAutoFUD_DUT1
End Property

Public Property Let AutoFUD_DUT2(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.AutoFUD = 5
    mvarAutoFUD_DUT2 = vData
End Property


Public Property Get AutoFUD_DUT2() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.AutoFUD
    AutoFUD_DUT2 = mvarAutoFUD_DUT2
End Property

'Gets the active profile
'Returns 1 to 4
Public Function GetActiveProfile(ByVal DUTNum As Integer) As Integer
Attribute GetActiveProfile.VB_Description = "Gets the currently active profile."
    Dim sProfileNum As String
    'Set the profile number
    Select Case DUTNum
        Case 2:
            sProfileNum = CStr(PS1_DUT2) & CStr(PS0_DUT2)
        Case Else:
            sProfileNum = CStr(PS1_DUT1) & CStr(PS0_DUT1)
    End Select
    
    GetActiveProfile = CInt(cbaseBinS2Dec(sProfileNum)) + 1
End Function

'Sets the active profile
'Inputs: Profile = A value from 1 to 4
Public Sub SetActiveProfile(ByVal DUTNum As Integer, ByVal Profile As Integer)
Attribute SetActiveProfile.VB_Description = "Sets the currently active profile."
    Dim sProfileNum As String
    Select Case DUTNum
        Case 1:
            'Use the profile selection bits to select the profile
            Select Case Profile
                Case 1:
                    PS0_DUT1 = abvLow
                    PS1_DUT1 = abvLow
                Case 2:
                    PS0_DUT1 = abvHigh
                    PS1_DUT1 = abvLow
                Case 3:
                    PS0_DUT1 = abvLow
                    PS1_DUT1 = abvHigh
                Case 4:
                    PS0_DUT1 = abvHigh
                    PS1_DUT1 = abvHigh
            End Select
        Case 2:
            'Use the profile selection bits to select the profile
            Select Case Profile
                Case 1:
                    PS0_DUT2 = abvLow
                    PS1_DUT2 = abvLow
                Case 2:
                    PS0_DUT2 = abvHigh
                    PS1_DUT2 = abvLow
                Case 3:
                    PS0_DUT2 = abvLow
                    PS1_DUT2 = abvHigh
                Case 4:
                    PS0_DUT2 = abvHigh
                    PS1_DUT2 = abvHigh
            End Select
        Case Else:
            'Use the profile selection bits to select the profile
            Select Case Profile
                Case 1:
                    PS0_DUT1 = abvLow
                    PS1_DUT1 = abvLow
                    PS0_DUT2 = abvLow
                    PS1_DUT2 = abvLow
                Case 2:
                    PS0_DUT1 = abvHigh
                    PS1_DUT1 = abvLow
                    PS0_DUT2 = abvHigh
                    PS1_DUT2 = abvLow
                Case 3:
                    PS0_DUT1 = abvLow
                    PS1_DUT1 = abvHigh
                    PS0_DUT2 = abvLow
                    PS1_DUT2 = abvHigh
                Case 4:
                    PS0_DUT1 = abvHigh
                    PS1_DUT1 = abvHigh
                    PS0_DUT2 = abvHigh
                    PS1_DUT2 = abvHigh
            End Select
    End Select
'    Strobe_Clock_D
    WriteEvbBuffVal evb59Buff1

End Sub


Public Property Let SerialIOModeDUT1(ByVal vData As evbdSerMode)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SerialIOMode = 5
    'mvarSerialIOMode = vData
    MsgBox "SerialIOMode is a read only property." & vbCrLf & "SerialIOMOde can only be set by setting Bit 1 in the Control Register.", vbCritical, "Funciton: Not Yet Supported!!"
End Property


Public Property Get SerialIOModeDUT1() As evbdSerMode
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SerialIOMode
    SerialIOModeDUT1 = mvarSerialIOModeDUT1
End Property
Public Property Let SerialIOModeDUT2(ByVal vData As evbdSerMode)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SerialIOMode = 5
    'mvarSerialIOMode = vData
    MsgBox "SerialIOMode is a read only property." & vbCrLf & "SerialIOMOde can only be set by setting Bit 1 in the Control Register.", vbCritical, "Funciton: Not Yet Supported!!"
End Property


Public Property Get SerialIOModeDUT2() As evbdSerMode
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SerialIOMode
    SerialIOModeDUT2 = mvarSerialIOModeDUT2
End Property






Public Property Let LSBFirstDUT1(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LSBFirst = 5
    'mvarLSBFirst = vData
End Property


Public Property Get LSBFirstDUT1() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LSBFirst
    LSBFirstDUT1 = mvarLSBFirstDUT1
End Property
Public Property Let LSBFirstDUT2(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.LSBFirst = 5
    'mvarLSBFirst = vData
End Property


Public Property Get LSBFirstDUT2() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.LSBFirst
    LSBFirstDUT2 = mvarLSBFirstDUT2
End Property
'Loads the data speicified by data into the AD9858 at the register address
'specified by Address
'Public Sub LoadData(ByVal DUTNum As Integer, ByVal Address As Integer, ByVal Data As String)
'    If mvarEnabled Then
'        'Send out the data on the serial bus
'        SerialLoad Address, Data
'    End If
'
'    If mvarAutoFUD = True Then
'        'Strobe the FUD line
'        FUD_DUT1 = abvLow
'        FUD_DUT1 = abvHigh
'        FUD_DUT1 = abvLow
'
'        'Strobe the FUD line
'        FUD_DUT2 = abvLow
'        FUD_DUT2 = abvHigh
'        FUD_DUT2 = abvLow
'    End If
'End Sub

'Input: DutNum - DUT write data to 1,2 or Any Other Value - To write to both DUTs
'Assumes that if you are writing to both DUTs that the LSB First Bit in CFR1
'is the same for both DUTs.
Public Sub SerialLoad(ByVal DUTNum As Integer, ByVal Address As Integer, ByVal Data As String)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)
        
        'If writing to both DUTs make sure that both are in the same IOMode
        If (DUTNum <> 1 And DUTNum <> 2) And (LSBFirstDUT1 <> LSBFirstDUT2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: To write to both DUT's simultaniously the LSB First bit must be the same for both DUTs.", vbApplicationModal, "Error: SUB Serial Load"
        Else
            'If the number of bytes to send is different than the number of bytes
            'present in the data passed then exit the sub
            If (NumBytes = (Len(Data) / 8)) And (Address >= 0 And Address <= &HC) Then
                
                'Build the instruction byte
                sInstructByte = "0000" & cbaseDec2Bin(Address, 4)
                sData = Data
                
                'Set SCLK Low before csb goes low so that we will know its
                'state
                SCLK = abvLow
                'Strobe the Clock_F line latching in the data
                'Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3
                
                'First take the CSB line low and check for LSB Frist Mode
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvLow
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT1 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                    Case 2
                        CSB_DUT2 = abvLow
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT2 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                    Case Else
                        CSB_DUT1 = abvLow
                        CSB_DUT2 = abvLow
                        'Assume that DUT1 and DUT2 are set the same and check for
                        'LSB First mode on DUT1
                        If LSBFirstDUT1 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                End Select
                'Strobe the Clock_F line latching in the CSB Lines
                'Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3
                
                'Build the final data string to be sent to the AD9858
                sData = sInstructByte & sData
                
                'Loop through the data
                For cntr = 1 To Len(sData)
                    'Set SDIO to the proper value
                    SDIO = CInt(Mid(sData, cntr, 1))
                    'Take SCLK Low
                    SCLK = abvLow
                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    WriteEvbBuffVal evb59Buff3
                    
                    'Latch the data into the AD9858
                    SCLK = abvHigh
                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    WriteEvbBuffVal evb59Buff3
                    
                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    'Take SCLK Low
'                    SCLK = abvLow
'                    WriteEvbBuffVal evb59Buff3
                Next cntr
                        
                'Return SCLK Low
                SCLK = abvLow
                WriteEvbBuffVal evb59Buff3
                
                'Now return the CSB line high
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvHigh
                    Case 2
                        CSB_DUT2 = abvHigh
                    Case Else
                        CSB_DUT1 = abvHigh
                        CSB_DUT2 = abvHigh
                End Select
                'Strobe the Clock_F line latching in the CSB Lines
'                Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3
                
    '                'Always return SCLK to a High when done just incase the user
    '                SCLK = abvHigh
    '                'Strobe the Clock_F line latching in the data
    '                Strobe_Clock_F
                
                'Now check to see
                Select Case DUTNum
                    Case 1
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT1 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT1 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT1 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT1 = TwoWire
                            End If
                        End If
                        'Automatically do a frequency update if the option is true
                        If mvarAutoFUD_DUT1 = True Then
                            FUD_DUT1 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT1 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        End If
                        
                        'Store the value written to the register in a buffer
                        sRegMapVals(0, Address) = Data

                    Case 2
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT2 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT2 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT2 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT2 = TwoWire
                            End If
                        End If
                        'Automatically do a frequency update if the option is true
                        If mvarAutoFUD_DUT2 = True Then
                            FUD_DUT2 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT2 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        End If
                        
                        'Store the value written to the register in a buffer
                        sRegMapVals(1, Address) = Data
                    Case Else
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT1 = True
                                mvarLSBFirstDUT2 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT1 = False
                                mvarLSBFirstDUT2 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT1 = ThreeWire
                                mvarSerialIOModeDUT2 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT1 = TwoWire
                                mvarSerialIOModeDUT2 = TwoWire
                            End If
                        End If
                        
                        If mvarAutoFUD_DUT1 And mvarAutoFUD_DUT2 Then
                            'Fud both at the same time
                            FUD_DUT1 = abvHigh
                            FUD_DUT2 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT1 = abvLow
                            FUD_DUT2 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        Else
                            'Automatically do a frequency update if the option is true
                            If mvarAutoFUD_DUT1 = True Then
                                FUD_DUT1 = abvHigh
                                WriteEvbBuffVal evb59Buff1
                                FUD_DUT1 = abvLow
                                WriteEvbBuffVal evb59Buff1
                            End If
                            'Automatically do a frequency update if the option is true
                            If mvarAutoFUD_DUT2 = True Then
                                FUD_DUT2 = abvHigh
                                WriteEvbBuffVal evb59Buff1
                                FUD_DUT2 = abvLow
                                WriteEvbBuffVal evb59Buff1
                            End If
                        End If
                        
                        'Store the value written to the register in a buffer
                        sRegMapVals(0, Address) = Data
                        sRegMapVals(1, Address) = Data
                End Select
            Else
                'The data isn't valid or the address isn't valid
                If Address < 0 Or Address > &HC Then
                    MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If
                
                If NumBytes = (Len(Data) / 8) Then
                    MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If
            End If
        End If
    End If
End Sub
'Reads back a binary string serialy
Public Function SerialRead(ByVal DUTNum As Integer, ByVal Address As Integer, Optional ARAAR9) As String
    Dim sInstructByte As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    Dim sRetStr As String
    Dim OldProfile As Long
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)
        
        If DUTNum = 1 Or DUTNum = 2 Then
            'If the number of bytes to send is different than the number of bytes
            'present in the data passed then exit the sub
            If Address >= 0 And Address <= &HC Then
                'If reading back from one of the RSCW use the profile pins to address
                If Address >= &H7 And Address <= &HB Then
                    'Store the current profile setting
                    OldProfile = GetActiveProfile(DUTNum)
                End If
                'Set the proper profile for the address selected
                Select Case Address
                    Case &H7
                        SetActiveProfile DUTNum, 1
                    Case &H8
                        SetActiveProfile DUTNum, 2
                    Case &H9
                        SetActiveProfile DUTNum, 3
                    Case &HA
                        'Fake out the part by addressing register 09 H because
                        'Register 0AH won't read back properly for some reason
                        If Not IsMissing(ARAAR9) Then
                            If ARAAR9 = 0 Then
                                Address = &HA 'Reading Address 0AH
                            Else
                                Address = &H9 'Reading Address 09H
                            End If
                        Else
                            Address = &H9 'Reading Address 09H
                        End If
                        'The profile pins actualy address the Register
                        SetActiveProfile DUTNum, 4
                End Select
            
                
                'Build the instruction byte
                sInstructByte = "1000" & cbaseDec2Bin(Address, 4)
                
                'Set SCLK high before csb goes low so that we will know its
                'state
                SCLK = abvHigh
                WriteEvbBuffVal evb59Buff3

                'Now take the appropriate the CSB line high
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvLow
                
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT1 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                        End If
                    Case 2
                        CSB_DUT2 = abvLow
                
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT2 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                        End If
                End Select
                WriteEvbBuffVal evb59Buff3
               
                'Take readback enable low
                RB_Enable = abvLow
'                WriteEvbBuffVal evb59Buff3
                
                'Send the Instruction Byte first
                For cntr = 1 To Len(sInstructByte)
                    'Set SDI to the proper value
                    SDIO = CInt(Mid(sInstructByte, cntr, 1))
                    'Latch the data into the AD9858
                    WriteEvbBuffVal evb59Buff3
'                    If cntr <> Len(sInstructByte) Then
                        'Take SCLK Low
                        SCLK = abvLow
                        'Latch the data into the AD9858
                        WriteEvbBuffVal evb59Buff3
'                    End If
                    'Take SCLK High
                    SCLK = abvHigh
                    'Latch the data into the AD9858
                    WriteEvbBuffVal evb59Buff3
                Next cntr
                
                'Now take the RB_Enable line high or low if needed
                Select Case DUTNum
                    Case 1
                        If SerialIOModeDUT1 = TwoWire Then
                            'Set read back enable high
                            RB_Enable = abvHigh
                        Else
                            'Make sure its low or
                            RB_Enable = abvLow
                        End If
                    Case 2
                        If SerialIOModeDUT2 = TwoWire Then
                            'Set read back enable high
                            RB_Enable = abvHigh
                        Else
                            'Make sure its low or
                            RB_Enable = abvLow
                        End If
                End Select
                'Clock_F
                            
                'Loop through, reading the data back
                For cntr = 0 To ((NumBytes * 8) - 1)
                    'Latch the data into the AD995X
                    SCLK = abvLow
                    WriteEvbBuffVal evb59Buff3
                    'Get a bit from the eval board
                    sRetStr = sRetStr & CStr(SDO)
                    'Set sclk high
                    SCLK = abvHigh
                    WriteEvbBuffVal evb59Buff3
                Next cntr
                
                'Now return the CSB line high
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvHigh
                        
                        'If in 2 Wire mode set RB_Enable Low again
                        If SerialIOModeDUT1 = TwoWire Then
                            'Set read back enable low
                            RB_Enable = abvLow
                            WriteEvbBuffVal evb59Buff3
                        End If
                    Case 2
                        CSB_DUT2 = abvHigh
                        
                        'If in 2 Wire mode set RB_Enable Low again
                        If SerialIOModeDUT1 = TwoWire Then
                            'Set read back enable low
                            RB_Enable = abvLow
                            WriteEvbBuffVal evb59Buff3
                        End If
                End Select
                WriteEvbBuffVal evb59Buff3
                
                'Take the sclk line low again
                SCLK = abvLow
                WriteEvbBuffVal evb59Buff3
                                    
                If DUTNum = 2 Then
                    'Check to see if the part is currently in LSB First Mode
                    If LSBFirstDUT2 Then
                        'Rearrange the instruction byte into LSB First format
                        sRetStr = FlipString(sRetStr)
                    End If
                Else
                    'Check to see if the part is currently in LSB First Mode
                    If LSBFirstDUT1 Then
                        'Rearrange the instruction byte into LSB First format
                        sRetStr = FlipString(sRetStr)
                    End If
                End If
                
                If Address >= &H7 And Address <= &HA Then
                    'Restore the current profile setting
                    SetActiveProfile DUTNum, OldProfile
                End If
                
                'Return the data string received
                SerialRead = sRetStr
            Else
                'The data isn't valid or the address isn't valid
                If Address < 0 Or Address > &HD Then
                    MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If
                
                If NumBytes = (Len(Data) / 8) Then
                    MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If
            End If
        Else
            MsgBox "You can only read from one dut at a time.", vbApplicationModal & vbCritical, "SerialRead()"
        End If
    End If
End Function


'Resets Dut1, Dut2 or Both
'Input: DutNum - DUT to Reset 1,2 or Any Other Value - To reset both
Public Sub ResetDUT(ByVal DUTNum As Integer)
    Select Case DUTNum
        Case 1:
            'Strobe the reset line
            Reset_DUT1 = abvHigh
            EvalBd.WriteEvbBuffVal evb59Buff2
            Reset_DUT1 = abLow
            EvalBd.WriteEvbBuffVal evb59Buff2
        Case 2:
            'Strobe the reset line
            Reset_DUT2 = abvHigh
            EvalBd.WriteEvbBuffVal evb59Buff2
            Reset_DUT2 = abLow
            EvalBd.WriteEvbBuffVal evb59Buff2
        Case Else:
            'Reset both duts
            Reset_DUT1 = abvHigh
            Reset_DUT2 = abvHigh
            EvalBd.WriteEvbBuffVal evb59Buff2
            Reset_DUT1 = abLow
            Reset_DUT2 = abLow
            EvalBd.WriteEvbBuffVal evb59Buff2
    End Select
End Sub



Public Property Let Enabled(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Enabled = 5
    mvarEnabled = vData
End Property


Public Property Get Enabled() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Enabled
    Enabled = mvarEnabled
End Property



Public Property Let Clock_F(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_F = Form1
    If mvarEnabled Then
        'Store the value latched into the Data buffer
        If mvarClock_F = abvLow And vData = abvLow Then
            'Just store the value that is currently on the
            'data port because that is what will be latched in
            CtrlBuff = PPIO.GetRegVal(ppaDataRegister)
        End If
        
        mvarClock_F = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnClock_F, mvarClock_F
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_F() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_F
    Clock_F = mvarClock_F

End Property



Public Property Let RB_Enable(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.RB_Enable = Form1
    If mvarEnabled Then
        mvarRB_Enable = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnRB_Enable, mvarRB_Enable
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get RB_Enable() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RB_Enable
    RB_Enable = mvarRB_Enable
End Property



Public Property Let Clock_A(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_A = Form1
    If mvarEnabled Then
        'Store the value latched into the Data buffer
        If mvarClock_A = abvLow And vData = abvLow Then
            'Just store the value that is currently on the
            'data port because that is what will be latched in
            AddrBuff = PPIO.GetRegVal(ppaDataRegister)
        End If
        
        mvarClock_A = vData
        'Set the bit value for the Clock_A bit
        PPIO.SetBitVal ppControlRegister, bnClock_A, mvarClock_A
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_D() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_A
    'Invert the data because this is a inverted control line
    If mvarClock_D = abvLow Then
        Clock_D = abvHigh
    Else
        Clock_D = abvLow
    End If
    
End Property



Public Property Let Clock_D(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Clock_D = Form1
    If mvarEnabled Then
        'Invert the data because this is a inverted control line
        If vData = abvLow Then
            vData = abvHigh
        Else
            vData = abvLow
        End If
        
        'Store the value latched into the Data buffer
'        If mvarClock_D = abvLow And vData = abvLow Then
'            'Just store the value that is currently on the
'            'data port because that is what will be latched in
'            DataBuff = PPIO.GetRegVal(ppaDataRegister)
'        End If
        
        mvarClock_D = vData
        'Set the bit value for the Clock_D bit
        PPIO.SetBitVal ppControlRegister, bnClock_D, mvarClock_D
        'Write the new data to the Parallel port
        PPIO.WritePort ppControlRegister
    End If
End Property


Public Property Get Clock_A() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Clock_D
    Clock_A = mvarClock_A
End Property



Public Property Let SDO(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.SDO = Form1
    'mvarSDO = vData
    MsgBox "SDO is a readonly property.", vbCritical, "Critical Error!"
End Property


Public Property Get SDO() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SDO
    'Read the register value
    Call PPIO.ReadPort(ppStatusRegister)
    mvarSDO = PPIO.GetBitVal(ppaStatusRegister, bnSDO)
    'Return the current value
    SDO = mvarSDO
End Property

Public Property Let SCLK1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.SDO = Form1
    'mvarSDO = vData
    MsgBox "SCLK1 is a readonly property.", vbCritical, "Critical Error!"
End Property


Public Property Get SCLK1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SDO
    'Read the register value
    Call PPIO.ReadPort(ppStatusRegister)
    mvarSCLK1 = PPIO.GetBitVal(ppaStatusRegister, bnSCLK1)
    'Return the current value
    SCLK1 = mvarSCLK1
End Property



Public Property Let CSB_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.RDB = Form1
    If mvarEnabled Then
        mvarCSB_DUT1 = vData
        
        'Set the bit value
        SetBitVal evb59Buff3, bnCSB_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff3
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property

Public Property Get CSB_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RDB
    CSB_DUT1 = GetBitVal(evb59Buff3, bnCSB_DUT1)
End Property



Public Property Let SCLK(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.WRB_SCLK = Form1
    If mvarEnabled Then
        'mvarWRB_SCLK = vData
        
        'Set the bit value
        SetBitVal evb59Buff3, bnSCLK, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff3
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get SCLK() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WRB_SCLK
    SCLK = GetBitVal(evb59Buff3, bnSCLK)
End Property



Public Property Let FUD_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.FUD = Form1
    If mvarEnabled Then
        'mvarFUD = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnFUD_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get FUD_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FUD
    FUD_DUT1 = GetBitVal(evb59Buff1, bnFUD_DUT1)
End Property



Public Property Let CSB_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Reset = Form1
    If mvarEnabled Then
        
        'Set the bit value
        SetBitVal evb59Buff3, bnCSB_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff3
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get CSB_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Reset
    CSB_DUT2 = GetBitVal(evb59Buff3, bnCSB_DUT2)
End Property



Public Property Let SDIO(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.SPMode = Form1
    If mvarEnabled Then
        mvarSPMode = vData
        
        'Set the bit value
        SetBitVal evb59Buff3, bnSDIO, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff3
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get SDIO() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SPMode
    SDIO = GetBitVal(evb59Buff3, bnSDIO)
End Property



Public Property Let IOSync_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS1 = Form1
    If mvarEnabled Then
        'mvarPS1 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnIOSync_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get IOSync_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS1
    IOSync_DUT1 = GetBitVal(evb59Buff2, bnIOSync_DUT1)
End Property



Public Property Let FUD_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS0 = Form1
    If mvarEnabled Then
        'mvarPS0 = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnFUD_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_F = abvHigh
'        Clock_F = abvLow
    End If
End Property


Public Property Get FUD_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS0
    FUD_DUT2 = GetBitVal(evb59Buff1, bnFUD_DUT2)
End Property






Public Property Let OSK_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A5 = Form1
    If mvarEnabled Then
        'mvarA5 = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnOSK_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get OSK_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A5
    A5 = GetBitVal(evb59Buff1, bnOSK_DUT2)
End Property



Public Property Let OSK_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A4 = Form1
    If mvarEnabled Then
        'mvarA4 = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnOSK_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get OSK_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A4
    OSK_DUT1 = GetBitVal(evb59Buff1, bnOSK_DUT1)
End Property



Public Property Let PS1_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A3 = Form1
    If mvarEnabled Then
        'mvarA3 = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnPS1_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get PS1_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A3
    PS1_DUT2 = GetBitVal(evb59Buff1, bnPS1_DUT2)
End Property



Public Property Let PS0_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A2_IOReset = Form1
    If mvarEnabled Then
        'mvarA2_IOReset = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnPS0_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get PS0_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A2_IOReset
    PS0_DUT2 = GetBitVal(evb59Buff1, bnPS0_DUT2)
End Property



Public Property Let PS1_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A1 = Form1
    If mvarEnabled Then
        'mvarA1 = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnPS1_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get PS1_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A1
    PS1_DUT1 = GetBitVal(evb59Buff1, bnPS1_DUT1)
End Property



Public Property Let PS0_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.A0_SDIO = Form1
    If mvarEnabled Then
        'mvarA0_SDIO = vData
        
        'Set the bit value
        SetBitVal evb59Buff1, bnPS0_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff1
        
        'Latch the data through the buffer
'        Clock_A = abvHigh
'        Clock_A = abvLow
    End If
End Property


Public Property Get PS0_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.A0_SDIO
    PS0_DUT1 = GetBitVal(evb59Buff1, bnPS0_DUT1)
End Property



Public Property Let REF_CLK(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D7 = Form1
    If mvarEnabled Then
        'mvarD7 = vData
        
        'Set the bit value
        SetBitVal evb59Buff3, bnREF_CLK, vData
        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff3
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get REF_CLK() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D7
    REF_CLK = GetBitVal(evb59Buff3, bnREF_CLK)
End Property

Public Property Let ClkMdSel_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D7 = Form1
    If mvarEnabled Then
        'mvarD7 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnClkMdSel_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property
Public Property Get ClkMdSel_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D7
    ClkMdSel_DUT2 = GetBitVal(evb59Buff2, bnClkMdSel_DUT2)
End Property



Public Property Let Reset_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D5 = Form1
    Dim wPwdwn As Boolean
    If mvarEnabled Then
        'mvarD5 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnReset_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'If the reset line is going from 0 to a 1
        If mvarReset_DUT2 = abvHigh And vData = abvLow Then
            'If either of the major powerdown bits are high then the dut was powered down
            If sGetRegMapBitVal(1, 0, 7) = abvHigh Or sGetNewRegMapBitVal(1, 0, 4) = abvHigh Then
                wPwdwn = True
            Else
                wPwdwn = False
            End If
            
            'Clear out the register map buffers
            ResetREGMAP (2)
            RaiseEvent ResetOccured(2, wPwdwn)
            mvarLSBFirstDUT2 = False
            mvarSerialIOModeDUT2 = TwoWire
        End If
        mvarReset_DUT2 = vData
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get Reset_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D5
    Reset_DUT2 = GetBitVal(evb59Buff2, bnReset_DUT2)
End Property



Public Property Let Reset_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D4 = Form1
    Dim wPwdwn As Boolean
    If mvarEnabled Then
        'mvarD4 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnReset_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'If the reset line is going from 0 to a 1
        If mvarReset_DUT1 = abvHigh And vData = abvLow Then
            
            'If either of the major powerdown bits are high then the dut was powered down
            If sGetRegMapBitVal(1, 0, 7) = abvHigh Or sGetNewRegMapBitVal(1, 0, 4) = abvHigh Then
                wPwdwn = True
            Else
                wPwdwn = False
            End If
            
            'Clear out the register map buffers
            ResetREGMAP (1)
            RaiseEvent ResetOccured(1, wPwdwn)
            mvarLSBFirstDUT1 = False
            mvarSerialIOModeDUT1 = TwoWire
        End If
        mvarReset_DUT1 = vData
    
    End If
End Property


Public Property Get Reset_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D4
    Reset_DUT1 = GetBitVal(evb59Buff2, bnReset_DUT1)
End Property



Public Property Let ClkMdSel_DUT1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D3 = Form1
    If mvarEnabled Then
        'mvarD3 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnClkMdSel_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get ClkMdSel_DUT1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D3
    ClkMdSel_DUT1 = GetBitVal(evb59Buff2, bnClkMdSel_DUT1)
End Property



Public Property Let PwrDwnCtl_Dut2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D2 = Form1
    If mvarEnabled Then
        'mvarD2 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnPwrDwnCtl_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get PwrDwnCtl_Dut2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D2
    PwrDwnCtl_Dut2 = GetBitVal(evb59Buff2, bnPwrDwnCtl_DUT2)
End Property



Public Property Let PwrDwnCtl_Dut1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D1 = Form1
    If mvarEnabled Then
        'mvarD1 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnPwrDwnCtl_DUT1, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get PwrDwnCtl_Dut1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D1
    PwrDwnCtl_Dut1 = GetBitVal(evb59Buff2, bnPwrDwnCtl_DUT1)
End Property

Public Property Let IOSync_DUT2(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.D0 = Form1
    If mvarEnabled Then
        'mvarD0 = vData
        
        'Set the bit value
        SetBitVal evb59Buff2, bnIOSync_DUT2, vData
'        'Write the value to the buffer
'        WriteEvbBuffVal evb59Buff2
        
        'Latch the data through the buffer
'        Clock_D = abvHigh
'        Clock_D = abvLow
    End If
End Property


Public Property Get IOSync_DUT2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D0
    IOSync_DUT2 = GetBitVal(evb59Buff2, bnIOSync_DUT2)   'mvarD0
End Property

Private Sub Class_Initialize()
    Dim cntr As Integer
        
    'Setup the lptio class
    Set PPIO = New clsLPTIO
    
    mvarEnabled = True
    mvarLSBFirst = False
    'Default value for AutoFUD mode is on.
    mvarAutoFUD = True
    
    'Initialize the bitvals array
    For cntr = 0 To 7
        evbBitVals(cntr) = 2 ^ cntr
    Next cntr
    
    'Initialize the OldResetDUT1Val & OldResetDUT2Val variable
    OldResetDUT1Val = abvLow
    OldResetDUT2Val = abvLow
    
    mvar_DUTsDetected = 0
    
    'Initialize the serial mode register size lookup table,
    'sizes are in number of bytes
    sRegSize(smCFR1) = 4
    sRegSize(smCFR2) = 3
    sRegSize(smASF) = 2
    sRegSize(smARR) = 1
    sRegSize(smFTW0) = 4
    sRegSize(smPOW0) = 2
    sRegSize(smFTW1) = 4
    sRegSize(smRSCW0) = 5
    sRegSize(smRSCW1) = 5
    sRegSize(smRSCW2) = 5
    sRegSize(smRSCW3) = 5
    sRegSize(smRAM) = 4
    sRegSize(smTR) = 4
    
    mvarAutoFUD_DUT1 = True
    mvarAutoFUD_DUT2 = True
    
    'Reset the register map to its initial values
    'Initialize the register map
    'Clear out the register map values for DUT1
    sRegMapVals(0, 0) = String(32, "0")
    sRegMapVals(0, 1) = String(24, "0")
    sRegMapVals(0, 2) = String(16, "0")
    sRegMapVals(0, 3) = String(8, "0")
    sRegMapVals(0, 4) = String(24, "0")
    sRegMapVals(0, 5) = String(16, "0")
    sRegMapVals(0, 6) = String(32, "0")
    sRegMapVals(0, 7) = String(40, "0")
    sRegMapVals(0, 8) = String(40, "0")
    sRegMapVals(0, 9) = String(40, "0")
    sRegMapVals(0, 10) = String(40, "0")
    sRegMapVals(0, 11) = String(32, "0")
    sRegMapVals(0, 12) = cbaseDec2Bin(&H59000800, 32)

    'Clear out the register map values for DUT2
    sRegMapVals(1, 0) = String(32, "0")
    sRegMapVals(1, 1) = String(24, "0")
    sRegMapVals(1, 2) = String(16, "0")
    sRegMapVals(1, 3) = String(8, "0")
    sRegMapVals(1, 4) = String(24, "0")
    sRegMapVals(1, 5) = String(16, "0")
    sRegMapVals(1, 6) = String(32, "0")
    sRegMapVals(1, 7) = String(40, "0")
    sRegMapVals(1, 8) = String(40, "0")
    sRegMapVals(1, 9) = String(40, "0")
    sRegMapVals(1, 10) = String(40, "0")
    sRegMapVals(1, 11) = String(32, "0")
    sRegMapVals(1, 12) = cbaseDec2Bin(&H59000800, 32)

    'Initialize the register map
    'Clear out the register map values for DUT1
    sRegMapValsNew(0, 0) = String(32, "0")
    sRegMapValsNew(0, 1) = String(24, "0")
    sRegMapValsNew(0, 2) = String(16, "0")
    sRegMapValsNew(0, 3) = String(8, "0")
    sRegMapValsNew(0, 4) = String(24, "0")
    sRegMapValsNew(0, 5) = String(16, "0")
    sRegMapValsNew(0, 6) = String(32, "0")
    sRegMapValsNew(0, 7) = String(40, "0")
    sRegMapValsNew(0, 8) = String(40, "0")
    sRegMapValsNew(0, 9) = String(40, "0")
    sRegMapValsNew(0, 10) = String(40, "0")
    sRegMapValsNew(0, 11) = String(32, "0")
    sRegMapValsNew(0, 12) = cbaseDec2Bin(&H59000800, 32)

    'Clear out the register map values for DUT2
    sRegMapValsNew(1, 0) = String(32, "0")
    sRegMapValsNew(1, 1) = String(24, "0")
    sRegMapValsNew(1, 2) = String(16, "0")
    sRegMapValsNew(1, 3) = String(8, "0")
    sRegMapValsNew(1, 4) = String(24, "0")
    sRegMapValsNew(1, 5) = String(16, "0")
    sRegMapValsNew(1, 6) = String(32, "0")
    sRegMapValsNew(1, 7) = String(40, "0")
    sRegMapValsNew(1, 8) = String(40, "0")
    sRegMapValsNew(1, 9) = String(40, "0")
    sRegMapValsNew(1, 10) = String(40, "0")
    sRegMapValsNew(1, 11) = String(32, "0")
    sRegMapValsNew(1, 12) = cbaseDec2Bin(&H59000800, 32)
End Sub

Private Sub Class_Terminate()
    'Release the lptio class
    Set PPIO = Nothing
End Sub
'Flips a string - used to flip the data in lsb first mode
Public Function FlipString(ByVal MyStr As String) As String
    Dim cntr As Integer
    For cntr = Len(MyStr) To 1 Step -1
        FlipString = FlipString & Mid(MyStr, cntr, 1)
    Next cntr
End Function
'Sets the specified bit value to the specified buffer
Public Sub SetBitVal(ByVal Buff As evb59Buffs, ByVal Bit As evbBits, ByVal value As adiBinValues)
    If value <> 0 Then
        'Set the bit
        evbBuffers(Buff) = evbBuffers(Buff) Or evbBitVals(Bit)
    Else
        'Clear the bit
        evbBuffers(Buff) = evbBuffers(Buff) And Not evbBitVals(Bit)
    End If
End Sub
'Returns the current bit value from the specified buffer
Public Function GetBitVal(ByVal Buff As evb59Buffs, ByVal Bit As evbBits) As Integer
    'Test the bit
    If evbBuffers(Buff) And evbBitVals(Bit) Then
        'If a one the return 1
        GetBitVal = 1
    Else
        'If a zero then return 0
        GetBitVal = 0
    End If
End Function
'Returns the current value of the specified software buffer which should be the
'current hardware buffer value if SetBitVal,SetEvbBuffVal,and WriteEvbBuffVal
'are used exclusively
Public Function GetEvbBuffVal(ByVal Buff As evb59Buffs) As Integer
    'Return the requested information
    GetEvbBuffVal = evbBuffers(Buff)
End Function

'Sets the software buffer value specifed by RegVal
'To write the value from the software buffer to the hardware buffer call
'WriteEvbBuffVal()
Public Sub SetEvbBuffVal(ByVal Buff As evb59Buffs, ByVal BuffVal As Integer)
    
    'Set the register value
    evbBuffers(Buff) = BuffVal
    
End Sub

'Writes the value specified by buff to the software buffer and the hardware buffer
'specifed by evbBuffs.  If BuffVal is not passed then it writes the value currently
'in the software buffer.
'The write sequence is as follows
'1. Write the value to the dataport of the parallel port
'2. Latch the data into the proper hardware buffer on the eval board.
Public Sub WriteEvbBuffVal(ByVal Buff As evb59Buffs, Optional BuffVal As Variant)
    Dim Val As Integer
    Static ResetDUT2Old As Boolean
    Static ResetDUT1Old As Boolean
    Dim wPwdwnDut1 As Boolean
    Dim wPwdwnDut2 As Boolean
    
    'Check to see if a value was passed, if not then use the value in the buffer
    If IsMissing(BuffVal) Then
        Val = evbBuffers(Buff)
    Else
        Val = BuffVal
    End If
    
    'Try and detect if the DUT(s) are being reset
    If Buff = evb59Buff2 Then 'Only check if BUFF2 is being written
        If Val And &H40 Then 'Test for a ResetDUT1
            If OldResetDUT1Val = abvLow Then
            'If either of the major powerdown bits are high then the dut was powered down
                If sGetRegMapBitVal(1, 0, 7) = abvHigh Or sGetNewRegMapBitVal(1, 0, 4) = abvHigh Then
                    wPwdwnDut1 = True
                Else
                    wPwdwnDut1 = False
                End If
                
                'A Reset is occuring so trigger the ResetOccurred
                RaiseEvent ResetOccured(1, wPwdwnDut1)
            End If
            'Store the state of the Reset Pin for future reference
            OldResetDUT1Val = abvHigh
        Else
            'Store the state of the Reset Pin for future reference
            OldResetDUT1Val = abvLow
        End If
        
        If Val And &H80 Then 'Test for a ResetDUT2
            If OldResetDUT2Val = abvLow Then
            'If either of the major powerdown bits are high then the dut was powered down
                If sGetRegMapBitVal(2, 0, 7) = abvHigh Or sGetNewRegMapBitVal(2, 0, 4) = abvHigh Then
                    wPwdwnDut2 = True
                Else
                    wPwdwnDut2 = False
                End If
                'A Reset is occuring so trigger the ResetOccurred
                RaiseEvent ResetOccured(2, wPwdwnDut2)
            End If
            'Store the state of the Reset Pin for future reference
            OldResetDUT2Val = abvHigh
        Else
            'Store the state of the Reset Pin for future reference
            OldResetDUT2Val = abvLow
        End If
    End If
    
    'Write it to the parallel port
    PPIO.WritePort ppDataRegister, Val
    
    'Store the new register value
    evbBuffers(Buff) = Val
    
    Select Case Buff
        Case evb59Buff1:
            Clock_D = abvLow
            Clock_D = abvHigh
        Case evb59Buff2:
            Clock_A = abvLow
            Clock_A = abvHigh
        Case evb59Buff3:
            Clock_F = abvLow
            Clock_F = abvHigh
    End Select
End Sub

'Strobes the Clock_D Line
Public Sub Strobe_Clock_D()
    'If it is already low the take it high because the latches are negative edge triggered
'    If Clock_D = abvLow Then
        Clock_D = abvHigh
'    End If
    Clock_D = abvLow
    Clock_D = abvHigh
End Sub
'Strobes the Clock_A Line
Public Sub Strobe_Clock_A()
    'If it is already low the take it high because the latches are negative edge triggered
'    If Clock_A = abvLow Then
        Clock_A = abvHigh
'    End If
    
    Clock_A = abvLow
    Clock_A = abvHigh
End Sub
'Strobes the Clock_F Line
Public Sub Strobe_Clock_F()
    'If it is already low the take it high because the latches are negative edge triggered
'    If Clock_F = abvLow Then
        Clock_F = abvHigh
'    End If
    
    Clock_F = abvLow
    Clock_F = abvHigh
End Sub

'Write a packet "Tunning or Phase Offset Word" to the RAM
'This function checks DUT1s LSBFirst bit and uses DUT1s communication Mode
Public Sub RAMWritePacket(ByVal DUTNum As Integer, ByVal Packet As String)
    Dim sData As String
    Dim cntr As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Build the data string
        sData = Packet
        
        If LSBFirstDUT1 Then
            'Rearrange the data into LSB First format
            sData = FlipString(sData)
        End If
        
        'Loop through the data
        For cntr = 1 To Len(sData)
            'Set SDI to the proper value and take SCLK Low
            SDIO = CInt(Mid(sData, cntr, 1))
            SCLK = abvLow
            'Strobe the Clock_F line latching in the data
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            'Latch the data into the AD9858
            SCLK = abvHigh
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
'            WriteEvbBuffVal evb59Buff3
        Next cntr
    End If
End Sub

'Writes a packet "Tunning or Phase Offset Word" to the RAM
'
Public Function RAMReadPacket(ByVal DUTNum As Integer) As String
    Dim sData As String
    Dim cntr As Integer
    
    sData = ""
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Set the packet size in bits
        NumBytes = 32
        
        'Build the data string
        sData = Packet
        
        'Loop through the data
        For cntr = 1 To NumBytes
            'Clock the out of the AD9859
            SCLK = abvLow
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            
            sData = sData & CStr(SDO)
                        
            SCLK = abvHigh
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
        Next cntr
    End If
    
    'Rearrange the data as it is read back
    If DUTNum = 1 Then
        'Check to see if the data is comming back in LSB First Mode
        If LSBFirstDUT1 Then
            'If so, rearrange the data back into MSB format
            sData = FlipString(sData)
        End If
    Else
        'Check to see if the data is comming back in LSB First Mode
        If LSBFirstDUT2 Then
            'If so, rearrange the data back into MSB format
            sData = FlipString(sData)
        End If
    End If
    
    'Return the data
    RAMReadPacket = sData
End Function

'Initializes a RAM upload sequence
Public Sub RAMInitUpload(ByVal DUTNum As Integer)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Build the instruction byte
        sData = "00001011" 'Address the memory 0BH
        
        'Set SCLK Low before csb goes low so that we will know its
        'state
        SCLK = abvLow
        'Strobe the Clock_F line latching in the data
        WriteEvbBuffVal evb59Buff3
        
        'First take the CSB line low and check for LSB Frist Mode
        Select Case DUTNum
            Case 1
                CSB_DUT1 = abvLow
                'Check to see if the part is currently in LSB First Mode
                If LSBFirstDUT1 Then
                    'Rearrange the data into LSB First format
                    sData = FlipString(sData)
                End If
            Case 2
                CSB_DUT2 = abvLow
                'Check to see if the part is currently in LSB First Mode
                If LSBFirstDUT2 Then
                    'Rearrange the data into LSB First format
                    sData = FlipString(sData)
                End If
            Case Else
                CSB_DUT1 = abvLow
                CSB_DUT2 = abvLow
                'Assume that DUT1 and DUT2 are set the same and check for
                'LSB First mode on DUT1
                If LSBFirstDUT1 Then
                    'Rearrange the data into LSB First format
                    sData = FlipString(sData)
                End If
        End Select
        'Strobe the Clock_F line latching in the CSB Lines
        WriteEvbBuffVal evb59Buff3
        
        'Loop through the data
        For cntr = 1 To Len(sData)
            'Set SDI to the proper value
            SDIO = CInt(Mid(sData, cntr, 1))
            SCLK = abvLow
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            'Latch the data into the AD9858
            SCLK = abvHigh
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            'Strobe the Clock_F line latching in the data
'            WriteEvbBuffVal evb59Buff3
        Next cntr
    End If
End Sub
'Initializes a RAM download sequence
'Returns 1 if successfull
Public Function RAMInitDownload(ByVal DUTNum As Integer) As Integer
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Build the instruction byte
        sData = "10001011" 'Address the memory 0B
        
        'Set SCLK Low before csb goes low so that we will know its
        'state
        SCLK = abvLow
        'Strobe the Clock_F line latching in the data
        WriteEvbBuffVal evb59Buff3
        
        'First take the CSB line low and check for LSB Frist Mode
        Select Case DUTNum
            Case 1
                CSB_DUT1 = abvLow
                'Check to see if the part is currently in LSB First Mode
                If LSBFirstDUT1 Then
                    'Rearrange the data into LSB First format
                    sData = FlipString(sData)
                End If
            Case 2
                CSB_DUT2 = abvLow
                'Check to see if the part is currently in LSB First Mode
                If LSBFirstDUT2 Then
                    'Rearrange the data into LSB First format
                    sData = FlipString(sData)
                End If
            Case Else
                'Can't read back from both DUTs so display error message
                'MsgBox "You can't readback from both DUT's at the same time!", vbApplicationModal + vbCritical, "Error: RAMInitDownload() Function"
                RAMInitDownload = 0
                Exit Function
        End Select
        'Strobe the Clock_F line latching in the CSB Lines
        WriteEvbBuffVal evb59Buff3
        
        'Loop through the data
        For cntr = 1 To Len(sData)
            'Set SDI to the proper value
            SDIO = CInt(Mid(sData, cntr, 1))
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            'Latch the data into the AD9858
            SCLK = abvHigh
            'Strobe the Clock_F line latching in the data
            WriteEvbBuffVal evb59Buff3
            
            'Leave SCLK high because when it goes low the data will be coming back
            'on the SDO line
            If cntr <> Len(sData) Then
                SCLK = abvLow
            End If
        Next cntr
        
        'Check to see if the DUT is in 2 or 3 wire mode
        If DUTNum = 2 Then
            If SerialIOModeDUT2 = TwoWire Then
                'Take readback enable high before clocking data back from the DUT
                RB_Enable = abvHigh
            End If
        Else
            'If not DUT2 the assume DUT1 because a 2 DUT readback isn't possible
            If SerialIOModeDUT1 = TwoWire Then
                'Take readback enable high before clocking data back from the DUT
                RB_Enable = abvHigh
            End If
        End If
    End If
    'No errors return 1
    RAMInitDownload = 1
End Function

Public Sub RAMTerminateDownload(ByVal DUTNum As Integer)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Now return the CSB line high
        Select Case DUTNum
            Case 2
                CSB_DUT2 = abvHigh
                'Strobe the Clock_F line latching in the CSB Lines
                WriteEvbBuffVal evb59Buff3
                'Check for 2-wire mode
                If SerialIOModeDUT2 = TwoWire Then
                    RB_Enable = abvLow
                End If
            Case Else
                CSB_DUT1 = abvHigh
                'Strobe the Clock_F line latching in the CSB Lines
                WriteEvbBuffVal evb59Buff3
                'Check for 2-wire mode
                If SerialIOModeDUT1 = TwoWire Then
                    RB_Enable = abvLow
                End If
        End Select
        
        'Return Sclk Low
        SCLK = abvLow
        WriteEvbBuffVal evb59Buff3

    End If
End Sub

Public Sub RAMTerminateUpload(ByVal DUTNum As Integer)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer
    
    'Only work if the object is enabled
    If mvarEnabled = True Then
        
        'Take SCLK Low just for looks
        SCLK = abvLow
        'Strobe the Clock_F line latching in the data
        WriteEvbBuffVal evb59Buff3
        
        'Now return the CSB line high
        Select Case DUTNum
            Case 1
                CSB_DUT1 = abvHigh
            Case 2
                CSB_DUT2 = abvHigh
            Case Else
                CSB_DUT1 = abvHigh
                CSB_DUT2 = abvHigh
        End Select
        'Strobe the Clock_F line latching in the CSB Lines
        WriteEvbBuffVal evb59Buff3
    End If
End Sub
'Loads a RAM File
Public Sub RAMLoadFile(ByVal DUTNum As Integer, ByVal RamFile As String)
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim DummyDbl As Double
    Dim cntr As Integer
    Dim CntrStart As Integer
    Dim CntrStop As Integer
    Dim CntrStep As Integer
    
    Dim FileType As String
    Dim FileRevNum As Double
    Dim TempDataStr As String
    Dim RSCW0Str As String
    Dim RSCW1Str As String
    Dim RSCW2Str As String
    Dim RSCW3Str As String
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer
    
    Dim ModeCntrlRS0 As Integer
    Dim NoDwellRS0 As Integer
    Dim StartAddressRS0 As Integer
    Dim FinalAddressRS0 As Integer
    Dim AddressRampRateRS0 As Long
    
    Dim ModeCntrlRS1 As Integer
    Dim NoDwellRS1 As Integer
    Dim StartAddressRS1 As Integer
    Dim FinalAddressRS1 As Integer
    Dim AddressRampRateRS1 As Long
    
    Dim ModeCntrlRS2 As Integer
    Dim NoDwellRS2 As Integer
    Dim StartAddressRS2 As Integer
    Dim FinalAddressRS2 As Integer
    Dim AddressRampRateRS2 As Long
    
    Dim ModeCntrlRS3 As Integer
    Dim NoDwellRS3 As Integer
    Dim StartAddressRS3 As Integer
    Dim FinalAddressRS3 As Integer
    Dim AddressRampRateRS3 As Long
        
    Dim RamSegment0Data() As String
    Dim RamSegment1Data() As String
    Dim RamSegment2Data() As String
    Dim RamSegment3Data() As String
    
    Dim UseRS0 As Boolean
    Dim UseRS1 As Boolean
    Dim UseRS2 As Boolean
    Dim UseRS3 As Boolean
    Dim sRAMAddr As String
    
    'Setup an error handler
    On Error GoTo ErrorHandler:
        
    'Set the screen cursor to hourglass
    Screen.MousePointer = 11
        
    If mvarEnabled = True Then
        'If writing to both DUTs make sure that both are in the same IOMode
        If (DUTNum <> 1 And DUTNum <> 2) And (LSBFirstDUT1 <> LSBFirstDUT2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: To write to both DUT's simultaniously the LSB First bit must be the same for both DUTs.", vbApplicationModal, "Error: SUB RAMLoadFile()"
        Else
            'If the number of bytes to send is different than the number of bytes
            'present in the data passed then exit the sub
            If (FileExists(RamFile)) Then
                'Get a sharable file handle
                FileHandle = FreeFile(1)
                
                'Open the file
                Open RamFile For Input As #FileHandle
                
                'Read the file header back
                Input #FileHandle, FileType, FileRevNum
                'Make sure its a valid file
                If FileType = "AD9859 RAM Configuration File" And FileRevNum = 1 Then
                    'Trash the next 4 lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    
                    'Read the RSCW0 Info
                    Input #FileHandle, dummystr, ModeCntrlRS0
                    Input #FileHandle, dummystr, NoDwellRS0
                    Input #FileHandle, dummystr, StartAddressRS0
                    Input #FileHandle, dummystr, FinalAddressRS0
                    Input #FileHandle, dummystr, AddressRampRateRS0
                    
                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    
                    'Resize the array
                    ReDim RamSegment0Data((FinalAddressRS0 - StartAddressRS0) + 1)
                    
                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS0 - StartAddressRS0) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS0 = True
                        End If
                        If UseRS0 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment0Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr
                
                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 1"
                    
                    'Read the RSCW1 Info
                    Input #FileHandle, dummystr, ModeCntrlRS1
                    Input #FileHandle, dummystr, NoDwellRS1
                    Input #FileHandle, dummystr, StartAddressRS1
                    Input #FileHandle, dummystr, FinalAddressRS1
                    Input #FileHandle, dummystr, AddressRampRateRS1
                    
                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    
                    'Resize the array
                    ReDim RamSegment1Data((FinalAddressRS1 - StartAddressRS1) + 1)
                    
                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS1 - StartAddressRS1) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS1 = True
                        End If
                        If UseRS1 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment1Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr
                
                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 2"
                    
                    'Read the RSCW2 Info
                    Input #FileHandle, dummystr, ModeCntrlRS2
                    Input #FileHandle, dummystr, NoDwellRS2
                    Input #FileHandle, dummystr, StartAddressRS2
                    Input #FileHandle, dummystr, FinalAddressRS2
                    Input #FileHandle, dummystr, AddressRampRateRS2
                    
                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    
                    'Resize the array
                    ReDim RamSegment2Data((FinalAddressRS2 - StartAddressRS2) + 1)
                    
                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS2 - StartAddressRS2) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS2 = True
                        End If
                        If UseRS2 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment2Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr
                
                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 3"
                    
                    'Read the RSCW3 Info
                    Input #FileHandle, dummystr, ModeCntrlRS3
                    Input #FileHandle, dummystr, NoDwellRS3
                    Input #FileHandle, dummystr, StartAddressRS3
                    Input #FileHandle, dummystr, FinalAddressRS3
                    Input #FileHandle, dummystr, AddressRampRateRS3
                    
                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    
                    'Resize the array
                    ReDim RamSegment3Data((FinalAddressRS3 - StartAddressRS3) + 1)
                    
                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS3 - StartAddressRS3) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS3 = True
                        End If
                        If UseRS3 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment3Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr
                    ' Close before reopening in another mode.
                    Close #FileHandle
                    
                    '*** All data was read correctly - Now Program The DUT(s) ****
                    'First program the RSCW Registers
                    'Build the binary string for the RSCW in MSB format
                    'RAMSegmentAddressRampRate<7:0> + RAMSegmentAddressRampRate<15:8> +
                    'RAMSegmentFinalAddress<7:0> +
                    'RAMSegmentBeginningAddress<5:0> + RAMSegmentFinalAddress<9:8>
                    'RAMSegmentModeControl + NoDwellActive + RAMSegmentBeginningAddress<9:6>
                    RSCW0Str = Right(cbaseDec2Bin(AddressRampRateRS0, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS0, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS0, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS0, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS0, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS0, 3) & cbaseDec2Bin(NoDwellRS0, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS0, 10), 4)
                    
'                    Debug.Print "RSCW0"
'                    PrintDecodedRSCW RSCW0Str
                    
                    'Calculate the RSCW1 Register
                    RSCW1Str = Right(cbaseDec2Bin(AddressRampRateRS1, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS1, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS1, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS1, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS1, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS1, 3) & cbaseDec2Bin(NoDwellRS1, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS1, 10), 4)
                    
'                    Debug.Print "RSCW1"
'                    PrintDecodedRSCW RSCW1Str
                
                    'Calculate the RSCW2 Register
                    RSCW2Str = Right(cbaseDec2Bin(AddressRampRateRS2, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS2, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS2, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS2, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS2, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS2, 3) & cbaseDec2Bin(NoDwellRS2, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS2, 10), 4)
                    
'                    Debug.Print "RSCW2"
'                    PrintDecodedRSCW RSCW2Str
                
                    'Calculate the RSCW2 Register
                    RSCW3Str = Right(cbaseDec2Bin(AddressRampRateRS3, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS3, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS3, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS3, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS3, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS3, 3) & cbaseDec2Bin(NoDwellRS3, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS3, 10), 4)
                    
'                    Debug.Print "RSCW3"
'                    PrintDecodedRSCW RSCW3Str
                    
                    '*** Now Load the RAM Data into the RAM for RSCW0 ***
                    'Store the old profile
                    TmpProfile_DUT1 = GetActiveProfile(1)
                    TmpProfile_DUT2 = GetActiveProfile(2)
                    
                    'Write to the RSCW0 Register
                    SerialLoad DUTNum, &H7, RSCW0Str
                    'Set the profile to write to the correct RAM Segment
                    If UseRS0 Then
                        SetActiveProfile DUTNum, 1
                        'Delay
                                                
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStep = 1
                            CntrStop = ((FinalAddressRS0 - StartAddressRS0) + 1)
                        Else
                            CntrStart = ((FinalAddressRS0 - StartAddressRS0) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                                                
                        'Initiate a Upload
                        RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            RAMWritePacket DUTNum, RamSegment0Data(cntr - 1)
                        Next cntr
                        'Terminate the upload
                        RAMTerminateUpload DUTNum
                    End If
                    
                    'Write to the RSCW1 Register
                    SerialLoad DUTNum, &H8, RSCW1Str
                    '*** Now Load the RAM Data into the RAM for RSCW1 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS1 Then
                        SetActiveProfile DUTNum, 2
                        'Delay
                        
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS1 - StartAddressRS1) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS1 - StartAddressRS1) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                                                
                        'Initiate a Upload
                        RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            RAMWritePacket DUTNum, RamSegment1Data(cntr - 1)
                        Next cntr
                        
                        'Terminate the upload
                        RAMTerminateUpload DUTNum
                    End If
                    
                    'Write to the RSCW2 Register
                    SerialLoad DUTNum, &H9, RSCW2Str
                    '*** Now Load the RAM Data into the RAM for RSCW2 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS2 Then
                        SetActiveProfile DUTNum, 3
                        'Delay
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS2 - StartAddressRS2) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS2 - StartAddressRS2) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                                                
                        'Initiate a Upload
                        RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            RAMWritePacket DUTNum, RamSegment2Data(cntr - 1)
                        Next cntr
                        
                        'Terminate the upload
                        RAMTerminateUpload DUTNum
                    End If
                    
                    'Write to the RSCW3 Register
                    SerialLoad DUTNum, &HA, RSCW3Str
                    '*** Now Load the RAM Data into the RAM for RSCW3 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS3 Then
                        'Set the proper profile
                        SetActiveProfile DUTNum, 4
                        'Delay
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS3 - StartAddressRS3) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS3 - StartAddressRS3) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                        'Initiate a Upload
                        RAMInitUpload DUTNum
                                                
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            RAMWritePacket DUTNum, RamSegment3Data(cntr - 1)
                        Next cntr
                        
                        'Terminate the upload
                        RAMTerminateUpload DUTNum
                    End If
                    
'                    Select Case DUTNum
'                        Case 1:
'                            'Automatically do a frequency update if the option is true
'                            If mvarAutoFUD_DUT1 = True Then
'                                FUD_DUT1 = abvHigh
'                                WriteEvbBuffVal evb59Buff1
'                                FUD_DUT1 = abvLow
'                                WriteEvbBuffVal evb59Buff1
'                            End If
'                        Case 2:
'                            'Automatically do a frequency update if the option is true
'                            If mvarAutoFUD_DUT2 = True Then
'                                FUD_DUT2 = abvHigh
'                                WriteEvbBuffVal evb59Buff1
'                                FUD_DUT2 = abvLow
'                                WriteEvbBuffVal evb59Buff1
'                            End If
'                        Case Else:
'                            'Automatically do a frequency update if the option is true
'                            If mvarAutoFUD_DUT1 = True Then
'                                FUD_DUT1 = abvHigh
'                                WriteEvbBuffVal evb59Buff1
'                                FUD_DUT1 = abvLow
'                                WriteEvbBuffVal evb59Buff1
'                            End If
'                            'Automatically do a frequency update if the option is true
'                            If mvarAutoFUD_DUT2 = True Then
'                                FUD_DUT2 = abvHigh
'                                WriteEvbBuffVal evb59Buff1
'                                FUD_DUT2 = abvLow
'                                WriteEvbBuffVal evb59Buff1
'                            End If
'                    End Select
                    
                    '*****  This is a required to make the loaded profiles work *****
                    'We need to send at lease 1 sclk to make the loaded profiles work
                    Select Case DUTNum
                        Case 1
                            dummystr = SerialRead(1, &H2)
                        Case 2
                            dummystr = SerialRead(2, &H2)
                        Case Else
                            dummystr = SerialRead(1, &H2)
                            dummystr = SerialRead(2, &H2)
                    End Select
                                        
                    'Restore the old profile
                    SetActiveProfile 1, TmpProfile_DUT1
                    SetActiveProfile 2, TmpProfile_DUT2
                Else
                    'Error message
                    MsgBox "Error: Invalid RAM File.", vbApplicationModal + vbCritical, "File Load Error!"
                End If
                                
            Else
                'Specified File Does Not Exist
                MsgBox "Error: RAM File not found.", vbApplicationModal, "Error: SUB RAMLoadFile()"
            End If
        End If
    End If
        
    'Set the screen cursor to the defualt
    Screen.MousePointer = 0
        
    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case 62:
            'Display an error message
            MsgBox "LOAD ERROR:  Bad RAM File, or Incomplete RAM File!", vbCritical + vbApplicationModal, "Critical File Load Error!"
            Close #FileHandle
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMLoadFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select
        
    'Set the screen cursor to the defualt
    Screen.MousePointer = 0
End Sub
'Loads a RAM File
Public Sub RAMLoadFileSeg(ByVal DUTNum As Integer, ByVal RAMSegment As Integer, ByVal RamFile As String)
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim DummyDbl As Double
    Dim cntr As Integer
    Dim CntrStart As Integer
    Dim CntrStop As Integer
    Dim CntrStep As Integer
    
    Dim FileType As String
    Dim FileRevNum As Double
    Dim TempDataStr As String
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer
    
    Dim ModeCntrl As Integer
    Dim NoDwell As Integer
    Dim StartAddress As Integer
    Dim FinalAddress As Integer
    Dim AddressRampRate As Long
        
    Dim RamSegmentData() As String
    
    Dim RSCWStr As String 'RAM Segment String
    
    Dim RSCRAddr As Integer
    Dim LoadProfile As Integer
    
    'Setup an error handler
    On Error GoTo ErrorHandler:
        
    'Set the screen cursor to hourglass
    Screen.MousePointer = 11
        
    If mvarEnabled = True Then
        'If writing to both DUTs make sure that both are in the same IOMode
        If (DUTNum <> 1 And DUTNum <> 2) And (LSBFirstDUT1 <> LSBFirstDUT2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: To write to both DUT's simultaniously the LSB First bit must be the same for both DUTs.", vbApplicationModal, "Error: SUB RAMLoadFile()"
        Else
            If RAMSegment <= 0 And RAMSegment >= 3 Then
                dummystr = "Invalid RAMSegment specified." & vbCrLf & "The RAM Segment must equal 0,1,2, or 3." & vbCrLf & "RAM Segment was not loaded."
                MsgBox dummystr, vbApplicationModal + vbCritical + vbOKOnly, "RAM Segment Load Error!"
            Else
                'If the number of bytes to send is different than the number of bytes
                'present in the data passed then exit the sub
                If (FileExists(RamFile)) Then
                    'Get a sharable file handle
                    FileHandle = FreeFile(1)
                    
                    'Open the file
                    Open RamFile For Input As #FileHandle
                    
                    'Read the file header back
                    Input #FileHandle, FileType, FileRevNum
                    'Make sure its a valid file
                    If FileType = "AD9859 RAM Segment Configuration File" And FileRevNum = 1 Then
                        'Trash the next 4 lines
                        Input #FileHandle, dummystr
                        Input #FileHandle, dummystr, dummystr
                        Input #FileHandle, dummystr
                        Input #FileHandle, dummystr
                        
                        'Read the RSCW0 Info
                        Input #FileHandle, dummystr, ModeCntrl
                        Input #FileHandle, dummystr, NoDwell
                        Input #FileHandle, dummystr, StartAddress
                        Input #FileHandle, dummystr, FinalAddress
                        Input #FileHandle, dummystr, AddressRampRate
                        
                        'Trash 4 More Lines
                        Input #FileHandle, dummystr
                        Input #FileHandle, dummystr
                        Input #FileHandle, dummystr
                        Input #FileHandle, dummystr
                        
                        'Resize the array
                        ReDim RamSegmentData((FinalAddress - StartAddress) + 1)
                        
                        'Read in the data from the file
                        For cntr = 1 To ((FinalAddress - StartAddress) + 1)
                            'Read the binary data in
                            Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                            'Remove the spaces
                            RamSegmentData(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                        Next cntr
                    
                        ' Close before reopening in another mode.
                        Close #FileHandle
                        
                        '*** All data was read correctly - Now Program The DUT(s) ****
                        'First program the RSCW Registers
                        'Build the binary string for the RSCW in MSB format
                        'RAMSegmentAddressRampRate<7:0> + RAMSegmentAddressRampRate<15:8> +
                        'RAMSegmentFinalAddress<7:0> +
                        'RAMSegmentBeginningAddress<5:0> + RAMSegmentFinalAddress<9:8>
                        'RAMSegmentModeControl + NoDwellActive + RAMSegmentBeginningAddress<9:6>
                        RSCWStr = Right(cbaseDec2Bin(AddressRampRate, 16), 8) & _
                                      Left(cbaseDec2Bin(AddressRampRate, 16), 8) & _
                                      Right(cbaseDec2Bin(FinalAddress, 10), 8) & _
                                      Right(cbaseDec2Bin(StartAddress, 10), 6) & _
                                      Left(cbaseDec2Bin(FinalAddress, 10), 2) & _
                                      cbaseDec2Bin(ModeCntrl, 3) & cbaseDec2Bin(NoDwell, 1) & _
                                      Left(cbaseDec2Bin(StartAddress, 10), 4)
                        
                        
                        '*** Now Load the RAM Data into the RAM for RSCW0 ***
                        'Store the old profile
                        TmpProfile_DUT1 = GetActiveProfile(1)
                        TmpProfile_DUT2 = GetActiveProfile(2)
                        
                        Select Case RAMSegment
                            Case 0:
                                RSCRAddr = &H7
                                LoadProfile = 1
                            Case 1:
                                RSCRAddr = &H8
                                LoadProfile = 2
                            Case 2:
                                RSCRAddr = &H9
                                LoadProfile = 3
                            Case 3:
                                RSCRAddr = &HA
                                LoadProfile = 4
                        End Select
                        
                        'Write to the RSCW0 Register
                        SerialLoad DUTNum, RSCRAddr, RSCWStr
                        
                        'Set the profile to write to the correct RAM Segment
'                        If UseRS0 Then
                            SetActiveProfile DUTNum, LoadProfile
                            'Delay
                                                    
                            'Load the RAM out in the right order
                            If LSBFirstDUT1 Then
                                CntrStart = 1
                                CntrStep = 1
                                CntrStop = ((FinalAddress - StartAddress) + 1)
                            Else
                                CntrStart = ((FinalAddress - StartAddress) + 1)
                                CntrStop = 1
                                CntrStep = -1
                            End If
                                                    
                            'CRAM the RAM in 32 Bit Chunks
                            'Initiate a Upload
                            RAMInitUpload DUTNum
                            'Upload 32 bits at a time
                            For cntr = CntrStart To CntrStop Step CntrStep
                                RAMWritePacket DUTNum, RamSegmentData(cntr - 1)
                            Next cntr
                            'Terminate the upload
                            RAMTerminateUpload DUTNum
'                        End If
                        
                        '*****  This is a required to make the loaded profiles work *****
                        'We need to send at lease 1 sclk to make the loaded profiles work
                        'So just do a read of a register and this will provide the SCLK to
                        'do the job
                        Select Case DUTNum
                            Case 1
                                dummystr = SerialRead(1, &H2)
                            Case 2
                                dummystr = SerialRead(2, &H2)
                            Case Else
                                dummystr = SerialRead(1, &H2)
                                dummystr = SerialRead(2, &H2)
                        End Select
                                            
                        'Restore the old profile
                        SetActiveProfile 1, TmpProfile_DUT1
                        SetActiveProfile 2, TmpProfile_DUT2
                    Else
                        'Error message
                        MsgBox "Error: Invalid RAM File.", vbApplicationModal + vbCritical, "File Load Error!"
                    End If
                Else
                    'Specified File Does Not Exist
                    MsgBox "Error: RAM File not found.", vbApplicationModal, "Error: SUB RAMLoadFile()"
                End If
            End If
        End If
    End If
        
    'Set the screen cursor to the defualt
    Screen.MousePointer = 0
        
    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case 62:
            'Display an error message
            MsgBox "LOAD ERROR:  Bad RAM File, or Incomplete RAM File!", vbCritical + vbApplicationModal, "Critical File Load Error!"
            Close #FileHandle
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMLoadFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select
        
    'Set the screen cursor to the defualt
    Screen.MousePointer = 0
End Sub

'RamFile
Public Sub RAMDumpFileOld(ByVal DUTNum As Integer, ByVal RamFile As String, ByVal sFileDescrptn As String)
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim DummyDbl As Double
    Dim TempInt As Integer
    Dim cntr As Integer
    Dim cntr1 As Integer
    Dim FileType As String
    Dim FileRevNum As Double
    Dim TempDataStr As String
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer
    Dim Packets2DownLoad As Integer
    
    Dim ModeCntrlRS0 As Integer
    Dim NoDwellRS0 As Integer
    Dim StartAddressRS0 As Integer
    Dim FinalAddressRS0 As Integer
    Dim AddressRampRateRS0 As Long
    
    Dim ModeCntrlRS1 As Integer
    Dim NoDwellRS1 As Integer
    Dim StartAddressRS1 As Integer
    Dim FinalAddressRS1 As Integer
    Dim AddressRampRateRS1 As Long
    
    Dim ModeCntrlRS2 As Integer
    Dim NoDwellRS2 As Integer
    Dim StartAddressRS2 As Integer
    Dim FinalAddressRS2 As Integer
    Dim AddressRampRateRS2 As Long
    
    Dim ModeCntrlRS3 As Integer
    Dim NoDwellRS3 As Integer
    Dim StartAddressRS3 As Integer
    Dim FinalAddressRS3 As Integer
    Dim AddressRampRateRS3 As Long
        
    Dim RamSegment0Data() As String
    Dim RamSegment1Data() As String
    Dim RamSegment2Data() As String
    Dim RamSegment3Data() As String
    
    Dim RSCntrStart As Integer
    Dim RSCntrStop As Integer
    Dim RSCntrStep As Integer
    
    'Setup an error handler
    On Error GoTo ErrorHandler:
    
    If mvarEnabled = True Then
        'If reading from both DUTs then your about to get a nasty message, because your trying to do something that is not possible
        If (DUTNum <> 1 And DUTNum <> 2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: You can only read from 1 DUT at a time.", vbApplicationModal, "Error: SUB RAMDumpFile()"
        Else
            'Get the active profiles
            TmpProfile_DUT1 = GetActiveProfile(DUTNum)
            
            'Get a sharable file handle
            FileHandle = FreeFile(1)
            
'**************** Ram Segment 0 Data Readback Start ****************
            
            'Set to profile 1 to read back RSCW0
            EvalBd.SetActiveProfile DUTNum, 1
'            Delay
            
            'Read the data from the DUT to write the file.
            dummystr = EvalBd.SerialRead(DUTNum, &H7)
            
            'Decode the nonlogical data arangement of the RSCW Registers
            ModeCntrlRS0 = cbaseBinS2Dec(Mid(dummystr, 33, 3))
            NoDwellRS0 = cbaseBinS2Dec(Mid(dummystr, 36, 1))
            StartAddressRS0 = cbaseBinS2Dec(Mid(dummystr, 37, 4) & Mid(dummystr, 25, 6))
            FinalAddressRS0 = cbaseBinS2Dec(Mid(dummystr, 31, 2) & Mid(dummystr, 17, 8))
            AddressRampRateRS0 = cbaseBinS2Dec(Mid(dummystr, 9, 8) & Mid(dummystr, 1, 8))
            
            'Read back the RAM Segment Data
            If FinalAddressRS0 = StartAddressRS0 Then
                Packets2DownLoad = 1
            Else
                Packets2DownLoad = FinalAddressRS0 - StartAddressRS0 + 1
            End If
            
            'Resize the RAM Segment Data buffer
            ReDim RamSegment0Data(0 To Packets2DownLoad - 1)
            
            'Get the data from the DUT
            If RAMInitDownload(DUTNum) Then
                'Download the ram data
                For cntr = 1 To Packets2DownLoad
                    RamSegment0Data(cntr - 1) = RAMReadPacket(DUTNum)
                Next cntr
                
                'Terminate the memory dump
                RAMTerminateDownload DUTNum
            Else
                'RAM Segment 1 Download failed
                MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                Exit Sub
            End If
            
'**************** Ram Segment 0 Data Readback Finished ****************
            
'**************** Ram Segment 1 Data Readback Start ****************
            
            'Set to profile 1 to read back RSCW1
            EvalBd.SetActiveProfile DUTNum, 2
'            Delay
            
            'Read the data from the DUT to write the file.
            dummystr = EvalBd.SerialRead(DUTNum, &H8)
            
            'Decode the nonlogical data arangement of the RSCW Registers
            ModeCntrlRS1 = cbaseBinS2Dec(Mid(dummystr, 33, 3))
            NoDwellRS1 = cbaseBinS2Dec(Mid(dummystr, 36, 1))
            StartAddressRS1 = cbaseBinS2Dec(Mid(dummystr, 37, 4) & Mid(dummystr, 25, 6))
            FinalAddressRS1 = cbaseBinS2Dec(Mid(dummystr, 31, 2) & Mid(dummystr, 17, 8))
            AddressRampRateRS1 = cbaseBinS2Dec(Mid(dummystr, 9, 8) & Mid(dummystr, 1, 8))
            
            'Read back the RAM Segment Data
            If FinalAddressRS1 = StartAddressRS1 Then
                Packets2DownLoad = 1
            Else
                Packets2DownLoad = FinalAddressRS0 - StartAddressRS0 + 1
            End If
            
            'Resize the RAM Segment Data buffer
            ReDim RamSegment1Data(0 To Packets2DownLoad - 1)
            
            'Get the data from the DUT
            If RAMInitDownload(DUTNum) Then
                'Download the ram data
                For cntr = 1 To Packets2DownLoad
                    RamSegment1Data(cntr - 1) = RAMReadPacket(DUTNum)
                Next cntr
                
                'Terminate the memory dump
                RAMTerminateDownload DUTNum
            Else
                'RAM Segment 1 Download failed
                MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                Exit Sub
            End If
            
'**************** Ram Segment 1 Data Readback Finished ****************
            
'**************** Ram Segment 2 Data Readback Start ****************
            
            'Set to profile 2 to read back RSCW2
            EvalBd.SetActiveProfile DUTNum, 3
'            Delay
            
            'Read the data from the DUT to write the file.
            dummystr = EvalBd.SerialRead(DUTNum, &H9)
            
            'Decode the nonlogical data arangement of the RSCW Registers
            ModeCntrlRS2 = cbaseBinS2Dec(Mid(dummystr, 33, 3))
            NoDwellRS2 = cbaseBinS2Dec(Mid(dummystr, 36, 1))
            StartAddressRS2 = cbaseBinS2Dec(Mid(dummystr, 37, 4) & Mid(dummystr, 25, 6))
            FinalAddressRS2 = cbaseBinS2Dec(Mid(dummystr, 31, 2) & Mid(dummystr, 17, 8))
            AddressRampRateRS2 = cbaseBinS2Dec(Mid(dummystr, 9, 8) & Mid(dummystr, 1, 8))
            
            'Read back the RAM Segment Data
            If FinalAddressRS2 = StartAddressRS2 Then
                Packets2DownLoad = 1
            Else
                Packets2DownLoad = FinalAddressRS0 - StartAddressRS0 + 1
            End If
            
            'Resize the RAM Segment Data buffer
            ReDim RamSegment2Data(0 To Packets2DownLoad - 1)
            
            'Get the data from the DUT
            If RAMInitDownload(DUTNum) Then
                'Download the ram data
                For cntr = 1 To Packets2DownLoad
                    RamSegment2Data(cntr - 1) = RAMReadPacket(DUTNum)
                Next cntr
                
                'Terminate the memory dump
                RAMTerminateDownload DUTNum
            Else
                'RAM Segment 1 Download failed
                MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                Exit Sub
            End If
            
'**************** Ram Segment 2 Data Readback Finished ****************
                        
'**************** Ram Segment 3 Data Readback Start ****************
            
            'Set to profile 3 to read back RSCW3
            EvalBd.SetActiveProfile DUTNum, 4
'            Delay
            
            'Read the data from the DUT to write to the file.
            dummystr = EvalBd.SerialRead(DUTNum, &HA)
            
            'Decode the nonlogical data arangement of the RSCW Registers
            ModeCntrlRS3 = cbaseBinS2Dec(Mid(dummystr, 33, 3))
            NoDwellRS3 = cbaseBinS2Dec(Mid(dummystr, 36, 1))
            StartAddressRS3 = cbaseBinS2Dec(Mid(dummystr, 37, 4) & Mid(dummystr, 25, 6))
            FinalAddressRS3 = cbaseBinS2Dec(Mid(dummystr, 31, 2) & Mid(dummystr, 17, 8))
            AddressRampRateRS3 = cbaseBinS2Dec(Mid(dummystr, 9, 8) & Mid(dummystr, 1, 8))
            
            'Read back the RAM Segment Data
            If FinalAddressRS3 = StartAddressRS3 Then
                Packets2DownLoad = 1
            Else
                Packets2DownLoad = FinalAddressRS0 - StartAddressRS0 + 1
            End If
            
            'Resize the RAM Segment Data buffer
            ReDim RamSegment3Data(0 To Packets2DownLoad - 1)
            
            'Get the data from the DUT
            If RAMInitDownload(DUTNum) Then
                'Download the ram data
                For cntr = 1 To Packets2DownLoad
                    RamSegment3Data(cntr - 1) = RAMReadPacket(DUTNum)
                Next cntr
                
                'Terminate the memory dump
                RAMTerminateDownload DUTNum
            Else
                'RAM Segment 1 Download failed
                MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                Exit Sub
            End If
            
'**************** Ram Segment 3 Data Readback Finished ****************
            
'********* Now Start Writing the data to the file ********************
            'Open the file
            Open RamFile For Output As #FileHandle
            
            'Write the file header back
            Write #FileHandle, "AD9859 RAM Configuration File", 1#
            
            'Write a spacer
            Write #FileHandle, ""
            'Write description
            Write #FileHandle, "Description", sFileDescrptn
            
            'Write a spacer
            Write #FileHandle, ""
            'Write BEGIN - RAM Segment 0
            Write #FileHandle, "BEGIN - RAM Segment 0"
            'Read the RSCW0 Info
            Write #FileHandle, "Mode Control", ModeCntrlRS0
            Write #FileHandle, "No Dwell Active", NoDwellRS0
            Write #FileHandle, "Starting Address", StartAddressRS0
            Write #FileHandle, "Final Address", FinalAddressRS0
            Write #FileHandle, "Address Ramp Rate", AddressRampRateRS0
            'Write "END - RAM Segment 0"
            Write #FileHandle, "END - RAM Segment 0"
            'Write a spacer
            Write #FileHandle, ""
            'Write the data header
            Write #FileHandle, "RAM Data"
            Write #FileHandle, "Address,Data,Hex Data,Binary Data"
            'Handle LSB and MSB Mode correctly
            'In MSB mode the first data readback is the data at RSCW(FinalAddress)
            'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
            If DUTNum = 2 Then
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment0Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment0Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            Else
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment0Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment0Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            End If
            'Start writing the real data
            cntr1 = StartAddressRS0
            For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                'Read the binary data in
                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment0Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment0Data(cntr)), 8), InsertChars(RamSegment0Data(cntr), " ", 8)
                cntr1 = cntr1 + 1
            Next cntr
            
            'Write a spacer
            Write #FileHandle, ""
            'Write BEGIN - RAM Segment 1
            Write #FileHandle, "BEGIN - RAM Segment 1"
            'Read the RSCW1 Info
            Write #FileHandle, "Mode Control", ModeCntrlRS1
            Write #FileHandle, "No Dwell Active", NoDwellRS1
            Write #FileHandle, "Starting Address", StartAddressRS1
            Write #FileHandle, "Final Address", FinalAddressRS1
            Write #FileHandle, "Address Ramp Rate", AddressRampRateRS1
            'Write "END - RAM Segment 1"
            Write #FileHandle, "END - RAM Segment 1"
            'Write a spacer
            Write #FileHandle, ""
            'Write the data header
            Write #FileHandle, "RAM Data"
            Write #FileHandle, "Address,Data,Hex Data,Binary Data"
            'Handle LSB and MSB Mode correctly
            'In MSB mode the first data readback is the data at RSCW(FinalAddress)
            'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
            If DUTNum = 2 Then
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment1Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment1Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            Else
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment1Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment1Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            End If
            'Start writing the real data
            cntr1 = StartAddressRS1
            For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                'Read the binary data in
                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment1Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment1Data(cntr)), 8), InsertChars(RamSegment1Data(cntr), " ", 8)
                cntr1 = cntr1 + 1
            Next cntr
                
            'Write a spacer
            Write #FileHandle, ""
            'Write BEGIN - RAM Segment 2
            Write #FileHandle, "BEGIN - RAM Segment 2"
            'Read the RSCW2 Info
            Write #FileHandle, "Mode Control", ModeCntrlRS2
            Write #FileHandle, "No Dwell Active", NoDwellRS2
            Write #FileHandle, "Starting Address", StartAddressRS2
            Write #FileHandle, "Final Address", FinalAddressRS2
            Write #FileHandle, "Address Ramp Rate", AddressRampRateRS2
            'Write "END - RAM Segment 2"
            Write #FileHandle, "END - RAM Segment 2"
            'Write a spacer
            Write #FileHandle, ""
            'Write the data header
            Write #FileHandle, "RAM Data"
            Write #FileHandle, "Address,Data,Hex Data,Binary Data"
            'Handle LSB and MSB Mode correctly
            'In MSB mode the first data readback is the data at RSCW(FinalAddress)
            'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
            If DUTNum = 2 Then
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment2Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment2Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            Else
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment2Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment2Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            End If
            'Start writing the real data
            cntr1 = StartAddressRS2
            For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                'Read the binary data in
                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment2Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment2Data(cntr)), 8), InsertChars(RamSegment2Data(cntr), " ", 8)
                cntr1 = cntr1 + 1
            Next cntr
            
            'Write a spacer
            Write #FileHandle, ""
            'Write BEGIN - RAM Segment 3
            Write #FileHandle, "BEGIN - RAM Segment 3"
            'Read the RSCW3 Info
            Write #FileHandle, "Mode Control", ModeCntrlRS3
            Write #FileHandle, "No Dwell Active", NoDwellRS3
            Write #FileHandle, "Starting Address", StartAddressRS3
            Write #FileHandle, "Final Address", FinalAddressRS3
            Write #FileHandle, "Address Ramp Rate", AddressRampRateRS3
            'Write "END - RAM Segment 3"
            Write #FileHandle, "END - RAM Segment 3"
            'Write a spacer
            Write #FileHandle, ""
            'Write the data header
            Write #FileHandle, "RAM Data"
            Write #FileHandle, "Address,Data,Hex Data,Binary Data"
            'Handle LSB and MSB Mode correctly
            'In MSB mode the first data readback is the data at RSCW(FinalAddress)
            'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
            If DUTNum = 2 Then
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment3Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment3Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            Else
                If LSBFirstDUT2 Then
                    RSCntrStart = 0
                    RSCntrStop = UBound(RamSegment3Data())
                    RSCntrStep = 1
                Else
                    RSCntrStart = UBound(RamSegment3Data())
                    RSCntrStop = 0
                    RSCntrStep = -1
                End If
            End If
            'Start writing the real data
            cntr1 = StartAddressRS3
            For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                'Read the binary data in
                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment3Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment3Data(cntr)), 8), InsertChars(RamSegment3Data(cntr), " ", 8)
                cntr1 = cntr1 + 1
            Next cntr
                
            'Restore the origional profile settings
            SetActiveProfile DUTNum, TmpProfile_DUT1
                
            ' Close before reopening in another mode.
            Close #FileHandle
        End If
    End If
    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMDumpFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select
End Sub

'Newer more inteligent ram dump routine
Public Sub RAMDumpFile(ByVal DUTNum As Integer, ByVal RamFile As String, ByVal sFileDescrptn As String)
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim cntr As Integer
    Dim cntr1 As Integer
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer
    Dim Packets2DownLoad As Integer

    Dim SelRamSeg As Integer
    Dim RamSegCW(0 To 3) As RSCWInfo

    Dim RamSegment0Data() As String
    Dim RamSegment1Data() As String
    Dim RamSegment2Data() As String
    Dim RamSegment3Data() As String

    Dim UseRs(0 To 3) As Boolean

    Dim UBndRSData As Integer

    Dim RSCntrStart As Integer
    Dim RSCntrStop As Integer
    Dim RSCntrStep As Integer

    Dim RAMSegAddrs(0 To 3) As Integer

    'Setup an error handler
    On Error GoTo ErrorHandler:

    RAMSegAddrs(0) = &H7
    RAMSegAddrs(1) = &H8
    RAMSegAddrs(2) = &H9
    RAMSegAddrs(3) = &HA

    If mvarEnabled = True Then
        'If reading from both DUTs then your about to get a nasty message, because your trying to do something that is not possible
        If (DUTNum <> 1 And DUTNum <> 2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: You can only read from 1 DUT at a time.", vbApplicationModal, "Error: SUB RAMDumpFile()"
        Else
            'Get the active profiles
            TmpProfile_DUT1 = GetActiveProfile(DUTNum)

            'Get a sharable file handle
            FileHandle = FreeFile(1)

'**************** Ram Readback Start ****************
            For SelRamSeg = 0 To 3

                'Set to profile 1 to read back RSCW0
                EvalBd.SetActiveProfile DUTNum, SelRamSeg + 1
    '            Delay

                'Read the data from the DUT to write the file.
                dummystr = EvalBd.SerialRead(DUTNum, RAMSegAddrs(SelRamSeg))

                'Decode the nonlogical data arangement of the RSCW Registers
                With RamSegCW(SelRamSeg)
                    DecodeRSCW dummystr, .BeginAddr, .FinalAddr, .AddressRampRate, .ModeControl, .NoDwell

                    'Read back the RAM Segment Data
                    If .FinalAddr = .BeginAddr Then
                        Packets2DownLoad = 1
                    Else
                        Packets2DownLoad = .FinalAddr - .BeginAddr + 1
                    End If
                                    
                    'Check to see if the user has set up the ram segment control words properly
                    If .BeginAddr > .FinalAddr Then
                        MsgBox "An error was found in RAM Segment Control Word #" & SelRamSeg & "." & vbCrLf & vbCrLf & "The beginning address cannot be greater than the final address.", vbCritical + vbApplicationModal, "Failed saving RAM to a file!"
                        Exit Sub
                    End If
                End With

                Select Case SelRamSeg
                    Case 0:
                        'Resize the RAM Segment Data buffer
                        ReDim RamSegment0Data(0 To Packets2DownLoad - 1)
                    Case 1:
                        'Resize the RAM Segment Data buffer
                        ReDim RamSegment1Data(0 To Packets2DownLoad - 1)
                    Case 2:
                        'Resize the RAM Segment Data buffer
                        ReDim RamSegment2Data(0 To Packets2DownLoad - 1)
                    Case 3:
                        'Resize the RAM Segment Data buffer
                        ReDim RamSegment3Data(0 To Packets2DownLoad - 1)
                End Select

                'Get the data from the DUT
                If RAMInitDownload(DUTNum) Then
                    'Download the ram data
                    For cntr = 1 To Packets2DownLoad
                        Select Case SelRamSeg
                            Case 0:
                                RamSegment0Data(cntr - 1) = RAMReadPacket(DUTNum)
                            Case 1:
                                RamSegment1Data(cntr - 1) = RAMReadPacket(DUTNum)
                            Case 2:
                                RamSegment2Data(cntr - 1) = RAMReadPacket(DUTNum)
                            Case 3:
                                RamSegment3Data(cntr - 1) = RAMReadPacket(DUTNum)
                        End Select
                    Next cntr

                    'Terminate the memory dump
                    RAMTerminateDownload DUTNum
                Else
                    'RAM Segment 1 Download failed
                    MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                    Exit Sub
                End If

            Next SelRamSeg
'**************** Ram Readback Finished ****************

'********* Now Start Writing the data to the file ********************
            'Open the file
            Open RamFile For Output As #FileHandle

            'Write the file header back
            Write #FileHandle, "AD9859 RAM Configuration File", 1#

            'Write a spacer
            Write #FileHandle, ""
            'Write description
            Write #FileHandle, "Description", sFileDescrptn

            'First assume that we will use all of the ram segments
            UseRs(0) = True
            UseRs(1) = True
            UseRs(2) = True
            UseRs(3) = True

            'Now check each one to see if it exists in another ram segment and if so
            'mark it as unused
            For SelRamSeg = 0 To 3
                For cntr1 = 0 To 3
                    'Dont even check the ram segment against it's self
                    If SelRamSeg <> cntr1 And UseRs(cntr1) Then
                        'Check each Ram Segment but don't check aginst itself
                        If RamSegCW(SelRamSeg).BeginAddr >= RamSegCW(cntr1).BeginAddr Then
                            If RamSegCW(SelRamSeg).FinalAddr <= RamSegCW(cntr1).FinalAddr Then
                                'Uses the same ram segment area mark it as unused
                                UseRs(SelRamSeg) = False
                            End If
                        End If
                    End If
                Next
            Next SelRamSeg

            For SelRamSeg = 0 To 3
                'Write a spacer
                Write #FileHandle, ""
                'Write BEGIN - RAM Segment 0-3
                Write #FileHandle, "BEGIN - RAM Segment " & SelRamSeg
                'Read the RSCW0 Info
                Write #FileHandle, "Mode Control", RamSegCW(SelRamSeg).ModeControl
                Write #FileHandle, "No Dwell Active", RamSegCW(SelRamSeg).NoDwell
                Write #FileHandle, "Starting Address", RamSegCW(SelRamSeg).BeginAddr
                Write #FileHandle, "Final Address", RamSegCW(SelRamSeg).FinalAddr
                Write #FileHandle, "Address Ramp Rate", RamSegCW(SelRamSeg).AddressRampRate
                'Write "END - RAM Segment 0-3"
                Write #FileHandle, "END - RAM Segment 0"
                'Write a spacer
                Write #FileHandle, ""
                'Write the data header
                Write #FileHandle, "RAM Data"
                Write #FileHandle, "Address,Data,Hex Data,Binary Data"

                Select Case SelRamSeg
                    Case 0:
                        UBndRSData = UBound(RamSegment0Data)
                    Case 1:
                        UBndRSData = UBound(RamSegment1Data)
                    Case 2:
                        UBndRSData = UBound(RamSegment2Data)
                    Case 3:
                        UBndRSData = UBound(RamSegment3Data)
                End Select

                If UseRs(SelRamSeg) Then
                    'Handle LSB and MSB Mode correctly
                    'In MSB mode the first data readback is the data at RSCW(FinalAddress)
                    'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
                    If DUTNum = 2 Then
                        If LSBFirstDUT2 Then
                            RSCntrStart = 0
                            RSCntrStop = UBndRSData
                            RSCntrStep = 1
                        Else
                            RSCntrStart = UBndRSData
                            RSCntrStop = 0
                            RSCntrStep = -1
                        End If
                    Else
                        If LSBFirstDUT2 Then
                            RSCntrStart = 0
                            RSCntrStop = UBndRSData
                            RSCntrStep = 1
                        Else
                            RSCntrStart = UBndRSData
                            RSCntrStop = 0
                            RSCntrStep = -1
                        End If
                    End If
                    'Start writing the real data
                    cntr1 = RamSegCW(SelRamSeg).BeginAddr
                    For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                        Select Case SelRamSeg
                            Case 0:
                                'Write a line into the ram segment file
                                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment0Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment0Data(cntr)), 8), InsertChars(RamSegment0Data(cntr), " ", 8)
                            Case 1:
                                'Write a line into the ram segment file
                                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment1Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment1Data(cntr)), 8), InsertChars(RamSegment1Data(cntr), " ", 8)
                            Case 2:
                                'Write a line into the ram segment file
                                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment2Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment2Data(cntr)), 8), InsertChars(RamSegment2Data(cntr), " ", 8)
                            Case 3:
                                'Write a line into the ram segment file
                                Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment3Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment3Data(cntr)), 8), InsertChars(RamSegment3Data(cntr), " ", 8)
                        End Select
                        cntr1 = cntr1 + 1
                    Next cntr
                Else
                    'Write a line that specifies that the ram segment data isn't used
                    Write #FileHandle, "Not Used", 0, 0, "00000000 00000000 00000000 00000000"
                End If
            Next SelRamSeg

            'Restore the origional profile settings
            SetActiveProfile DUTNum, TmpProfile_DUT1

            ' Close before reopening in another mode.
            Close #FileHandle
        End If
    End If
    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMDumpFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select
End Sub

 'Sets the register value for the register at RegAddr in the register map.
Public Sub sSetRegMapVal(ByVal DUT As Integer, ByVal RegAddr As Integer, ByVal value As String)
    Select Case DUT
        Case 1:
            sRegMapVals(0, RegAddr) = value
        Case 2:
            sRegMapVals(1, RegAddr) = value
        Case Else:
            sRegMapVals(0, RegAddr) = value
            sRegMapVals(1, RegAddr) = value
    End Select
    'Fire off the RegMapChanged event
    RaiseEvent RegMapChanged(DUT, 1, RegAddr)
End Sub

'Returns the register value for the register at RegAddr in the register map.
Public Function sGetRegMapVal(ByVal DUT As Integer, ByVal RegAddr As Integer) As String
    Select Case DUT
        Case 1:
            sGetRegMapVal = sRegMapVals(0, RegAddr)
        Case 2:
            sGetRegMapVal = sRegMapVals(1, RegAddr)
        Case Else:
            MsgBox "Error: sGetRegVal(DUT, RegAddr) - DUT must be 1 or 2.", vbExclamation + vbOKOnly, "sGetRegVal() Error"
    End Select
End Function
 'Sets the register value for the register at RegAddr in the register map.
Public Sub sSetNewRegMapVal(ByVal DUT As Integer, ByVal RegAddr As Integer, ByVal value As String)
    Select Case DUT
        Case 1:
            sRegMapValsNew(0, RegAddr) = value
        Case 2:
            sRegMapValsNew(1, RegAddr) = value
        Case Else:
            sRegMapValsNew(0, RegAddr) = value
            sRegMapValsNew(1, RegAddr) = value
    End Select
    'Fire off the RegMapChanged event
    RaiseEvent RegMapChanged(DUT, 0, RegAddr)
End Sub

'Returns the register value for the register at RegAddr in the register map.
Public Function sGetNewRegMapVal(ByVal DUT As Integer, ByVal RegAddr As Integer) As String
    Select Case DUT
        Case 1:
            sGetNewRegMapVal = sRegMapValsNew(0, RegAddr)
        Case 2:
            sGetNewRegMapVal = sRegMapValsNew(1, RegAddr)
        Case Else:
            MsgBox "Error: sGetRegVal(DUT, RegAddr) - DUT must be 1 or 2.", vbExclamation + vbOKOnly, "sGetRegVal() Error"
    End Select
End Function

'Sets the bit value for a register
Public Sub sSetNewRegMapBitVal(ByVal DUTNum As Integer, ByVal RegAddr As Integer, ByVal Bit As Integer, ByVal value As adiBinValues)
    'B7         B0
    ' 01000000
    'C1         C8
    
    Dim RegVal As String
    Dim NewRegVal As String
    Dim BitVal As String
    
    Dim numbits As Integer
    
    
    If value = abvHigh Then
        BitVal = "1"
    Else
        BitVal = "0"
    End If
    
    Select Case DUTNum
        Case 1:
            'Get the value of the register
            RegVal = sRegMapValsNew(DUTNum - 1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapValsNew(DUTNum - 1, RegAddr) = NewRegVal
        Case 2:
            'Get the value of the register
            RegVal = sRegMapValsNew(DUTNum - 1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapValsNew(DUTNum - 1, RegAddr) = NewRegVal
        Case Else:
            'Get the value of the register
            RegVal = sRegMapValsNew(0, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapValsNew(0, RegAddr) = NewRegVal
        
            'Get the value of the register
            RegVal = sRegMapValsNew(1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapValsNew(1, RegAddr) = NewRegVal
    End Select
    
    'Fire off the RegMapChanged event
    RaiseEvent RegMapChanged(DUTNum, 0, RegAddr)
End Sub
'Sets the bit value for a register
Public Sub sSetRegMapBitVal(ByVal DUTNum As Integer, ByVal RegAddr As Integer, ByVal Bit As Integer, ByVal value As adiBinValues)
    'B7         B0
    ' 01000000
    'C1         C8
    
    Dim RegVal As String
    Dim NewRegVal As String
    Dim BitVal As String
    
    Dim numbits As Integer
    
    
    If value = abvHigh Then
        BitVal = "1"
    Else
        BitVal = "0"
    End If
    
    Select Case DUTNum
        Case 1:
            'Get the value of the register
            RegVal = sRegMapVals(DUTNum - 1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapVals(DUTNum - 1, RegAddr) = NewRegVal
        Case 2:
            'Get the value of the register
            RegVal = sRegMapVals(DUTNum - 1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapVals(DUTNum - 1, RegAddr) = NewRegVal
        Case Else:
            'Get the value of the register
            RegVal = sRegMapVals(0, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapVals(0, RegAddr) = NewRegVal
        
            'Get the value of the register
            RegVal = sRegMapVals(1, RegAddr)
            'Get the bit length of the string to modify
            numbits = Len(RegVal)
            'Build the new value
            NewRegVal = Mid(RegVal, 1, numbits - Bit - 1) & BitVal & Mid(RegVal, numbits - Bit + 1, Bit)
            'Insert it into the buffer array
            sRegMapVals(1, RegAddr) = NewRegVal
    End Select
    
    'Fire off the RegMapChanged event
    RaiseEvent RegMapChanged(DUTNum, 1, RegAddr)
End Sub
'Returns the bit value for a register.
Public Function sGetNewRegMapBitVal(ByVal DUT As Integer, ByVal RegAddr As Integer, ByVal Bit As Integer) As adiBinValues
    'B7         B0
    ' 01000000
    'C1         C8
    Dim BitVal As String
    Dim numbits As Integer
    
    'Get the number of bits in the register value word
    numbits = Len(sRegMapValsNew(DUT - 1, RegAddr))
    
    'Get the value of the register
    BitVal = Mid(sRegMapValsNew(DUT - 1, RegAddr), numbits - Bit, 1)
    
    If BitVal = "1" Then
        sGetNewRegMapBitVal = abvHigh
    Else
        sGetNewRegMapBitVal = abvLow
    End If
    
End Function

'Returns the bit value for a register.
'Bit - Bit0 to Regsize-1
'DUT - 1,2
'RegAddr - Valid Register Address
Public Function sGetRegMapBitVal(ByVal DUT As Integer, ByVal RegAddr As Integer, ByVal Bit As Integer) As adiBinValues
    'B7         B0
    ' 01000000
    'C1         C8
    Dim BitVal As String
    Dim numbits As Integer
    
    'Get the number of bits in the register value word
    numbits = Len(sRegMapVals(DUT - 1, RegAddr))
    
    'Get the value of the register
    BitVal = Mid(sRegMapVals(DUT - 1, RegAddr), numbits - Bit, 1)
    
    If BitVal = "1" Then
        sGetRegMapBitVal = abvHigh
    Else
        sGetRegMapBitVal = abvLow
    End If
    
End Function

'Returns the bit value for a register.

'Resets the register map buffers to their default values
Public Sub ResetREGMAP(ByVal DUTNum As Integer)
    Dim cntr As Integer
    
    Select Case DUTNum
        Case 1:
            'Clear out the register map values for DUT1
            sRegMapVals(0, 0) = String(32, "0")
            sRegMapVals(0, 1) = String(24, "0")
            sRegMapVals(0, 4) = String(32, "0")
            sRegMapVals(0, 5) = String(16, "0")
            sRegMapVals(0, 6) = String(32, "0")
            sRegMapVals(0, 12) = cbaseDec2Bin(&H59000800, 32)
        
            'Clear out the register map values for DUT1
            sRegMapValsNew(0, 0) = String(32, "0")
            sRegMapValsNew(0, 1) = String(24, "0")
            sRegMapValsNew(0, 4) = String(32, "0")
            sRegMapValsNew(0, 5) = String(16, "0")
            sRegMapValsNew(0, 6) = String(32, "0")
            sRegMapValsNew(0, 12) = cbaseDec2Bin(&H59000800, 32)
            
            'Resync Register map values buffers
            sRegMapValsNew(0, 2) = sRegMapVals(0, 2)
            sRegMapValsNew(0, 3) = sRegMapVals(0, 3)
            sRegMapValsNew(0, 7) = sRegMapVals(0, 7)
            sRegMapValsNew(0, 8) = sRegMapVals(0, 8)
            sRegMapValsNew(0, 9) = sRegMapVals(0, 9)
            sRegMapValsNew(0, 10) = sRegMapVals(0, 10)
            sRegMapValsNew(0, 11) = sRegMapVals(0, 11)
            
        Case 2:
            'Clear out the register map values for DUT2
            sRegMapVals(1, 0) = String(32, "0")
            sRegMapVals(1, 1) = String(24, "0")
            sRegMapVals(1, 4) = String(32, "0")
            sRegMapVals(1, 5) = String(16, "0")
            sRegMapVals(1, 6) = String(32, "0")
            sRegMapVals(1, 12) = cbaseDec2Bin(&H59000800, 32)
        
            'Clear out the register map values for DUT2
            sRegMapValsNew(1, 0) = String(32, "0")
            sRegMapValsNew(1, 1) = String(24, "0")
            sRegMapValsNew(1, 4) = String(32, "0")
            sRegMapValsNew(1, 5) = String(16, "0")
            sRegMapValsNew(1, 6) = String(32, "0")
            sRegMapValsNew(1, 12) = cbaseDec2Bin(&H59000800, 32)
            
            'Resync Register map values buffers
            sRegMapValsNew(1, 2) = sRegMapVals(1, 2)
            sRegMapValsNew(1, 3) = sRegMapVals(1, 3)
            sRegMapValsNew(1, 7) = sRegMapVals(1, 7)
            sRegMapValsNew(1, 8) = sRegMapVals(1, 8)
            sRegMapValsNew(1, 9) = sRegMapVals(1, 9)
            sRegMapValsNew(1, 10) = sRegMapVals(1, 10)
            sRegMapValsNew(1, 11) = sRegMapVals(1, 11)
        
        Case Else:
            'Clear out the register map values for DUT1
            sRegMapVals(0, 0) = String(32, "0")
            sRegMapVals(0, 1) = String(24, "0")
            sRegMapVals(0, 4) = String(32, "0")
            sRegMapVals(0, 5) = String(16, "0")
            sRegMapVals(0, 6) = String(32, "0")
            sRegMapVals(0, 12) = cbaseDec2Bin(&H59000800, 32)
        
            'Clear out the register map values for DUT1
            sRegMapValsNew(0, 0) = String(32, "0")
            sRegMapValsNew(0, 1) = String(24, "0")
            sRegMapValsNew(0, 4) = String(32, "0")
            sRegMapValsNew(0, 5) = String(16, "0")
            sRegMapValsNew(0, 6) = String(32, "0")
            sRegMapValsNew(0, 12) = cbaseDec2Bin(&H59000800, 32)
            
            'Resync Register map values buffers
            sRegMapValsNew(0, 2) = sRegMapVals(0, 2)
            sRegMapValsNew(0, 3) = sRegMapVals(0, 3)
            sRegMapValsNew(0, 7) = sRegMapVals(0, 7)
            sRegMapValsNew(0, 8) = sRegMapVals(0, 8)
            sRegMapValsNew(0, 9) = sRegMapVals(0, 9)
            sRegMapValsNew(0, 10) = sRegMapVals(0, 10)
            sRegMapValsNew(0, 11) = sRegMapVals(0, 11)
        
            'Clear out the register map values for DUT2
            sRegMapVals(1, 0) = String(32, "0")
            sRegMapVals(1, 1) = String(24, "0")
            sRegMapVals(1, 4) = String(32, "0")
            sRegMapVals(1, 5) = String(16, "0")
            sRegMapVals(1, 6) = String(32, "0")
            sRegMapVals(1, 12) = cbaseDec2Bin(&H59000800, 32)
        
            'Clear out the register map values for DUT2
            sRegMapValsNew(1, 0) = String(32, "0")
            sRegMapValsNew(1, 1) = String(24, "0")
            sRegMapValsNew(1, 4) = String(32, "0")
            sRegMapValsNew(1, 5) = String(16, "0")
            sRegMapValsNew(1, 6) = String(32, "0")
            sRegMapValsNew(1, 12) = cbaseDec2Bin(&H59000800, 32)
            
            'Resync Register map values buffers
            sRegMapValsNew(1, 2) = sRegMapVals(1, 2)
            sRegMapValsNew(1, 3) = sRegMapVals(1, 3)
            sRegMapValsNew(1, 7) = sRegMapVals(1, 7)
            sRegMapValsNew(1, 8) = sRegMapVals(1, 8)
            sRegMapValsNew(1, 9) = sRegMapVals(1, 9)
            sRegMapValsNew(1, 10) = sRegMapVals(1, 10)
            sRegMapValsNew(1, 11) = sRegMapVals(1, 11)
    End Select
End Sub

'Return the number of DUTs that were installed on the Eval Board
'Assumes that the DetectDuts method was run
Public Property Get DutsInstalled() As Integer
    'Thats it just return the duts that were detected.
    DutsInstalled = mvar_DUTsDetected
End Property
'Do nothing
Public Property Let DutsInstalled(ByVal vNewValue As Integer)

End Property

'Detects the DUTs and returns 1 if DUT1 only is detected,
'returns 2 if DUT2 only is detected, returns 3 of both
'DUTs are detected and returns 0 if no DUTs are detected.
Public Function DetectDUTs() As Integer
    Dim TestValue As String
    Dim TestValue1 As String
    Dim TestRead As String
    Dim ReturnValue As Integer
    
    'Initialize the test value to a ramdom value
'    TestValue = "10101110101011111010101011100000"
'    TestValue1 = "00000000111111110000111100110011"
    TestValue = "01011001"
    TestValue1 = "00001000"
    
    ReturnValue = 0
    
    'Reset both duts at once
    ResetDUT (0)
    
    'Reset both duts at once
'    ResetDUT (0)

    'Test DUT1
'    SerialLoad 0, &H6 TestValue  'Write it twice?  Don't know why but you have to.
    TestRead = SerialRead(1, &HC)
    If Left(TestRead, 8) = TestValue Then
'        SerialLoad 1, &H6, TestValue1
'        TestRead = SerialRead(1, &H6)
        If Mid(TestRead, 17, 8) = TestValue1 Then
            ReturnValue = 1
        End If
    End If
    
    'Test DUT2
    TestRead = SerialRead(2, &HC)
    If Left(TestRead, 8) = TestValue Then
'        SerialLoad 2, &H6, TestValue1
'        TestRead = SerialRead(2, &H6)
        If Mid(TestRead, 17, 8) = TestValue1 Then
            'if return value is = 1 then dut1 was found
            If ReturnValue = 1 Then
                ReturnValue = 3
            Else
                ReturnValue = 2
            End If
        End If
    End If
    'Return the return value
    DetectDUTs = ReturnValue
    'Store the value for the detected DUTs'
    mvar_DUTsDetected = DetectDUTs
End Function

'Initializes the Eval Board and syncronizes it with the
'PC parallel port
Public Sub InitEvalBoard()
    'Clear out all buffers
    WriteEvbBuffVal evb59Buff1, 0
    WriteEvbBuffVal evb59Buff2, 0
    WriteEvbBuffVal evb59Buff3, 0
    
    'Initialize the evalboard
    CSB_DUT1 = abvHigh
    CSB_DUT2 = abvHigh
    'Write the changes to the buffer
    WriteEvbBuffVal evb59Buff3
    
    RB_Enable = abvLow
    Clock_A = abvHigh
    Clock_D = abvHigh
    Clock_F = abvHigh
End Sub

'Detects the eval board by toggling the SCLK line and reading back the value on SCLK1
'Returns true if detected and false if not
Public Function DetectEvalBoard() As Boolean
    'Take SCLK high
    SCLK = abvHigh
    WriteEvbBuffVal evb59Buff3
    If SCLK1 = abvHigh Then
        'Take SCLK low
        SCLK = abvLow
        WriteEvbBuffVal evb59Buff3
        If SCLK1 = abvLow Then
            DetectEvalBoard = True
        Else
            DetectEvalBoard = False
        End If
    End If
End Function


'Decodes the RAM Segment Control Word
Public Sub PrintDecodedRSCW(ByVal RSCW As String)
    Dim MSWord As String
    Dim LSWord As String
    Dim BinWord As String
    Dim a As Variant
    
    'Extract the Beginning Address
    LSWord = Mid(RSCW, 25, 6)
    MSWord = Right(RSCW, 4)
    Debug.Print "Beginning Addr: " & CStr(cbaseBinS2Dec(MSWord & LSWord))
    
    
    
    'Extract the Final Address
    MSWord = Mid(RSCW, 31, 2)
    LSWord = Mid(RSCW, 17, 8)
    Debug.Print "Final Addr: " & CStr(cbaseBinS2Dec(MSWord & LSWord))

    'Extract the Ramp Rate
    LSWord = Left(RSCW, 16)
    MSWord = Right(LSWord, 8)
    LSWord = Left(LSWord, 8)
    a = cbaseBinS2Dec(MSWord & LSWord)
    Debug.Print "Ramp Rate: " & CStr(a)
    
    'Extract the Mode control
    Debug.Print "Mode Control: " & CStr(cbaseBinS2Dec(Mid(RSCW, 33, 3)))
    
    'Extract the NoDwell bit
    Debug.Print "No Dwell: " & cbaseBinS2Dec(Mid(RSCW, 36, 1))
End Sub

'Decodes the RAM Segment Control Word
Private Sub DecodeRSCW(ByVal RSCW As String, BegAddr As Integer, FnlAddr As Integer, AddrRR As Long, ModeCtrl As Integer, NoDwell As Long)
    Dim MSWord As String
    Dim LSWord As String
    Dim BinWord As String
    
    'Extract the Beginning Address
    LSWord = Mid(RSCW, 25, 6)
    MSWord = Right(RSCW, 4)
    BegAddr = CStr(cbaseBinS2Dec(MSWord & LSWord))
    
    'Extract the Final Address
    MSWord = Mid(RSCW, 31, 2)
    LSWord = Mid(RSCW, 17, 8)
    FnlAddr = CStr(cbaseBinS2Dec(MSWord & LSWord))

    'Extract the Ramp Rate
    LSWord = Left(RSCW, 16)
    MSWord = Right(LSWord, 8)
    LSWord = Left(LSWord, 8)
    AddrRR = CStr(cbaseBinS2Dec(MSWord & LSWord))
    
    'Extract the Mode control
    ModeCtrl = cbaseBinS2Dec(Mid(RSCW, 33, 3))
    
    'Extract the NoDwell bit
    NoDwell = cbaseBinS2Dec(Mid(RSCW, 36, 1))
End Sub

'Inputs the values to be encoded and outputs a proper RSCW
Private Function EncodeRSCW(BegAddr As Integer, FnlAddr As Integer, AddrRR As Long, ModeCtrl As Integer, NoDwell As Integer) As String
    EncodeRSCW = Right(cbaseDec2Bin(AddrRR, 16), 8) & _
                 Left(cbaseDec2Bin(AddrRR, 16), 8) & _
                 Right(cbaseDec2Bin(FnlAddr, 10), 8) & _
                 Right(cbaseDec2Bin(BegAddr, 10), 6) & _
                 Left(cbaseDec2Bin(FnlAddr, 10), 2) & _
                 cbaseDec2Bin(ModeCtrl, 3) & cbaseDec2Bin(NoDwell, 1) & _
                 Left(cbaseDec2Bin(BegAddr, 10), 4)
End Function


'Input: DutNum - DUT write data to 1,2 or Any Other Value - To write to both DUTs
'Assumes that if you are writing to both DUTs that the LSB First Bit in CFR1
'is the same for both DUTs.
Public Sub FastSerialLoad(ByVal DUTNum As Integer, ByVal Address As Integer, ByVal Data As String)
    Dim sInstructByte As String
    Dim sData As String
    Dim cntr As Integer
    Dim NumBytes As Integer

    Dim OutputByte As Integer 'The Byte to output
    Dim OpQue As Long 'The OP Que for the Driver X Driver

    'Only work if the object is enabled
    If mvarEnabled = True Then
        'Get the number of bytes sent
        NumBytes = sRegSize(Address)

        'allocate a opqueue for the driver x driver
        OpQue = frmLPTSelect.dxcParallelPort.AllocateOpQueue(0, 100, 0)

        'If writing to both DUTs make sure that both are in the same IOMode
        If (DUTNum <> 1 And DUTNum <> 2) And (LSBFirstDUT1 <> LSBFirstDUT2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: To write to both DUT's simultaniously the LSB First bit must be the same for both DUTs.", vbApplicationModal, "Error: SUB Serial Load"
        Else
            'If the number of bytes to send is different than the number of bytes
            'present in the data passed then exit the sub
            If (NumBytes = (Len(Data) / 8)) And (Address >= 0 And Address <= &HC) Then

                'Build the instruction byte
                sInstructByte = "0000" & cbaseDec2Bin(Address, 4)
                sData = Data

                'Set SCLK Low before csb goes low so that we will know its
                'state
                SCLK = abvLow
                'Strobe the Clock_F line latching in the data
                'Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3

                'First take the CSB line low and check for LSB Frist Mode
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvLow
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT1 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                    Case 2
                        CSB_DUT2 = abvLow
                        'Check to see if the part is currently in LSB First Mode
                        If LSBFirstDUT2 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                    Case Else
                        CSB_DUT1 = abvLow
                        CSB_DUT2 = abvLow
                        'Assume that DUT1 and DUT2 are set the same and check for
                        'LSB First mode on DUT1
                        If LSBFirstDUT1 Then
                            'Rearrange the instruction byte into LSB First format
                            sInstructByte = FlipString(sInstructByte)
                            'Rearrange the data into LSB First format
                            sData = FlipString(sData)
                        End If
                End Select
                'Strobe the Clock_F line latching in the CSB Lines
                'Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3

                'Build the final data string to be sent to the AD9858
                sData = sInstructByte & sData

                'Loop through the data
                For cntr = 1 To Len(sData)
                    'Set SDIO to the proper value
                    SDIO = CInt(Mid(sData, cntr, 1))
                    'Take SCLK Low
                    SCLK = abvLow
                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    WriteEvbBuffVal evb59Buff3

                    'Latch the data into the AD9858
                    SCLK = abvHigh
                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    WriteEvbBuffVal evb59Buff3

                    'Strobe the Clock_F line latching in the data
'                    Strobe_Clock_F
                    'Take SCLK Low
'                    SCLK = abvLow
'                    WriteEvbBuffVal evb59Buff3
                Next cntr

                'Return SCLK Low
                SCLK = abvLow
                WriteEvbBuffVal evb59Buff3

                'Now return the CSB line high
                Select Case DUTNum
                    Case 1
                        CSB_DUT1 = abvHigh
                    Case 2
                        CSB_DUT2 = abvHigh
                    Case Else
                        CSB_DUT1 = abvHigh
                        CSB_DUT2 = abvHigh
                End Select
                'Strobe the Clock_F line latching in the CSB Lines
'                Strobe_Clock_F
                WriteEvbBuffVal evb59Buff3

    '                'Always return SCLK to a High when done just incase the user
    '                SCLK = abvHigh
    '                'Strobe the Clock_F line latching in the data
    '                Strobe_Clock_F

                'Now check to see
                Select Case DUTNum
                    Case 1
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT1 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT1 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT1 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT1 = TwoWire
                            End If
                        End If
                        'Automatically do a frequency update if the option is true
                        If mvarAutoFUD_DUT1 = True Then
                            FUD_DUT1 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT1 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        End If

                        'Store the value written to the register in a buffer
                        sRegMapVals(0, Address) = Data

                    Case 2
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT2 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT2 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT2 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT2 = TwoWire
                            End If
                        End If
                        'Automatically do a frequency update if the option is true
                        If mvarAutoFUD_DUT2 = True Then
                            FUD_DUT2 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT2 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        End If

                        'Store the value written to the register in a buffer
                        sRegMapVals(1, Address) = Data
                    Case Else
                        'Now Check to see if they put the part into LSB First or 2 or 3 Wire Mode
                        If Address = 0 Then
                            If Left(Right(Data, 9), 1) = "1" Then
                                'They sent the LSBFirst Bit
                                mvarLSBFirstDUT1 = True
                                mvarLSBFirstDUT2 = True
                            Else
                                'They Sent MSB First Mode
                                mvarLSBFirstDUT1 = False
                                mvarLSBFirstDUT2 = False
                            End If
                            If Left(Right(Data, 10), 1) = "1" Then
                                'They sent the SDIO Input Only Bit so they want 3 Wire Mode
                                mvarSerialIOModeDUT1 = ThreeWire
                                mvarSerialIOModeDUT2 = ThreeWire
                            Else
                                'They want 2 wire mode
                                mvarSerialIOModeDUT1 = TwoWire
                                mvarSerialIOModeDUT2 = TwoWire
                            End If
                        End If

                        If mvarAutoFUD_DUT1 And mvarAutoFUD_DUT2 Then
                            'Fud both at the same time
                            FUD_DUT1 = abvHigh
                            FUD_DUT2 = abvHigh
                            WriteEvbBuffVal evb59Buff1
                            FUD_DUT1 = abvLow
                            FUD_DUT2 = abvLow
                            WriteEvbBuffVal evb59Buff1
                        Else
                            'Automatically do a frequency update if the option is true
                            If mvarAutoFUD_DUT1 = True Then
                                FUD_DUT1 = abvHigh
                                WriteEvbBuffVal evb59Buff1
                                FUD_DUT1 = abvLow
                                WriteEvbBuffVal evb59Buff1
                            End If
                            'Automatically do a frequency update if the option is true
                            If mvarAutoFUD_DUT2 = True Then
                                FUD_DUT2 = abvHigh
                                WriteEvbBuffVal evb59Buff1
                                FUD_DUT2 = abvLow
                                WriteEvbBuffVal evb59Buff1
                            End If
                        End If

                        'Store the value written to the register in a buffer
                        sRegMapVals(0, Address) = Data
                        sRegMapVals(1, Address) = Data
                End Select
            Else
                'The data isn't valid or the address isn't valid
                If Address < 0 Or Address > &HC Then
                    MsgBox "Error: Invalid address = " & Address & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If

                If NumBytes = (Len(Data) / 8) Then
                    MsgBox "Error: Invalid data = " & Data & ".", vbApplicationModal, "Error: Sub SerialLoad"
                End If
            End If
        End If
    End If
End Sub
