Attribute VB_Name = "modMain"
'Uncoment to enter full debug mode
'#Const FullDebugMode = 1
'Uncomment to enter ADI Mode
Public AdiMode As Boolean

Public iDecSep As Integer
Public sDecSep As String
Public iNegSign As Integer
Public sNegSign As String
Public TestMode As Integer
Public strCmdLineArgs As String
Public EvalBd As cls9859EVBD
Public DUT1_CFR2 As String
Public DUT2_CFR2 As String
Public DUT1_Installed As Boolean
Public DUT2_Installed As Boolean
Public DUT1_RAM(0 To 1023) As String 'String array to hold DUT1's RAM Values
Public DUT2_RAM(0 To 1023) As String 'String array to hold DUT2's RAM Values

Public FlashOnColor As Long
Public NormalColor As Long

'Setup a constant that points to the register that this form addresses
Global Const CFR1 = &H0
Global Const CFR2 = &H1
Global Const ASF = &H2
Global Const ARR = &H3
Global Const FTW0 = &H4
Global Const POW0 = &H5
Global Const FTW1 = &H6
Global Const RSCW0 = &H7
Global Const RSCW1 = &H8
Global Const RSCW2 = &H9
Global Const RSCW3 = &HA
Global Const RAM = &HB
Global Const TR = &HC

Public frmRAMEditor As Form
Public EditFileName As String

Public HardwareOnlyReset As Boolean

'Ramsegment control word structure
Private Type RSCWInfo
    BeginAddr As Integer
    FinalAddr As Integer
    NoDwell As Integer
    AddressRampRate As Long
    ModeControl As Integer
End Type

Public MainWindowTitle As String


Public Sub Main()
    Dim CurInstanceHwnd As Long
    Dim TestValue As String
    Dim ReadValue As String
    Dim cntr As Integer
    Dim EvalBdDetected As Integer
    Dim NumOfDUTsDetected As Integer
'    Dim EvBdDetected As Boolean
    
    'Support XP Themes using a manafest file
    'EnableXPThemes
    
    'Setup the internationalization class
    Dim LocaleInfo As adiLocaleInfo
    Set LocaleInfo = New adiLocaleInfo

    'Do only hardware resets on startup
    HardwareOnlyReset = True
    
    'Get Locale Infomation
    sDecSep = LocaleInfo.GetLocaleInfo(adiDecimalSep)
    iDecSep = Asc(sDecSep)
    sNegSign = LocaleInfo.GetLocaleInfo(adiNegativeSign)
    iNegSign = Asc(sDecSep)
    Set LocaleInfo = Nothing
    
    'Assign values to variables
    FlashOnColor = RGB(0, 255, 0)
    NormalColor = vb3DFace
    
    'Get the command line arguments
    strCmdLineArgs = UCase(Command())
        
    'set the main window title
    MainWindowTitle = App.Title & " Rev " & App.Major & "." & App.Minor & "." & App.Revision
        
    'Activate the currently running instance
    CurInstanceHwnd = FindWindow("ThunderMDIForm", MainWindowTitle)
    
    'If the program is already running then quit now!!!
    If App.PrevInstance = True Or CurInstanceHwnd <> 0 Then
        'If the window is minimized
        If IsIconic(CurInstanceHwnd) Then
            'Then unminimize it
            Call OpenIcon(CurInstanceHwnd)
        End If
        
        'Activate the application
'        AppActivate MainFrmCaption
        Call SetForegroundWindow(CurInstanceHwnd)
        
        'Exit the program before doing anything
        End
    End If
    
    'Initialize the RAM Arrays
    For cntr = 0 To 1023
        DUT1_RAM(cntr) = "00000000000000000000000000000000"
        DUT2_RAM(cntr) = "00000000000000000000000000000000"
    Next cntr
    
    'Load and show the splash screen
    Load frmSplash
    'frmSplash.Height = 0
    frmSplash.Width = 0
    frmSplash.Show
    'frmSplash.Top = frmSplash.Top - 4245 / 2
    'frmSplash.Left = frmSplash.Left - 7380 / 2
    'Make the window the topmost window
'    MakeTopMost frmSplash, True
    MakeFormModeless frmSplash, mdiMain.hWnd
    With frmSplash
    Do While .Width < 7380
        'Resize by 16 pixels
        If .Width + Screen.TwipsPerPixelX * 32 > 7380 Then
            Exit Do
        Else
            .Width = .Width + Screen.TwipsPerPixelX * 32
            '.Top = .Top - Screen.TwipsPerPixelY * 64
            .Left = .Left - Screen.TwipsPerPixelX * 16
            .Refresh
        End If
        
        'Allow windows to process events
        'DoEvents
        Delay 0.018, True
    Loop
    
    '.Height = 4245
    'Finish centering the form
    .Left = .Left - Screen.TwipsPerPixelX * 6
    .Width = 7380
    .Refresh
    End With
    'Show the splash form
'    frmSplash.Show
    
    'Make the splash form topmost
    'MakeTopMost frmSplash, True
    frmSplash.Refresh
    
    'Load the other forms
    frmSplash.AddStatLine "Attempting to load and start the device driver."
    frmSplash.AddStatLine "This may take some time, please wait..."
    Load frmLPTSelect
    frmSplash.AddStatLine "The driver was successfully loaded and started."
    frmSplash.AddStatLine "Detecting LPT Ports..."
    Call frmLPTSelect.LPTSelectDialog("", "", False, 1)
    frmSplash.AddStatLine "Found " & frmLPTSelect.LPTGetPortCount & " LPT Ports..."
    frmSplash.AddStatLine "Loading Main Window..."
    mdiMain.Show
    
    'Load the Analog Logo window
    Load frmMdiBack
    'Center the form in the center of the client area of the mdi form
    frmMdiBack.Left = (mdiMain.Width - frmMdiBack.Width) / 2
    frmMdiBack.Top = (mdiMain.Height - frmMdiBack.Height - 1600) / 2
    frmMdiBack.Show
    
    'Create a global link to the evalboard
    Set EvalBd = mdiMain.EvBd

    frmSplash.AddStatLine "Loading Control Window..."
    Load frmControl
'    frmSplash.AddStatLine "Loading Configure Window..."
'    Load frmConfigureDUT
'    frmSplash.AddStatLine "Loading Toolbox Window..."
    frmSplash.AddStatLine "Loading Frequency Window..."
    Load frmFrequency
    frmSplash.AddStatLine "Loading RAM Config Window..."
    Load frmRAMConfig
    frmSplash.AddStatLine "Loading Amplitude Window..."
    Load frmAmplitude
    frmSplash.AddStatLine "Loading DUT Signals Tool Window..."
    Load frmDUTSignals
    frmSplash.AddStatLine "Loading RAM File Editor Window..."
    'Create a new instance of the edit ram window
    Set frmRAMEditor = New frmEditRam
    Load frmRAMEditor
    
    'Detect the DUTS and options
    frmSplash.AddStatLine "Detecting Eval Board, and DUT Types..."
    
    'Find the evaluation Board
    FindEvBoard NumOfDUTsDetected, EvalBdDetected, False
    'Try and detect a DUT on each LPT port connected to the
'    For cntr = 0 To frmLPTSelect.LPTGetPortCount() - 1
'        'Select the LPT port to test
'        frmLPTSelect.LPTSelectPort cntr
'        'Sync up the PC and Eval Board
'        EvalBd.InitEvalBoard
'        'Try to Detect the DUTs
'        NumOfDUTsDetected = EvalBd.DetectDUTs
'        EvBdDetected = EvalBd.DetectEvalBoard
'        If NumOfDUTsDetected Or EvBdDetected Then
'            EvalBdDetected = True
'            Exit For
'        End If
'    Next cntr
    
    'Display a status line of what was found
    If EvalBdDetected <> -1 Then
        frmSplash.AddStatLine "    Evaluation Board found at LPT" & EvalBdDetected & "."
    Else
        frmSplash.txtStatus.ForeColor = RGB(255, 0, 0)
        frmSplash.AddStatLine "Error:  Evaluation Board Not Found!!!"
        frmLPTSelect.LPTSelectPort 0 'Reselect LPT1
    End If
    
    Select Case NumOfDUTsDetected
        Case 0:
            'Display an error message
            frmSplash.AddStatLine "    DUT1: Not Installed!!!"
            frmSplash.AddStatLine "    DUT2: Not Installed!!!"
            
        Case 1:
            'Read the CFR2 register to detect the DUT
            DUT1_CFR2 = EvalBd.SerialRead(1, &H1)
            'Trimm off everything except the bond option bits
            DUT1_CFR2 = Left(DUT1_CFR2, 8)
        
            'Decode the bits for DUT1
            frmSplash.AddStatLine "    DUT1: " & GetProductString(DUT1_CFR2) & "."
            mdiMain.stbStatusBar.Panels(2).Text = "DUT1: " & GetProductString(DUT1_CFR2) & "."
'            Select Case DUT1_CFR2
'                Case "00011010": 'Evaluation Product
'                    frmSplash.AddStatLine "    DUT1: AD9954E." 'Evaluation Product"
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9954E"
'                Case "00000101": 'AD9859 - No Options,10 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9859."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9859"
'                Case "00000100": 'AD9951 - No Options,14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9951."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9951"
'                Case "00000000": 'AD9952 - Comparator Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9952."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9952"
'                Case "00010100": 'AD9953 - RAM Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9953."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9953"
'                Case "00011000": 'AD9954 - All Options, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9954."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9954"
'                Case "00001100": 'AD80XXX - Linear Sweep, 14 Bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD80XXX."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD80XXX"
'                Case Else:
'                    frmSplash.AddStatLine "    DUT1: Not Installed!!!"
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: Not Inst."
'            End Select
            frmSplash.AddStatLine "    DUT2: Not Installed."

        Case 2:
            'Read the CFR2 register to detect the DUT
            DUT2_CFR2 = EvalBd.SerialRead(2, &H1)
            'Trimm off everything except the bond option bits
            DUT2_CFR2 = Left(DUT2_CFR2, 8)
            'Decode the bits for DUT2
            frmSplash.AddStatLine "    DUT2: " & GetProductString(DUT2_CFR2) & "."
            mdiMain.stbStatusBar.Panels(3).Text = "DUT2: " & GetProductString(DUT2_CFR2) & "."
            'Decode the bits for DUT2
'            Select Case DUT2_CFR2
'                Case "00011010": 'Evaluation Product
'                    frmSplash.AddStatLine "    DUT2: AD9954E." 'Evaluation Product"
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9954E"
'                Case "00000101": 'AD9859 - No Options,10 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9859."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9859"
'                Case "00000100": 'AD9951 - No Options,14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9951."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9951"
'                Case "00000000": 'AD9952 - Comparator Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9952."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9952"
'                Case "00010100": 'AD9953 - RAM Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9953."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9953"
'                Case "00011000": 'AD9954 - All Options, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9954."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9954"
'                Case "00001100": 'AD80XXX - Linear Sweep, 14 Bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD80XXX."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD80XXX"
'                Case Else:
'                    frmSplash.AddStatLine "    DUT2: Not Installed!!!"
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: Not Inst."
'            End Select
            frmSplash.AddStatLine "    DUT1: Not Installed."
        Case 3:
            'Read the CFR2 register to detect the DUT
            DUT1_CFR2 = EvalBd.SerialRead(1, &H1)
            DUT2_CFR2 = EvalBd.SerialRead(2, &H1)
            
            'Trimm off everything except the bond option bits
            DUT1_CFR2 = Left(DUT1_CFR2, 8)
            DUT2_CFR2 = Left(DUT2_CFR2, 8)
            
            'Decode the bits for DUT1
            frmSplash.AddStatLine "    DUT1: " & GetProductString(DUT1_CFR2) & "."
            mdiMain.stbStatusBar.Panels(2).Text = "DUT1: " & GetProductString(DUT1_CFR2) & "."
            'Decode the bits for DUT2
            frmSplash.AddStatLine "    DUT2: " & GetProductString(DUT2_CFR2) & "."
            mdiMain.stbStatusBar.Panels(3).Text = "DUT2: " & GetProductString(DUT2_CFR2) & "."

'            Select Case DUT1_CFR2
'                Case "00011010": 'Evaluation Product
'                    frmSplash.AddStatLine "    DUT1: AD9954E." 'Evaluation Product"
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9954E"
'                Case "00000101": 'AD9859 - No Options,10 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9859."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9859"
'                Case "00000100": 'AD9951 - No Options,14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9951."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9951"
'                Case "00000000": 'AD9952 - Comparator Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9952."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9952"
'                Case "00010100": 'AD9953 - RAM Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9953."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9953"
'                Case "00011000": 'AD9954 - All Options, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD9954."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD9954"
'                Case "00001100": 'AD80XXX - Linear Sweep, 14 Bit DAC
'                    frmSplash.AddStatLine "    DUT1: AD80XXX."
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: AD80XXX"
'                Case Else:
'                    frmSplash.AddStatLine "    DUT1: Not Installed!!!"
'                    mdiMain.stbStatusBar.Panels(2).Text = "DUT1: Not Inst."
'            End Select
'
'            'Decode the bits for DUT2
'            Select Case DUT2_CFR2
'                Case "00011010": 'Evaluation Product
'                    frmSplash.AddStatLine "    DUT2: AD9954E." 'Evaluation Product"
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9954E"
'                Case "00000101": 'AD9859 - No Options,10 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9859."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9859"
'                Case "00000100": 'AD9951 - No Options,14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9951."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9951"
'                Case "00000000": 'AD9952 - Comparator Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9952."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9952"
'                Case "00010100": 'AD9953 - RAM Active, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9953."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9953"
'                Case "00011000": 'AD9954 - All Options, 14 bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD9954."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD9954"
'                Case "00001100": 'AD80XXX - Linear Sweep, 14 Bit DAC
'                    frmSplash.AddStatLine "    DUT2: AD80XXX."
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: AD80XXX"
'                Case Else:
'                    frmSplash.AddStatLine "    DUT2: Not Installed!!!"
'                    mdiMain.stbStatusBar.Panels(3).Text = "DUT2: Not Inst."
'            End Select
    End Select
    
    If EvalBd.DutsInstalled = 0 Then
        frmSplash.txtStatus.ForeColor = RGB(255, 0, 0)
    End If
        
    'Reset the DUT again to clear out register 4 which is used to detect
    'the DUTs
'    EvalBd.ResetDUT 0
    
    'Disable DUT Tabs that aren't usable
'    Select Case EvalBd.DutsInstalled
'        Case 0:
'            frmControl.sstChooseDUT.TabEnabled(1) = False
'            frmControl.sstChooseDUT.TabEnabled(0) = False
'            frmFrequency.sstChooseDUT.TabEnabled(1) = False
'            frmFrequency.sstChooseDUT.TabEnabled(0) = False
'            frmAmplitude.sstChooseDUT.TabEnabled(1) = False
'            frmAmplitude.sstChooseDUT.TabEnabled(0) = False
'            frmRegisterMap.sstChooseDUT.TabEnabled(1) = False
'            frmRegisterMap.sstChooseDUT.TabEnabled(0) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(3) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(2) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(1) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(0) = False
'        Case 1:
'            frmControl.sstChooseDUT.TabEnabled(1) = False
'            frmControl.sstChooseDUT.TabEnabled(0) = True
'            frmFrequency.sstChooseDUT.TabEnabled(1) = False
'            frmFrequency.sstChooseDUT.TabEnabled(0) = True
'            frmAmplitude.sstChooseDUT.TabEnabled(1) = False
'            frmAmplitude.sstChooseDUT.TabEnabled(0) = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(1) = False
'            frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(3) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(2) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(0) = True
'        Case 2:
'            frmControl.sstChooseDUT.TabEnabled(0) = False
'            frmControl.sstChooseDUT.TabEnabled(1) = True
'            frmFrequency.sstChooseDUT.TabEnabled(0) = False
'            frmFrequency.sstChooseDUT.TabEnabled(1) = True
'            frmAmplitude.sstChooseDUT.TabEnabled(0) = False
'            frmAmplitude.sstChooseDUT.TabEnabled(1) = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(0) = False
'            frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(1) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(0) = False
'            frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
'        Case 3:
'            frmControl.sstChooseDUT.TabEnabled(1) = True
'            frmControl.sstChooseDUT.TabEnabled(0) = True
'            frmControl.chkLoadBothDUTs.Enabled = True
'            frmFrequency.sstChooseDUT.TabEnabled(1) = True
'            frmFrequency.sstChooseDUT.TabEnabled(0) = True
'            frmFrequency.chkLoadBothDUTs.Enabled = True
'            frmAmplitude.sstChooseDUT.TabEnabled(1) = True
'            frmAmplitude.sstChooseDUT.TabEnabled(0) = True
'            frmAmplitude.chkLoadBothDUTs.Enabled = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(0) = True
'    End Select
        
    Select Case UCase(Command$)
        Case "-ADIFULLENGMODE"
            SetEngMode 1
        Case "-ADIFAMODE"
            SetEngMode 2
        Case "-DEBUGMODE"
            SetEngMode 3
        Case Else
            SetEngMode 0
    End Select
    
    'Finished starting up now do software resets also
    HardwareOnlyReset = False
        
    
    frmSplash.AddStatLine ""
    frmSplash.AddStatLine "Resetting the Evaluation Board and Software."
    
    'Reset the evalbd
    EvalBd.ResetDUT 0
        
'******************************************************************************
    'Used for internal use only
    frmControl.chkLoadBothDUTs.Visible = True
    frmFrequency.chkLoadBothDUTs.Visible = True
    frmRAMConfig.chkLoadBothDUTs.Visible = True
    frmAmplitude.chkLoadBothDUTs.Visible = True
'******************************************************************************
    'Show the Control Window
'    frmConfigureDUT.Show
    'frmDebug.Move 0, 0
    'frmDebug.Show
    frmControl.Show
    frmFrequency.Show
    frmDUTSignals.Move mdiMain.Left + mdiMain.Width - frmDUTSignals.Width - (Screen.TwipsPerPixelY * 6), mdiMain.Top + (Screen.TwipsPerPixelY * 25)
    frmDUTSignals.Show
    
'*****************************************
'* Uncomment one of the following lines  *
'* to force a DUT Type for the GUI Setup *
'*****************************************
'    DUT1_CFR2 = "00011010" 'Evaluation Product
'    DUT1_CFR2 = "00011000" 'AD9854
'    DUT1_CFR2 = "00010100" 'AD9853
'    DUT1_CFR2 = "00000000" 'AD9852
'    DUT1_CFR2 = "00000100" 'AD9851
'    DUT1_CFR2 = "00000101" 'AD9859
'    DUT1_CFR2 = "00001100" 'AD80XXX
'    DUT1_CFR2 = ""

'    DUT2_CFR2 = "00011010" 'Evaluation Product
'    DUT2_CFR2 = "00011000" 'AD9854
'    DUT2_CFR2 = "00010100" 'AD9853
'    DUT2_CFR2 = "00000000" 'AD9852
'    DUT2_CFR2 = "00000100" 'AD9851
'    DUT2_CFR2 = "00000101" 'AD9859
'    DUT2_CFR2 = "00001100" 'AD80XXX
'    DUT2_CFR2 = ""
'****************************************
    
    frmSplash.AddStatLine ""
    frmSplash.AddStatLine "Setting up Graphical User Interface for..."
    frmSplash.AddStatLine "    DUT1: " & GetProductString(DUT1_CFR2) & "."
    frmSplash.AddStatLine "    DUT2: " & GetProductString(DUT2_CFR2) & "."

    SetupGUIForProduct DUT1_CFR2, DUT2_CFR2

    'Wait 1 second and process events
    Delay 0.5
    'Enable the auto unload feature of the splash screen
    If IsLoaded("frmSplash") Then
        frmSplash.Visible = True
        frmSplash.SetFocus
        frmSplash.AutoUnloadEnable
    End If
    
    'Show that the software is loaded and ready
    frmSplash.AddStatLine ""
    frmSplash.AddStatLine "Software Loaded and Ready!!!"
End Sub

Public Sub ExitGracefully()
    Dim cntr As Integer
    
    'Unload frmLPTSelect first
    Unload frmLPTSelect
    
    'Unload each form
    For cntr = (Forms.Count - 1) To 0 Step -1
        If Forms(cntr).Name <> "mdiMain" Then
            Unload Forms(cntr)
        End If
    Next cntr
    
    'Unload the main form
    Unload mdiMain
    
    End
End Sub

'Decodes the RAM Segment Control Word
Public Sub DecodeRSCW(ByVal RSCW As String, BegAddr As Integer, FnlAddr As Integer, AddrRR As Long, ModeCtrl As Integer, NoDwell As Integer)
    Dim MSWord As String
    Dim LSWord As String
    Dim BinWord As String
    
    'Extract the Beginning Address
    LSWord = Mid(RSCW, 25, 6)
    MSWord = Right(RSCW, 4)
    BegAddr = CStr(cbaseBinS2Dec(MSWord & LSWord))
    
    'Extract the Final Address
    MSWord = Mid(RSCW, 31, 2)
    LSWord = Mid(RSCW, 17, 8)
    FnlAddr = CStr(cbaseBinS2Dec(MSWord & LSWord))

    'Extract the Ramp Rate
    LSWord = Left(RSCW, 16)
    MSWord = Right(LSWord, 8)
    LSWord = Left(LSWord, 8)
    AddrRR = CStr(cbaseBinS2Dec(MSWord & LSWord))
    
    'Extract the Mode control
    ModeCtrl = cbaseBinS2Dec(Mid(RSCW, 33, 3))
    
    'Extract the NoDwell bit
    NoDwell = cbaseBinS2Dec(Mid(RSCW, 36, 1))
End Sub

'Inputs the values to be encoded and outputs a proper RSCW
Public Function EncodeRSCW(BegAddr As Integer, FnlAddr As Integer, AddrRR As Long, ModeCtrl As Integer, NoDwell As Integer) As String
    EncodeRSCW = Right(cbaseDec2Bin(AddrRR, 16), 8) & _
                 Left(cbaseDec2Bin(AddrRR, 16), 8) & _
                 Right(cbaseDec2Bin(FnlAddr, 10), 8) & _
                 Right(cbaseDec2Bin(BegAddr, 10), 6) & _
                 Left(cbaseDec2Bin(FnlAddr, 10), 2) & _
                 cbaseDec2Bin(ModeCtrl, 3) & cbaseDec2Bin(NoDwell, 1) & _
                 Left(cbaseDec2Bin(BegAddr, 10), 4)
End Function

Public Sub LoadRAMFile(ByVal DUTNum As Integer, ByVal RamFile As String)
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim DummyDbl As Double
    Dim cntr As Integer
    Dim cntr1 As Integer
    Dim CntrStart As Integer
    Dim CntrStop As Integer
    Dim CntrStep As Integer

    Dim FileType As String
    Dim FileRevNum As Double
    Dim TempDataStr As String
    Dim RSCW0Str As String
    Dim RSCW1Str As String
    Dim RSCW2Str As String
    Dim RSCW3Str As String
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer

    Dim ModeCntrlRS0 As Integer
    Dim NoDwellRS0 As Integer
    Dim StartAddressRS0 As Integer
    Dim FinalAddressRS0 As Integer
    Dim AddressRampRateRS0 As Long

    Dim ModeCntrlRS1 As Integer
    Dim NoDwellRS1 As Integer
    Dim StartAddressRS1 As Integer
    Dim FinalAddressRS1 As Integer
    Dim AddressRampRateRS1 As Long

    Dim ModeCntrlRS2 As Integer
    Dim NoDwellRS2 As Integer
    Dim StartAddressRS2 As Integer
    Dim FinalAddressRS2 As Integer
    Dim AddressRampRateRS2 As Long

    Dim ModeCntrlRS3 As Integer
    Dim NoDwellRS3 As Integer
    Dim StartAddressRS3 As Integer
    Dim FinalAddressRS3 As Integer
    Dim AddressRampRateRS3 As Long

    Dim RamSegment0Data() As String
    Dim RamSegment1Data() As String
    Dim RamSegment2Data() As String
    Dim RamSegment3Data() As String

    Dim UseRS0 As Boolean
    Dim UseRS1 As Boolean
    Dim UseRS2 As Boolean
    Dim UseRS3 As Boolean
    Dim sRAMAddr As String

    Dim PrgCntr As String 'Progress cntr
    Dim UpdatePrgBar As Boolean

    'Setup an error handler
    On Error GoTo ErrorHandler:

    'Set the screen cursor to hourglass
    Screen.MousePointer = 11

    If EvalBd.Enabled = True Then
        'If writing to both DUTs make sure that both are in the same IOMode
        If (DUTNum <> 1 And DUTNum <> 2) And (EvalBd.LSBFirstDUT1 <> EvalBd.LSBFirstDUT2) Then
            'LSBFirst mode must be the same on both DUTs
            MsgBox "Error: To write to both DUT's simultaniously the LSB First bit must be the same for both DUTs.", vbApplicationModal, "Error: SUB RAMLoadFile()"
        Else
            'If the number of bytes to send is different than the number of bytes
            'present in the data passed then exit the sub
            If (FileExists(RamFile)) Then
                'Get a sharable file handle
                FileHandle = FreeFile(1)

                'Open the file
                Open RamFile For Input As #FileHandle

                'Read the file header back
                Input #FileHandle, FileType, FileRevNum
                'Make sure its a valid file
                If FileType = "AD9859 RAM Configuration File" And FileRevNum = 1 Then
                    'Trash the next 4 lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr

                    'Read the RSCW0 Info
                    Input #FileHandle, dummystr, ModeCntrlRS0
                    Input #FileHandle, dummystr, NoDwellRS0
                    Input #FileHandle, dummystr, StartAddressRS0
                    Input #FileHandle, dummystr, FinalAddressRS0
                    Input #FileHandle, dummystr, AddressRampRateRS0

                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr

                    'Resize the array
                    ReDim RamSegment0Data((FinalAddressRS0 - StartAddressRS0) + 1)

                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS0 - StartAddressRS0) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS0 = True
                        End If
                        If UseRS0 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment0Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr

                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 1"

                    'Read the RSCW1 Info
                    Input #FileHandle, dummystr, ModeCntrlRS1
                    Input #FileHandle, dummystr, NoDwellRS1
                    Input #FileHandle, dummystr, StartAddressRS1
                    Input #FileHandle, dummystr, FinalAddressRS1
                    Input #FileHandle, dummystr, AddressRampRateRS1

                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr

                    'Resize the array
                    ReDim RamSegment1Data((FinalAddressRS1 - StartAddressRS1) + 1)

                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS1 - StartAddressRS1) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS1 = True
                        End If
                        If UseRS1 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment1Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr

                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 2"

                    'Read the RSCW2 Info
                    Input #FileHandle, dummystr, ModeCntrlRS2
                    Input #FileHandle, dummystr, NoDwellRS2
                    Input #FileHandle, dummystr, StartAddressRS2
                    Input #FileHandle, dummystr, FinalAddressRS2
                    Input #FileHandle, dummystr, AddressRampRateRS2

                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr

                    'Resize the array
                    ReDim RamSegment2Data((FinalAddressRS2 - StartAddressRS2) + 1)

                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS2 - StartAddressRS2) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS2 = True
                        End If
                        If UseRS2 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment2Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr

                    'Trash all data until the next RSC Section
                    Do
                        Input #FileHandle, dummystr
                    Loop Until dummystr = "BEGIN - RAM Segment 3"

                    'Read the RSCW3 Info
                    Input #FileHandle, dummystr, ModeCntrlRS3
                    Input #FileHandle, dummystr, NoDwellRS3
                    Input #FileHandle, dummystr, StartAddressRS3
                    Input #FileHandle, dummystr, FinalAddressRS3
                    Input #FileHandle, dummystr, AddressRampRateRS3

                    'Trash 4 More Lines
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr
                    Input #FileHandle, dummystr

                    'Resize the array
                    ReDim RamSegment3Data((FinalAddressRS3 - StartAddressRS3) + 1)

                    'Read in the data from the file
                    For cntr = 1 To ((FinalAddressRS3 - StartAddressRS3) + 1)
                        'Read the binary data in
                        Input #FileHandle, sRAMAddr, DummyDbl, dummystr, TempDataStr
                        'If the first address is numeric then set the UseRS Variable
                        If cntr = 1 And IsNumeric(sRAMAddr) Then
                            UseRS3 = True
                        End If
                        If UseRS3 = False Then
                            'Don't bother loading the ram data from the file because
                            'it isn't used anyway
                            Exit For
                        End If
                        'Remove the spaces
                        RamSegment3Data(cntr - 1) = cbaseDec2Bin(DummyDbl, 32)
                    Next cntr
                    ' Close before reopening in another mode.
                    Close #FileHandle

                    '*** All data was read correctly - Now Program The DUT(s) ****
                    'First program the RSCW Registers
                    'Build the binary string for the RSCW in MSB format
                    'RAMSegmentAddressRampRate<7:0> + RAMSegmentAddressRampRate<15:8> +
                    'RAMSegmentFinalAddress<7:0> +
                    'RAMSegmentBeginningAddress<5:0> + RAMSegmentFinalAddress<9:8>
                    'RAMSegmentModeControl + NoDwellActive + RAMSegmentBeginningAddress<9:6>
                    RSCW0Str = Right(cbaseDec2Bin(AddressRampRateRS0, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS0, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS0, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS0, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS0, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS0, 3) & cbaseDec2Bin(NoDwellRS0, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS0, 10), 4)

'                    Debug.Print "RSCW0"
'                    PrintDecodedRSCW RSCW0Str

                    'Calculate the RSCW1 Register
                    RSCW1Str = Right(cbaseDec2Bin(AddressRampRateRS1, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS1, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS1, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS1, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS1, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS1, 3) & cbaseDec2Bin(NoDwellRS1, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS1, 10), 4)

'                    Debug.Print "RSCW1"
'                    PrintDecodedRSCW RSCW1Str

                    'Calculate the RSCW2 Register
                    RSCW2Str = Right(cbaseDec2Bin(AddressRampRateRS2, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS2, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS2, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS2, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS2, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS2, 3) & cbaseDec2Bin(NoDwellRS2, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS2, 10), 4)

'                    Debug.Print "RSCW2"
'                    PrintDecodedRSCW RSCW2Str

                    'Calculate the RSCW2 Register
                    RSCW3Str = Right(cbaseDec2Bin(AddressRampRateRS3, 16), 8) & _
                                  Left(cbaseDec2Bin(AddressRampRateRS3, 16), 8) & _
                                  Right(cbaseDec2Bin(FinalAddressRS3, 10), 8) & _
                                  Right(cbaseDec2Bin(StartAddressRS3, 10), 6) & _
                                  Left(cbaseDec2Bin(FinalAddressRS3, 10), 2) & _
                                  cbaseDec2Bin(ModeCntrlRS3, 3) & cbaseDec2Bin(NoDwellRS3, 1) & _
                                  Left(cbaseDec2Bin(StartAddressRS3, 10), 4)

'                    Debug.Print "RSCW3"
'                    PrintDecodedRSCW RSCW3Str

                    '*** Now Load the RAM Data into the RAM for RSCW0 ***
                    'Store the old profile
                    TmpProfile_DUT1 = EvalBd.GetActiveProfile(1)
                    TmpProfile_DUT2 = EvalBd.GetActiveProfile(2)

                    'Write to the RSCW0 Register
                    EvalBd.SerialLoad DUTNum, &H7, RSCW0Str
                    'Set the profile to write to the correct RAM Segment
                    If UseRS0 Then
                        EvalBd.SetActiveProfile DUTNum, 1
                        'Delay

                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStep = 1
                            CntrStop = ((FinalAddressRS0 - StartAddressRS0) + 1)
                        Else
                            CntrStart = ((FinalAddressRS0 - StartAddressRS0) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                        
                        'Setup the status bar
                        With frmRAMLoadStatus
                            frmRAMLoadStatus.lblMsg.Caption = "Writing File To RAM: RS0"
                            If CntrStart < CntrStop Then
                                .pbrProgress.Min = CntrStart
                                .pbrProgress.Max = CntrStop
                                UpdatePrgBar = True
                            Else
                                If CntrStart > CntrStop Then
                                    .pbrProgress.Min = CntrStop
                                    .pbrProgress.Max = CntrStart
                                    UpdatePrgBar = True
                                Else
                                    'Setup the progress bar with known values
                                    .pbrProgress.Min = 0
                                    .pbrProgress.Max = 1
                                    UpdatePrgBar = False
                                End If
                            End If
                            PrgCntr = 1
                            .pbrProgress.value = .pbrProgress.Min
                            .Refresh
                        End With
    
                        'Initiate a Upload
                        EvalBd.RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            EvalBd.RAMWritePacket DUTNum, RamSegment0Data(cntr - 1)
                            If UpdatePrgBar = True Then
                                'Update the status window
                                frmRAMLoadStatus.pbrProgress.value = PrgCntr
                                PrgCntr = PrgCntr + 1
                                frmRAMLoadStatus.pbrProgress.Refresh
                            Else
                                'Show that were finished
                                frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
                                frmRAMLoadStatus.pbrProgress.Refresh
                            End If
                        Next cntr
                        'Terminate the upload
                        EvalBd.RAMTerminateUpload DUTNum
                    End If
                    
                    'Write to the RSCW1 Register
                    EvalBd.SerialLoad DUTNum, &H8, RSCW1Str
                    '*** Now Load the RAM Data into the RAM for RSCW1 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS1 Then
                        EvalBd.SetActiveProfile DUTNum, 2
                        'Delay

                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS1 - StartAddressRS1) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS1 - StartAddressRS1) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If

                        'Setup the status bar
                        With frmRAMLoadStatus
                            frmRAMLoadStatus.lblMsg.Caption = "Writing File To RAM: RS1"
                            If CntrStart < CntrStop Then
                                .pbrProgress.Min = CntrStart
                                .pbrProgress.Max = CntrStop
                                UpdatePrgBar = True
                            Else
                                If CntrStart > CntrStop Then
                                    .pbrProgress.Min = CntrStop
                                    .pbrProgress.Max = CntrStart
                                    UpdatePrgBar = True
                                Else
                                    'Setup the progress bar with known values
                                    .pbrProgress.Min = 0
                                    .pbrProgress.Max = 1
                                    UpdatePrgBar = False
                                End If
                            End If
                            PrgCntr = 1
                            .pbrProgress.value = .pbrProgress.Min
                            .Refresh
                        End With

                        'Initiate a Upload
                        EvalBd.RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            EvalBd.RAMWritePacket DUTNum, RamSegment1Data(cntr - 1)
                            'Update the status window
                            If UpdatePrgBar = True Then
                                'Update the status window
                                frmRAMLoadStatus.pbrProgress.value = PrgCntr
                                PrgCntr = PrgCntr + 1
                                frmRAMLoadStatus.pbrProgress.Refresh
                            Else
                                'Show that were finished
                                frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
                                frmRAMLoadStatus.pbrProgress.Refresh
                            End If
                        Next cntr

                        'Terminate the upload
                        EvalBd.RAMTerminateUpload DUTNum
                    End If

                    'Write to the RSCW2 Register
                    EvalBd.SerialLoad DUTNum, &H9, RSCW2Str
                    '*** Now Load the RAM Data into the RAM for RSCW2 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS2 Then
                        EvalBd.SetActiveProfile DUTNum, 3
                        'Delay
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS2 - StartAddressRS2) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS2 - StartAddressRS2) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If

                        'Setup the status bar
                        With frmRAMLoadStatus
                            frmRAMLoadStatus.lblMsg.Caption = "Writing File To RAM: RS2"
                            If CntrStart < CntrStop Then
                                .pbrProgress.Min = CntrStart
                                .pbrProgress.Max = CntrStop
                                UpdatePrgBar = True
                            Else
                                If CntrStart > CntrStop Then
                                    .pbrProgress.Min = CntrStop
                                    .pbrProgress.Max = CntrStart
                                    UpdatePrgBar = True
                                Else
                                    'Setup the progress bar with known values
                                    .pbrProgress.Min = 0
                                    .pbrProgress.Max = 1
                                    UpdatePrgBar = False
                                End If
                            End If
                            PrgCntr = 1
                            .pbrProgress.value = .pbrProgress.Min
                            .Refresh
                        End With

                        'Initiate a Upload
                        EvalBd.RAMInitUpload DUTNum
                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            EvalBd.RAMWritePacket DUTNum, RamSegment2Data(cntr - 1)
                            'Update the status window
                            If UpdatePrgBar = True Then
                                'Update the status window
                                frmRAMLoadStatus.pbrProgress.value = PrgCntr
                                PrgCntr = PrgCntr + 1
                                frmRAMLoadStatus.pbrProgress.Refresh
                            Else
                                'Show that were finished
                                frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
                                frmRAMLoadStatus.pbrProgress.Refresh
                            End If
                        Next cntr

                        'Terminate the upload
                        EvalBd.RAMTerminateUpload DUTNum
                    End If

                    'Write to the RSCW3 Register
                    EvalBd.SerialLoad DUTNum, &HA, RSCW3Str
                    '*** Now Load the RAM Data into the RAM for RSCW3 ***
                    'Set the profile to write to the correct RAM Segment
                    If UseRS3 Then
                        'Set the proper profile
                        EvalBd.SetActiveProfile DUTNum, 4
                        'Delay
                        'Load the RAM out in the right order
                        If LSBFirstDUT1 Then
                            CntrStart = 1
                            CntrStop = ((FinalAddressRS3 - StartAddressRS3) + 1)
                            CntrStep = 1
                        Else
                            CntrStart = ((FinalAddressRS3 - StartAddressRS3) + 1)
                            CntrStop = 1
                            CntrStep = -1
                        End If
                        'Setup the status bar
                        With frmRAMLoadStatus
                            frmRAMLoadStatus.lblMsg.Caption = "Writing File To RAM: RS3"
                            If CntrStart < CntrStop Then
                                .pbrProgress.Min = CntrStart
                                .pbrProgress.Max = CntrStop
                                UpdatePrgBar = True
                            Else
                                If CntrStart > CntrStop Then
                                    .pbrProgress.Min = CntrStop
                                    .pbrProgress.Max = CntrStart
                                    UpdatePrgBar = True
                                Else
                                    'Setup the progress bar with known values
                                    .pbrProgress.Min = 0
                                    .pbrProgress.Max = 1
                                    UpdatePrgBar = False
                                End If
                            End If
                            PrgCntr = 1
                            .pbrProgress.value = .pbrProgress.Min
                            .Refresh
                        End With

                        'Initiate a Upload
                        EvalBd.RAMInitUpload DUTNum

                        'Upload 32 bits at a time
                        For cntr = CntrStart To CntrStop Step CntrStep
                            EvalBd.RAMWritePacket DUTNum, RamSegment3Data(cntr - 1)
                            'Update the status window
                            If UpdatePrgBar = True Then
                                'Update the status window
                                frmRAMLoadStatus.pbrProgress.value = PrgCntr
                                PrgCntr = PrgCntr + 1
                                frmRAMLoadStatus.pbrProgress.Refresh
                            Else
                                'Show that were finished
                                frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
                                frmRAMLoadStatus.pbrProgress.Refresh
                            End If
                        Next cntr

                        'Terminate the upload
                        EvalBd.RAMTerminateUpload DUTNum
                    End If

                    '*****  This is a required to make the loaded profiles work *****
                    'We need to send at least 1 sclk to make the loaded profiles work
                    Select Case DUTNum
                        Case 1
                            dummystr = EvalBd.SerialRead(1, &H2)
                        Case 2
                            dummystr = EvalBd.SerialRead(2, &H2)
                        Case Else
                            dummystr = EvalBd.SerialRead(1, &H2)
                            dummystr = EvalBd.SerialRead(2, &H2)
                    End Select

                    'Load the data into the global RAMDataArrays
                    If UseRS0 Then
                        cntr1 = 0
                         For cntr = StartAddressRS0 To FinalAddressRS0
                             Select Case DUTNum
                                 Case 1:
                                     DUT1_RAM(cntr) = RamSegment0Data(cntr1)
                                 Case 2:
                                     DUT2_RAM(cntr) = RamSegment0Data(cntr1)
                                 Case Else:
                                     DUT1_RAM(cntr) = RamSegment0Data(cntr1)
                                     DUT2_RAM(cntr) = RamSegment0Data(cntr1)
                             End Select
                             'Incriment the array indexer
                             cntr1 = cntr1 + 1
                         Next cntr
                    End If

                    'Load the data into the global RAMDataArrays
                    If UseRS1 Then
                        cntr1 = 0
                         For cntr = StartAddressRS1 To FinalAddressRS1
                             Select Case DUTNum
                                 Case 1:
                                     DUT1_RAM(cntr) = RamSegment1Data(cntr1)
                                 Case 2:
                                     DUT2_RAM(cntr) = RamSegment1Data(cntr1)
                                 Case Else:
                                     DUT1_RAM(cntr) = RamSegment1Data(cntr1)
                                     DUT2_RAM(cntr) = RamSegment1Data(cntr1)
                             End Select
                             'Incriment the array indexer
                             cntr1 = cntr1 + 1
                         Next cntr
                    End If

                    'Load the data into the global RAMDataArrays
                    If UseRS2 Then
                        cntr1 = 0
                         For cntr = StartAddressRS2 To FinalAddressRS2
                             Select Case DUTNum
                                 Case 1:
                                     DUT1_RAM(cntr) = RamSegment2Data(cntr1)
                                 Case 2:
                                     DUT2_RAM(cntr) = RamSegment2Data(cntr1)
                                 Case Else:
                                     DUT1_RAM(cntr) = RamSegment2Data(cntr1)
                                     DUT2_RAM(cntr) = RamSegment2Data(cntr1)
                             End Select
                             'Incriment the array indexer
                             cntr1 = cntr1 + 1
                         Next cntr
                    End If

                    'Load the data into the global RAMDataArrays
                    If UseRS3 Then
                        cntr1 = 0
                         For cntr = StartAddressRS3 To FinalAddressRS3
                             Select Case DUTNum
                                 Case 1:
                                     DUT1_RAM(cntr) = RamSegment3Data(cntr1)
                                 Case 2:
                                     DUT2_RAM(cntr) = RamSegment3Data(cntr1)
                                 Case Else:
                                     DUT1_RAM(cntr) = RamSegment3Data(cntr1)
                                     DUT2_RAM(cntr) = RamSegment3Data(cntr1)
                             End Select
                             'Incriment the array indexer
                             cntr1 = cntr1 + 1
                         Next cntr
                    End If

                    'Restore the old profile
                    EvalBd.SetActiveProfile 1, TmpProfile_DUT1
                    EvalBd.SetActiveProfile 2, TmpProfile_DUT2
                Else
                    'Error message
                    MsgBox "Error: Invalid RAM File.", vbApplicationModal + vbCritical, "File Load Error!"
                End If

            Else
                'Specified File Does Not Exist
                MsgBox "Error: RAM File not found.", vbApplicationModal, "Error: SUB RAMLoadFile()"
            End If
        End If
    End If

    'Set the screen cursor to the defualt
    Screen.MousePointer = 0

    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case 62:
            'Display an error message
            MsgBox "LOAD ERROR:  Bad RAM File, or Incomplete RAM File!", vbCritical + vbApplicationModal, "Critical File Load Error!"
            Close #FileHandle
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMLoadFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select

    'Set the screen cursor to the defualt
    Screen.MousePointer = 0
End Sub

Public Function GetRAMFileInfo(ByVal RamFile As String) As String
    Dim FileHandle As Integer
    Dim Description As String
    Dim Dscr As String
    Dim FileRevNum As Integer
    Dim FileType As String
    Dim dummystr As String
    
    'Get a sharable file handle
    FileHandle = FreeFile(1)
    
    If RamFile <> "" Then
        If FileExists(RamFile) Then
            'Get the RAM file name
'            RamFile = File1.Path & "\" & File1.filename
            
            'Open the file
            Open RamFile For Input As #FileHandle
            
            'Read the file header back
            Input #FileHandle, FileType, FileRevNum
            'Make sure its a valid file
            If FileType = "AD9859 RAM Configuration File" Then
                'Trash the next 4 lines
                Input #FileHandle, dummystr
                Input #FileHandle, Dscr, Description
                GetRAMFileInfo = Description
            Else
                GetRAMFileInfo = "Not available!"
            End If
        Else
            GetRAMFileInfo = "No File Specified!"
        End If
    Else
        GetRAMFileInfo = "No File Specified!"
    End If
End Function

'Newer more inteligent ram dump routine
Public Sub SaveRAM2File(ByVal DUTNum As Integer, ByVal RamFile As String, ByVal sFileDescrptn As String)
    
    Dim FileHandle As Integer
    Dim dummystr As String
    Dim cntr As Integer
    Dim cntr1 As Integer
    Dim TmpProfile_DUT1 As Integer
    Dim TmpProfile_DUT2 As Integer
    Dim Packets2DownLoad As Integer

    Dim SelRamSeg As Integer
    Dim RamSegCW(0 To 3) As RSCWInfo

    Dim RamSegment0Data() As String
    Dim RamSegment1Data() As String
    Dim RamSegment2Data() As String
    Dim RamSegment3Data() As String

    Dim UseRs(0 To 3) As Boolean

    Dim UBndRSData As Integer

    Dim RSCntrStart As Integer
    Dim RSCntrStop As Integer
    Dim RSCntrStep As Integer

    Dim RAMSegAddrs(0 To 3) As Integer

    'Setup an error handler
    On Error GoTo ErrorHandler:

    RAMSegAddrs(0) = &H7
    RAMSegAddrs(1) = &H8
    RAMSegAddrs(2) = &H9
    RAMSegAddrs(3) = &HA

    'If reading from both DUTs then your about to get a nasty message, because your trying to do something that is not possible
    If (DUTNum <> 1 And DUTNum <> 2) Then
        'LSBFirst mode must be the same on both DUTs
        MsgBox "Error: You can only read from 1 DUT at a time.", vbApplicationModal, "Error: SUB RAMDumpFile()"
    Else
        'Get the active profiles
        TmpProfile_DUT1 = EvalBd.GetActiveProfile(DUTNum)

        'Get a sharable file handle
        FileHandle = FreeFile(1)

'**************** Ram Readback Start ****************
        For SelRamSeg = 0 To 3

            'Set to profile 1 to read back RSCW0
            EvalBd.SetActiveProfile DUTNum, SelRamSeg + 1
'            Delay

            'Read the data from the DUT to write the file.
            dummystr = EvalBd.SerialRead(DUTNum, RAMSegAddrs(SelRamSeg))

            'Decode the nonlogical data arangement of the RSCW Registers
            With RamSegCW(SelRamSeg)
                DecodeRSCW dummystr, .BeginAddr, .FinalAddr, .AddressRampRate, .ModeControl, .NoDwell

                'Read back the RAM Segment Data
                If .FinalAddr = .BeginAddr Then
                    Packets2DownLoad = 1
                Else
                    Packets2DownLoad = .FinalAddr - .BeginAddr + 1
                End If
                                
                'Check to see if the user has set up the ram segment control words properly
                If .BeginAddr > .FinalAddr Then
                    MsgBox "An error was found in RAM Segment Control Word #" & SelRamSeg & "." & vbCrLf & vbCrLf & "The beginning address cannot be greater than the final address.", vbCritical + vbApplicationModal, "Failed saving RAM to a file!"
                    Exit Sub
                End If
            End With

            Select Case SelRamSeg
                Case 0:
                    'Resize the RAM Segment Data buffer
                    ReDim RamSegment0Data(0 To Packets2DownLoad - 1)
                Case 1:
                    'Resize the RAM Segment Data buffer
                    ReDim RamSegment1Data(0 To Packets2DownLoad - 1)
                Case 2:
                    'Resize the RAM Segment Data buffer
                    ReDim RamSegment2Data(0 To Packets2DownLoad - 1)
                Case 3:
                    'Resize the RAM Segment Data buffer
                    ReDim RamSegment3Data(0 To Packets2DownLoad - 1)
            End Select

            'Setup the status bar
            With frmRAMLoadStatus
                .lblMsg.Caption = "Reading Ram Segment " & SelRamSeg
                .pbrProgress.Min = 1
                .pbrProgress.Max = Packets2DownLoad + 1
                .pbrProgress.value = .pbrProgress.Min
                .Refresh
            End With
            
            'Get the data from the DUT
            If EvalBd.RAMInitDownload(DUTNum) Then
                'Download the ram data
                For cntr = 1 To Packets2DownLoad
                    Select Case SelRamSeg
                        Case 0:
                            RamSegment0Data(cntr - 1) = EvalBd.RAMReadPacket(DUTNum)
                        Case 1:
                            RamSegment1Data(cntr - 1) = EvalBd.RAMReadPacket(DUTNum)
                        Case 2:
                            RamSegment2Data(cntr - 1) = EvalBd.RAMReadPacket(DUTNum)
                        Case 3:
                            RamSegment3Data(cntr - 1) = EvalBd.RAMReadPacket(DUTNum)
                    End Select
                    
                    'Update the status bar
                    frmRAMLoadStatus.pbrProgress.value = cntr
                    frmRAMLoadStatus.pbrProgress.Refresh
                Next cntr
                
                'Terminate the memory dump
                EvalBd.RAMTerminateDownload DUTNum
                
                'Update the status bar
                frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
                frmRAMLoadStatus.pbrProgress.Refresh
            Else
                'RAM Segment 1 Download failed
                MsgBox "Specifiy one DUT only.  RAM Readback failed", vbApplicationModal + vbCritical, "Error: RAMDumpFile"
                Exit Sub
            End If

        Next SelRamSeg
'**************** Ram Readback Finished ****************

'********* Now Start Writing the data to the file ********************
        'Open the file
        Open RamFile For Output As #FileHandle

        'Write the file header back
        Write #FileHandle, "AD9859 RAM Configuration File", 1#

        'Write a spacer
        Write #FileHandle, ""
        'Write description
        Write #FileHandle, "Description", sFileDescrptn

        'First assume that we will use all of the ram segments
        UseRs(0) = True
        UseRs(1) = True
        UseRs(2) = True
        UseRs(3) = True

        'Now check each one to see if it exists in another ram segment and if so
        'mark it as unused
        For SelRamSeg = 0 To 3
            For cntr1 = 0 To 3
                'Dont even check the ram segment against it's self
                If SelRamSeg <> cntr1 And UseRs(cntr1) Then
                    'Check each Ram Segment but don't check aginst itself
                    If RamSegCW(SelRamSeg).BeginAddr >= RamSegCW(cntr1).BeginAddr Then
                        If RamSegCW(SelRamSeg).FinalAddr <= RamSegCW(cntr1).FinalAddr Then
                            'Uses the same ram segment area mark it as unused
                            UseRs(SelRamSeg) = False
                        End If
                    End If
                End If
            Next
        Next SelRamSeg

        For SelRamSeg = 0 To 3
            'Write a spacer
            Write #FileHandle, ""
            'Write BEGIN - RAM Segment 0-3
            Write #FileHandle, "BEGIN - RAM Segment " & SelRamSeg
            'Read the RSCW0 Info
            Write #FileHandle, "Mode Control", RamSegCW(SelRamSeg).ModeControl
            Write #FileHandle, "No Dwell Active", RamSegCW(SelRamSeg).NoDwell
            Write #FileHandle, "Starting Address", RamSegCW(SelRamSeg).BeginAddr
            Write #FileHandle, "Final Address", RamSegCW(SelRamSeg).FinalAddr
            Write #FileHandle, "Address Ramp Rate", RamSegCW(SelRamSeg).AddressRampRate
            'Write "END - RAM Segment 0-3"
            Write #FileHandle, "END - RAM Segment 0"
            'Write a spacer
            Write #FileHandle, ""
            'Write the data header
            Write #FileHandle, "RAM Data"
            Write #FileHandle, "Address,Data,Hex Data,Binary Data"

            Select Case SelRamSeg
                Case 0:
                    UBndRSData = UBound(RamSegment0Data)
                Case 1:
                    UBndRSData = UBound(RamSegment1Data)
                Case 2:
                    UBndRSData = UBound(RamSegment2Data)
                Case 3:
                    UBndRSData = UBound(RamSegment3Data)
            End Select

            If UseRs(SelRamSeg) Then
                'Handle LSB and MSB Mode correctly
                'In MSB mode the first data readback is the data at RSCW(FinalAddress)
                'In LSB mode the first data readback is the data at RSCW(BeginingAddress)
                If DUTNum = 2 Then
                    If LSBFirstDUT2 Then
                        RSCntrStart = 0
                        RSCntrStop = UBndRSData
                        RSCntrStep = 1
                    Else
                        RSCntrStart = UBndRSData
                        RSCntrStop = 0
                        RSCntrStep = -1
                    End If
                Else
                    If LSBFirstDUT2 Then
                        RSCntrStart = 0
                        RSCntrStop = UBndRSData
                        RSCntrStep = 1
                    Else
                        RSCntrStart = UBndRSData
                        RSCntrStop = 0
                        RSCntrStep = -1
                    End If
                End If
                
                'Setup the status bar
                With frmRAMLoadStatus
                    .lblMsg.Caption = "Writing RS" & SelRamSeg & " to File."
                    .pbrProgress.Min = 1
                    .pbrProgress.Max = 2
                    .pbrProgress.value = .pbrProgress.Min
                    .Refresh
                End With
                                
                'Start writing the real data
                cntr1 = RamSegCW(SelRamSeg).BeginAddr
                For cntr = RSCntrStart To RSCntrStop Step RSCntrStep
                    Select Case SelRamSeg
                        Case 0:
                            'Write a line into the ram segment file
                            Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment0Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment0Data(cntr)), 8), InsertChars(RamSegment0Data(cntr), " ", 8)
                        Case 1:
                            'Write a line into the ram segment file
                            Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment1Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment1Data(cntr)), 8), InsertChars(RamSegment1Data(cntr), " ", 8)
                        Case 2:
                            'Write a line into the ram segment file
                            Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment2Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment2Data(cntr)), 8), InsertChars(RamSegment2Data(cntr), " ", 8)
                        Case 3:
                            'Write a line into the ram segment file
                            Write #FileHandle, CStr(cntr1), CDbl(cbaseBinS2Dec(RamSegment3Data(cntr))), cbaseHex(cbaseBinS2Dec(RamSegment3Data(cntr)), 8), InsertChars(RamSegment3Data(cntr), " ", 8)
                    End Select
                    cntr1 = cntr1 + 1
                Next cntr
            Else
                'Write a line that specifies that the ram segment data isn't used
                Write #FileHandle, "Not Used", 0, 0, "00000000 00000000 00000000 00000000"
            End If
        Next SelRamSeg

        'Update the status bar
        frmRAMLoadStatus.pbrProgress.value = frmRAMLoadStatus.pbrProgress.Max
        frmRAMLoadStatus.pbrProgress.Refresh
        
        'Restore the origional profile settings
        EvalBd.SetActiveProfile DUTNum, TmpProfile_DUT1

        ' Close before reopening in another mode.
        Close #FileHandle
    End If
    'Exit the subroutine before going into the error handler
    Exit Sub
'Handles errors
ErrorHandler:
    Select Case Err.Number
        Case Else:
            'Display a defualt error message
            MsgBox "Subroutine: RAMDumpFile()" & vbCrLf & _
            "Error Number: " & Err.Number & vbCrLf & _
            "Description: " & Err.Description, vbCritical + vbApplicationModal, "Error Occured"
            Close #FileHandle
    End Select
End Sub


'Grays out invalid parts of the software.
'Inputs -
'DUT - DUT number, can be 1 or 2.
'ProductCode - Most significant byte read back from CFR2
Public Sub SetupGUIForProduct(ByVal DUT1ProductCode As String, ByVal DUT2ProductCode As String)
    Dim DUT As Integer
    Dim D1PId As String
    Dim D2PId As String
    
    DUT = 1
    Select Case DUT1ProductCode
        Case "00011010", "00011000" 'Or "AD9954E" 'Or "AD9954"
            'All options enabled
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = True
                .chkAutoClrFreqAccum(DUT - 1).Enabled = True
                .chkLinearSwpEnable(DUT - 1).Enabled = True
                .chkLinSwpNoDwell(DUT - 1).Enabled = True
                .fraLinSweepCtrl(DUT - 1).Enabled = True
                .chkClearFreqAccum(DUT - 1).Enabled = True
                .chkLoadSRRatFud(DUT - 1).Enabled = True
                .chkRAMEnable(DUT - 1).Enabled = True
                .chkRAMDestIsPW(DUT - 1).Enabled = True
                .fraRAMSweepControl(DUT - 1).Enabled = True
                .fraIntProfileCtrl(DUT - 1).Enabled = True
                .lstIntProfileControl(DUT - 1).Enabled = True
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = True
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = True
                .cmdEditFreq(DUT).Enabled = True
                .txtFreqDSP(DUT).Enabled = True
                .lblMHz(DUT - 1).Enabled = True
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT - 1) = True
            End With
        Case "00010100"  'Or "AD9953"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
            End With
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT).Enabled = False
                .txtFreqDSP(DUT).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
        Case "00000000" ' "AD9952" Or "00000000"
            'Setup the control window
            With frmControl
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT).Enabled = False
                .txtFreqDSP(DUT).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT - 1) = False
            End With
        Case "00000100", "00000101"   '"AD9951" Or "00000100" Or "AD9859" Or "00000101"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT).Enabled = False
                .txtFreqDSP(DUT).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT - 1) = False
            End With
        Case "00001100" '"AD80XXX" Or "00001100"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
'            With frmFrequency
'                .lblFreq1(DUT - 1).Enabled = False
'                .cmdEditFreq(DUT).Enabled = False
'                .txtFreqDSP(DUT).Enabled = False
'                .lblMHz(DUT - 1).Enabled = False
'            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT - 1) = False
            End With
    End Select
        
    DUT = 2
    Select Case DUT2ProductCode
        Case "00011010", "00011000" 'Or "AD9954E" 'Or "AD9954"
            'All options enabled
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = True
                .chkAutoClrFreqAccum(DUT - 1).Enabled = True
                .chkLinearSwpEnable(DUT - 1).Enabled = True
                .chkLinSwpNoDwell(DUT - 1).Enabled = True
                .fraLinSweepCtrl(DUT - 1).Enabled = True
                .chkClearFreqAccum(DUT - 1).Enabled = True
                .chkLoadSRRatFud(DUT - 1).Enabled = True
                .chkRAMEnable(DUT - 1).Enabled = True
                .chkRAMDestIsPW(DUT - 1).Enabled = True
                .fraRAMSweepControl(DUT - 1).Enabled = True
                .fraIntProfileCtrl(DUT - 1).Enabled = True
                .lstIntProfileControl(DUT - 1).Enabled = True
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = True
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = True
                .cmdEditFreq(DUT + 1).Enabled = True
                .txtFreqDSP(DUT + 1).Enabled = True
                .lblMHz(DUT - 1).Enabled = True
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT) = True
            End With
        Case "00010100"  'Or "AD9953"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT + 1).Enabled = False
                .txtFreqDSP(DUT + 1).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
        Case "00000000" ' "AD9952" Or "00000000"
            'Setup the control window
            With frmControl
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT + 1).Enabled = False
                .txtFreqDSP(DUT + 1).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT) = False
            End With
        Case "00000100", "00000101"  '"AD9951" Or "00000100" Or "AD9859" Or "00000101"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkAutoClrFreqAccum(DUT - 1).Enabled = False
                .chkLinearSwpEnable(DUT - 1).Enabled = False
                .chkLinSwpNoDwell(DUT - 1).Enabled = False
                .fraLinSweepCtrl(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkLoadSRRatFud(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
            With frmFrequency
                .lblFreq1(DUT - 1).Enabled = False
                .cmdEditFreq(DUT + 1).Enabled = False
                .txtFreqDSP(DUT + 1).Enabled = False
                .lblMHz(DUT - 1).Enabled = False
            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT) = False
            End With
        Case "00001100" '"AD80XXX" Or "00001100"
            'Setup the control window
            With frmControl
                .chkCompPwrDwn(DUT - 1).Enabled = False
                .chkClearFreqAccum(DUT - 1).Enabled = False
                .chkRAMEnable(DUT - 1).Enabled = False
                .chkRAMDestIsPW(DUT - 1).Enabled = False
                .fraRAMSweepControl(DUT - 1).Enabled = False
                .fraIntProfileCtrl(DUT - 1).Enabled = False
                .lstIntProfileControl(DUT - 1).Enabled = False
                .lblIntProfileCtrlInfo(DUT - 1).Enabled = False
            End With
            'Setup the frequency window
'            With frmFrequency
'                .lblFreq1(DUT - 1).Enabled = False
'                .cmdEditFreq(DUT + 1).Enabled = False
'                .txtFreqDSP(DUT + 1).Enabled = False
'                .lblMHz(DUT - 1).Enabled = False
'            End With
            'Setup the RAM config window
            With frmRAMConfig
                .sstChooseDUT.TabEnabled(DUT) = False
            End With
    End Select
    
    'If both duts are installed
    If EvalBd.DutsInstalled = 3 Then
        D1PId = GetProductString(DUT1ProductCode)
        D2PId = GetProductString(DUT2ProductCode)
        If (D1PId = "AD9859" Or D1PId = "AD9951" Or D1PId = "AD9952") And (D2PId = "AD9859" Or D2PId = "AD9951" Or D2PId = "AD9952") Then
            mdiMain.mnuWindowRAMConfig.Enabled = False
            mdiMain.tlbMainToolBar.Buttons("ramconfig").Enabled = False
        End If
    Else
        'If handle if only dut1 or dut2
        If EvalBd.DutsInstalled = 1 Then
            D1PId = GetProductString(DUT1ProductCode)
            If (D1PId = "AD9859" Or D1PId = "AD9951" Or D1PId = "AD9952") Then
                mdiMain.mnuWindowRAMConfig.Enabled = False
                mdiMain.tlbMainToolBar.Buttons("ramconfig").Enabled = False
            End If
        Else
            D2PId = GetProductString(DUT2ProductCode)
            If (D2PId = "AD9859" Or D2PId = "AD9951" Or D2PId = "AD9952") Then
                mdiMain.mnuWindowRAMConfig.Enabled = False
                mdiMain.tlbMainToolBar.Buttons("ramconfig").Enabled = False
            End If
        End If
    End If
    
    'If any dut that has the ram or linear sweep enabled is installed then enable the ramconfig window
    If GetProductString(DUT1ProductCode) = "AD9954" Or GetProductString(DUT1ProductCode) = "AD9954E" Or GetProductString(DUT1ProductCode) = "AD9953" Or GetProductString(DUT1ProductCode) = "AD80XXX" Then
        mdiMain.mnuWindowRAMConfig.Enabled = True
        mdiMain.tlbMainToolBar.Buttons("ramconfig").Enabled = True
    End If
    If GetProductString(DUT2ProductCode) = "AD9954" Or GetProductString(DUT2ProductCode) = "AD9954E" Or GetProductString(DUT2ProductCode) = "AD9953" Or GetProductString(DUT2ProductCode) = "AD80XXX" Then
        mdiMain.mnuWindowRAMConfig.Enabled = True
        mdiMain.tlbMainToolBar.Buttons("ramconfig").Enabled = True
    End If
End Sub

'Returns the product number
'Input: ProductID - This is the most significant byte returned from CFR2
Public Function GetProductString(ByVal ProductID) As String
    Select Case ProductID
        Case "00011010"
            'Evaluation Product
            GetProductString = "AD9954E"
        Case "00011000"
            'AD9954 - All Options, 14 bit DAC
            GetProductString = "AD9954"
        Case "00010100"
            'AD9953 - RAM Active, 14 bit DAC
            GetProductString = "AD9953"
        Case "00000000"
            'AD9952 - Comparator Active, 14 bit DAC
            GetProductString = "AD9952"
        Case "00000100"
            'AD9951 - No Options,14 bit DAC
            GetProductString = "AD9951"
        Case "00000101"
            'AD9859 - No Options,10 bit DAC
            GetProductString = "AD9859"
        Case "00001100"
            'AD80XXX - Linear Sweep, 14 Bit DAC
            GetProductString = "AD80XXX"
        Case Else
            'Invalid Product Code
            GetProductString = "Invalid"
    End Select
End Function
Public Function HasRAM(ByVal DUT As Integer) As Boolean
    If DUT = 0 Then
        Select Case DUT1_CFR2
            Case "00011010" 'Evaluation Product
                HasRAM = True
            Case "00011000" 'AD9954
                HasRAM = True
            Case "00010100" 'AD9953
                HasRAM = True
            Case Else
                HasRAM = False
        End Select
    Else
        Select Case DUT2_CFR2
            Case "00011010" 'Evaluation Product
                HasRAM = True
            Case "00011000" 'AD9954
                HasRAM = True
            Case "00010100" 'AD9953
                HasRAM = True
            Case Else
                HasRAM = False
        End Select
    End If
End Function
Public Function HasLinearSweep(ByVal DUT As Integer) As Boolean
    If DUT = 0 Then
        Select Case DUT1_CFR2
            Case "00011010" 'Evaluation Product
                HasLinearSweep = True
            Case "00011000" 'AD9954
                HasLinearSweep = True
            Case "00001100" 'AD80XXX
                HasLinearSweep = True
            Case Else
                HasLinearSweep = False
        End Select
    Else
        Select Case DUT2_CFR2
            Case "00011010" 'Evaluation Product
                HasLinearSweep = True
            Case "00011000" 'AD9954
                HasLinearSweep = True
            Case "00001100" 'AD80XXX
                HasLinearSweep = True
            Case Else
                HasLinearSweep = False
        End Select
    End If
End Function
Public Function HasComparator(ByVal DUT As Integer) As Boolean
    If DUT = 0 Then
        Select Case DUT1_CFR2
            Case "00011010" 'Evaluation Product
                HasComparator = True
            Case "00011000" 'AD9954
                HasComparator = True
            Case "00000000" 'AD9952
                HasComparator = True
            Case Else
                HasComparator = False
        End Select
    Else
        Select Case DUT2_CFR2
            Case "00011010" 'Evaluation Product
                HasComparator = True
            Case "00011000" 'AD9954
                HasComparator = True
            Case "00000000" 'AD9952
                HasComparator = True
            Case Else
                HasComparator = False
        End Select
    End If
End Function

'Sets the engineering mode of the software
'0 - Normal Mode
'1 - ADI full engineering mode
'2 - FA Mode
'3 - Debug Mode
Public Sub SetEngMode(ByVal Mode As Integer)
    Select Case Mode
        Case 1 'ADI full engineering mode
            AdiMode = True
            frmDebug.SetMode
            'Enable all DUT Tabs on all forms
            frmControl.sstChooseDUT.TabEnabled(1) = True
            frmControl.sstChooseDUT.TabEnabled(0) = True
            frmControl.chkLoadBothDUTs.Enabled = True
            frmFrequency.sstChooseDUT.TabEnabled(1) = True
            frmFrequency.sstChooseDUT.TabEnabled(0) = True
            frmFrequency.chkLoadBothDUTs.Enabled = True
            frmAmplitude.sstChooseDUT.TabEnabled(1) = True
            frmAmplitude.sstChooseDUT.TabEnabled(0) = True
            frmAmplitude.chkLoadBothDUTs.Enabled = True
            frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
            frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
            frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
            frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
            frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
            frmRAMConfig.sstChooseDUT.TabEnabled(0) = True
            If IsLoaded("frmReadback") Then
                frmReadback.fraReg(11).Visible = True
            End If

            'Show all of the menus
            mdiMain.mnuWindowRegMap.Visible = True
            mdiMain.mnuWindowDebug.Visible = True
            mdiMain.mnuWindowSVGARes.Visible = True
            mdiMain.mnuWindowTestReg.Visible = True
            mdiMain.mnuSpace.Visible = True

            'Unhide unneeded controls
            frmControl.chkDacPrimeDataDisable(0).Visible = True
            frmControl.chkDacPrimeDataDisable(1).Visible = True
            frmControl.chkSyncDacNMux(0).Visible = True
            frmControl.chkSyncDacNMux(1).Visible = True
        Case 2 'FA Mode
        Case 3 'Set Debug Mode
            'Enable all DUT Tabs on all forms
'            frmControl.sstChooseDUT.TabEnabled(1) = True
'            frmControl.sstChooseDUT.TabEnabled(0) = True
'            frmControl.chkLoadBothDUTs.Enabled = True
'            frmFrequency.sstChooseDUT.TabEnabled(1) = True
'            frmFrequency.sstChooseDUT.TabEnabled(0) = True
'            frmFrequency.chkLoadBothDUTs.Enabled = True
'            frmAmplitude.sstChooseDUT.TabEnabled(1) = True
'            frmAmplitude.sstChooseDUT.TabEnabled(0) = True
'            frmAmplitude.chkLoadBothDUTs.Enabled = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
'            frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
'            frmRAMConfig.sstChooseDUT.TabEnabled(0) = True

            'Show the debug menu
            mdiMain.mnuWindowDebug.Visible = True
        Case Else 'Set Normal Mode
            'Hide stuff that isn't usefull
            If IsLoaded("frmReadback") Then
                frmReadback.fraReg(11).Visible = False
            End If
            
            'Disable DUT Tabs that aren't usable
            Select Case EvalBd.DutsInstalled
                Case 0:
                    frmControl.sstChooseDUT.TabEnabled(1) = False
                    frmControl.sstChooseDUT.TabEnabled(0) = False
                    frmFrequency.sstChooseDUT.TabEnabled(1) = False
                    frmFrequency.sstChooseDUT.TabEnabled(0) = False
                    frmAmplitude.sstChooseDUT.TabEnabled(1) = False
                    frmAmplitude.sstChooseDUT.TabEnabled(0) = False
                    frmRegisterMap.sstChooseDUT.TabEnabled(1) = False
                    frmRegisterMap.sstChooseDUT.TabEnabled(0) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(3) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(2) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(1) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(0) = False
                Case 1:
                    frmControl.sstChooseDUT.TabEnabled(1) = False
                    frmControl.sstChooseDUT.TabEnabled(0) = True
                    frmFrequency.sstChooseDUT.TabEnabled(1) = False
                    frmFrequency.sstChooseDUT.TabEnabled(0) = True
                    frmAmplitude.sstChooseDUT.TabEnabled(1) = False
                    frmAmplitude.sstChooseDUT.TabEnabled(0) = True
                    frmRegisterMap.sstChooseDUT.TabEnabled(1) = False
                    frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(3) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(2) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(0) = True
                Case 2:
                    frmControl.sstChooseDUT.TabEnabled(0) = False
                    frmControl.sstChooseDUT.TabEnabled(1) = True
                    frmFrequency.sstChooseDUT.TabEnabled(0) = False
                    frmFrequency.sstChooseDUT.TabEnabled(1) = True
                    frmAmplitude.sstChooseDUT.TabEnabled(0) = False
                    frmAmplitude.sstChooseDUT.TabEnabled(1) = True
                    frmRegisterMap.sstChooseDUT.TabEnabled(0) = False
                    frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(1) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(0) = False
                    frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
                Case 3:
                    frmControl.sstChooseDUT.TabEnabled(1) = True
                    frmControl.sstChooseDUT.TabEnabled(0) = True
                    frmControl.chkLoadBothDUTs.Enabled = True
                    frmFrequency.sstChooseDUT.TabEnabled(1) = True
                    frmFrequency.sstChooseDUT.TabEnabled(0) = True
                    frmFrequency.chkLoadBothDUTs.Enabled = True
                    frmAmplitude.sstChooseDUT.TabEnabled(1) = True
                    frmAmplitude.sstChooseDUT.TabEnabled(0) = True
                    frmAmplitude.chkLoadBothDUTs.Enabled = True
                    frmRegisterMap.sstChooseDUT.TabEnabled(1) = True
                    frmRegisterMap.sstChooseDUT.TabEnabled(0) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(3) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(2) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(1) = True
                    frmRAMConfig.sstChooseDUT.TabEnabled(0) = True
            End Select
            
            'If the debug window is visible then unload the debug form
            If IsLoaded("frmDebug") Then
                If frmDebug.Visible Then
                    Unload frmDebug
                End If
            End If
            
            'Setup the debug window
            AdiMode = False
            
            'Hide the unneeded menus
            mdiMain.mnuWindowRegMap.Visible = False
            mdiMain.mnuWindowDebug.Visible = False
            mdiMain.mnuWindowSVGARes.Visible = False
            mdiMain.mnuSpace.Visible = False
            mdiMain.mnuWindowTestReg.Visible = False
            
            'Hide unneeded controls
            frmControl.chkDacPrimeDataDisable(0).Visible = False
            frmControl.chkDacPrimeDataDisable(1).Visible = False
            frmControl.chkSyncDacNMux(0).Visible = False
            frmControl.chkSyncDacNMux(1).Visible = False
            
    End Select
End Sub

Public Sub SaveSetup(ByVal FilePath As String)
    Dim FileHandle As Integer 'Handle to the file opened
    Dim cntr As Integer
    Dim DUTCntr As Integer
    Dim RegNames(0 To 10) As String
    
    RegNames(0) = "CFR1"
    RegNames(1) = "CFR2"
    RegNames(2) = "ASF"
    RegNames(3) = "ARR"
    RegNames(4) = "FTW0"
    RegNames(5) = "POW0"
    RegNames(6) = "FTW1"
    RegNames(7) = "RSCW0"
    RegNames(8) = "RSCW1"
    RegNames(9) = "RSCW2"
    RegNames(10) = "RSCW3"
    
    'Setup an errorhandler
    On Error GoTo FileError
    
    'Show the RAM Loading Status Window
    frmRAMLoadStatus.lblMsg.Caption = "Saving DUT Settings"
    frmRAMLoadStatus.Show
    MakeTopMost frmRAMLoadStatus, True
    frmRAMLoadStatus.Refresh
    
    'Setup the status bar
    With frmRAMLoadStatus
        .pbrProgress.Min = 1
        .pbrProgress.Max = 11
        .pbrProgress.value = .pbrProgress.Min
        .Refresh
    End With
    
    'Get a file handle
    FileHandle = FreeFile(1)
    
    'Open the file
    Open FilePath For Output As #FileHandle
    
    'Write the Header
    Write #FileHandle, "AD9859 - AD9951,2,3,4 Eval Software Settings File", 1#
    Write #FileHandle, ""
    
    For DUTCntr = 0 To 1
        Write #FileHandle, "DUT" & DUTCntr + 1 & " Settings"
        
        'Store any non register related info
        With frmControl
            'Store the external frequency
            Write #FileHandle, "External Frequency", .txtRefClk(DUTCntr).Text
            If DUTCntr = 1 Then
                Write #FileHandle, "Use DUT1's RefClk", .chkUseDUT1sRefCLK.value
            End If
            'Store the Currently selected profile
            Write #FileHandle, "Profile DUT", EvalBd.GetActiveProfile(DUTCntr + 1)
            If DUTCntr = 0 Then
                Write #FileHandle, "OSK Pin", EvalBd.OSK_DUT1
                Write #FileHandle, "Clock Mode Select", EvalBd.ClkMdSel_DUT1
            Else
                Write #FileHandle, "OSK Pin", EvalBd.OSK_DUT2
                Write #FileHandle, "Clock Mode Select", EvalBd.ClkMdSel_DUT2
            End If
        End With
        
        'Store the register map
        Write #FileHandle, "Register Map for DUT" & DUTCntr
        For cntr = 0 To &HA
            Write #FileHandle, RegNames(cntr), EvalBd.SerialRead(DUTCntr + 1, cntr)
            'Update the status window
            frmRAMLoadStatus.pbrProgress.value = cntr + 1
        Next cntr
    Next DUTCntr
    
    'Close file before exiting
    Close #FileHandle

    'Hide and Unload  the RAM Loading Status Window
    MakeTopMost frmRAMLoadStatus, False
    frmRAMLoadStatus.Hide
    Unload frmRAMLoadStatus
        
    'Exit the subroutine before the error handler
    Exit Sub
    
'Define error handler
FileError:
    'Display an error message
    MsgBox "Error: " & Err.Number & vbCrLf & Err.Description, vbApplicationModal + vbCritical + vbOKOnly, "File Error:"
    Close #FileHandle
    
    'Hide and Unload  the RAM Loading Status Window
    MakeTopMost frmRAMLoadStatus, False
    frmRAMLoadStatus.Hide
    Unload frmRAMLoadStatus
        
End Sub


Public Sub LoadSetup(ByVal FilePath As String)
    Dim FileHandle As Integer 'Handle to the file opened
    Dim cntr As Integer
    Dim sDummyString As String
    Dim vValue As Variant
    Dim ActForm As Form
    Dim ActControl As Control
    
    Dim FileType As String
    Dim FileRevNum As Double
    
    Dim iprofile As Integer
    Dim lngSPMode As Long
    
    Dim DUTCntr As Integer
    
    'Update the status bar and mouse pointer while setting are loading
    Screen.MousePointer = 11
    
    'Show the RAM Loading Status Window
    frmRAMLoadStatus.lblMsg.Caption = "Loading DUT Settings"
    frmRAMLoadStatus.Show
    MakeTopMost frmRAMLoadStatus, True
    frmRAMLoadStatus.Refresh
    
    'Setup the status bar
    With frmRAMLoadStatus
        .pbrProgress.Min = 1
        .pbrProgress.Max = 11
        .pbrProgress.value = .pbrProgress.Min
        .Refresh
    End With
    
    'Turn autofud off
    EvalBd.AutoFUD_DUT1 = False
    EvalBd.AutoFUD_DUT2 = False
    
    'Setup the errorhandler
    On Error GoTo LoadFileError
    
    'Get a file handle
    FileHandle = FreeFile
    
    'Open the file
    Open FilePath For Input As #FileHandle
    
    'Readback the first line which is the header
    Input #FileHandle, FileType, FileRevNum
    
    'Get blank line
    Input #FileHandle, sDummyString
    
    'Check the file version
    If FileType = "AD9859 - AD9951,2,3,4 Eval Software Settings File" Then
        For DUTCntr = 0 To 1
            'Get blank line
            Input #FileHandle, sDummyString
            'Get the control windows settings
            With frmControl
                'Get the reference clock value
                Input #FileHandle, sDummyString, vValue
                .txtRefClk(DUTCntr).Text = vValue
                .txtRefClk_KeyPress DUTCntr, 13
                If DUTCntr = 1 Then
                    'Get the reference clock value
                    Input #FileHandle, sDummyString, vValue
                    .chkUseDUT1sRefCLK.value = vValue
                End If
                'Get the profile to select
                Input #FileHandle, sDummyString, iprofile
                
                If DUTCntr = 0 Then
                    'Get the OSK Pin Value
                    Input #FileHandle, sDummyString, vValue
                    EvalBd.OSK_DUT1 = vValue
                    EvalBd.WriteEvbBuffVal evb59Buff1
                    'Get the Clock Mode Select Pin Value
                    Input #FileHandle, sDummyString, vValue
                    EvalBd.ClkMdSel_DUT1 = vValue
                    EvalBd.WriteEvbBuffVal evb59Buff2
                Else
                    'Get the OSK Pin Value
                    Input #FileHandle, sDummyString, vValue
                    EvalBd.OSK_DUT2 = vValue
                    EvalBd.WriteEvbBuffVal evb59Buff1
                    'Get the Clock Mode Select Pin Value
                    Input #FileHandle, sDummyString, vValue
                    EvalBd.ClkMdSel_DUT2 = vValue
                    EvalBd.WriteEvbBuffVal evb59Buff2
                End If
                'Get one line
                Input #FileHandle, sDummyString
            End With
            
            With EvalBd
                'Loop through all of the registers in the register map
                For cntr = 0 To &HA
                    Input #FileHandle, sDummyString, vValue
                    .sSetNewRegMapVal DUTCntr + 1, cntr, vValue
                    .sSetRegMapVal DUTCntr + 1, cntr, vValue
                Next cntr
                
                'Loop through all of the registers and load each
                For cntr = 1 To &HA
                    .SerialLoad DUTCntr + 1, cntr, .sGetNewRegMapVal(DUTCntr + 1, cntr)
'                    If cntr = 0 Then
'                '        'Send a FUD
'                        EvalBd.FUD_DUT1 = abvHigh
'                        EvalBd.FUD_DUT2 = abvHigh
'                        EvalBd.WriteEvbBuffVal evb59Buff1
'                        EvalBd.FUD_DUT1 = abvLow
'                        EvalBd.FUD_DUT2 = abvLow
'                        EvalBd.WriteEvbBuffVal evb59Buff1
'                    End If
                        
                    'Update the status window
                    frmRAMLoadStatus.pbrProgress.value = cntr + 1
                Next cntr
                .SerialLoad DUTCntr + 1, 0, .sGetNewRegMapVal(DUTCntr + 1, 0)
           End With
            
            'Set the profile that was saved
            EvalBd.SetActiveProfile DUTCntr + 1, iprofile
        
        Next DUTCntr
        
        'Refresh the forms
        frmControl.RefreshControls
        frmIOInterface.RefreshControls
        frmFrequency.RefreshControls
        frmAmplitude.RefreshControls
        frmRAMConfig.RefreshControls
            
'        'Send a FUD
        EvalBd.FUD_DUT1 = abvHigh
        EvalBd.FUD_DUT2 = abvHigh
        EvalBd.WriteEvbBuffVal evb59Buff1
        EvalBd.FUD_DUT1 = abvLow
        EvalBd.FUD_DUT2 = abvLow
        EvalBd.WriteEvbBuffVal evb59Buff1
        
'        EvalBoard.FUD = abvLow
'
        'Turn autofud back on
        EvalBd.AutoFUD_DUT1 = True
        EvalBd.AutoFUD_DUT2 = True
        
        'Hide and Unload  the RAM Loading Status Window
        MakeTopMost frmRAMLoadStatus, False
        frmRAMLoadStatus.Hide
        Unload frmRAMLoadStatus
        
        'Update the status bar and mouse pointer back to normal
'        mdiMain.StatusText = ""
        Screen.MousePointer = 0
    Else
        'Show setup file error
        MsgBox "Invalid setup file!", vbApplicationModal + vbExclamation + vbOKOnly, "Error Loading Setup File!"
    End If
    
    'Close file before exiting
    Close #FileHandle

    'Exit the subroutine before errorhandler
    Exit Sub

'Define the error handler
LoadFileError:
    
    'Display an error message
    MsgBox "Error Number: " & Err.Number & vbCrLf & Err.Description, vbApplicationModal + vbCritical + vbOKOnly, "Load File Error"
    
    'Close file before exiting
    Close #FileHandle

    'Hide and Unload  the RAM Loading Status Window
    MakeTopMost frmRAMLoadStatus, False
    frmRAMLoadStatus.Hide
    Unload frmRAMLoadStatus
End Sub

'Attempts to detect the evalboard on one of the LPT ports
'Returns
'INodd - Number of DUTs detected
'ILPTPort - LPT Number that the evalboard was detected on, if -1 is returned then
'           the evalboard wasn't detected. *Note* it is possible to detect a DUT but no evalboard.
Public Sub FindEvBoard(iNodd As Integer, iLPTPort As Integer, ByVal ShowStatusForm As Boolean)
    Dim cntr As Integer
    Dim bEvbdd As Boolean
    
    'Set the return value to -1 just incase nothing is found
    iLPTPort = -1
    
    If ShowStatusForm Then
        'Load status form
        frmDetectEvalBD.Show
        'Clear the text box
        frmDetectEvalBD.txtStatus.Text = ""
    End If
    
    'Try and detect a DUT on each LPT port connected to the
    For cntr = 0 To frmLPTSelect.LPTGetPortCount() - 1
        'Only update the status window if wanted
        If ShowStatusForm Then
            'Update the status window
            frmDetectEvalBD.AddStatLineSeg "  Checking LPT" & cntr + 1 & ".....", False
            Delay 0.5
        End If
        
        'Select the LPT port to test
        frmLPTSelect.LPTSelectPort cntr
        'Sync up the PC and Eval Board
        EvalBd.InitEvalBoard
        'Try to Detect the DUTs
        iNodd = EvalBd.DetectDUTs
        bEvbdd = EvalBd.DetectEvalBoard
        If iNodd Or bEvbdd Then
            bEvbdd = True
            'Only update the status window if wanted
            If ShowStatusForm Then
                'Eval board found
                frmDetectEvalBD.AddStatLineSeg ".....Found", True
                Delay 0.25
            End If
            'Return the
            iLPTPort = cntr + 1
            Exit For
        Else
            'Only update the status window if wanted
            If ShowStatusForm Then
                'Eval board not found
                frmDetectEvalBD.AddStatLineSeg ".....Not Found", True
                Delay 0.25
            End If
        End If
    Next cntr
    If ShowStatusForm Then
        Delay 1
        'Unload the status form
        frmDetectEvalBD.Hide
        Unload frmDetectEvalBD
    End If
End Sub
